/* hyperget.c         Thu 02-02-1995
Fri 06-04-1993  creation from jgwget.c.
Thu 02-02-1995  Introduced ez-use wcongets() q.v. Made insert default.

requires JGOVIDEO.OBJ:whatadaptor()  // does not.... in Linux...
*/

#include <stdio.h>

#ifdef MSWINDOWS
#include <conio.h>
#include <dir.h>
#include <dos.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "hyperx.h"

#define YES (1)
#define NO (0)

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


#ifndef BYTE
  #define BYTE char
#endif

#ifndef sBYTE
  #define sBYTE signed char
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)

#define nBIT(x) (1 << x)                          /*  */
#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define LOW(x) ((x) & 255)
#define HIGH(x) ((x) >> 8)

#define LOCALK enum       /* that's what I learned in c--. LOCALK { bingo=1 }
                          etc. */

#include "winkey.h"

#define cUP (24)          /* a little up arrow. */
#define cDOWN (25)

#define CTLQOK YES           /* the fabulous ^Q */

#define ALWAYSWEIRD YES

#define ABORT_CK defined(__FLAT__)
/* try and detect key press so I don't keep showing those spaces over and
over again.*/

#define TESTALONE NO      /* standalone test. */
/****************************************************************************
****************************************************************************/
/**************************************************/
#if !__FLAT__
extern unsigned int whatadaptor();  /* in jgwvideo.asm. */

extern int _video;      /* some kind of harmless junk in Borland video land. ?*/

#define BORLAND_MAX_ROW (((unsigned char *) &_video)[3])
/* 0-based max row? */

#define BORLAND_N_ROWS (((unsigned char *) &_video)[7])
/* Borland 1-based number of rows? */

void fixscreensize(void) {
  BORLAND_MAX_ROW=
  (whatadaptor() >> 8);     /* returns 0-based max row in ah. */
  BORLAND_N_ROWS=
  BORLAND_MAX_ROW+1;
}

void fixvga(void) {
  static int fixed;
  if (fixed) return;
  fixed=YES;
  fixscreensize();
}

#endif

/****************************************************************************
****************************************************************************/

#if CHECK_CTLA
int Gwas_ctla;
#endif

/****************************************************************************
****************************************************************************/
#if ABORT_CK
_f void cmult(int c, int count) {
  while (
  (count-- > 0) && (!kbhit())
  )
  x_putch(c);
}
#else
_f void cmult(int c, int count) {
  while (count-- > 0)
  x_putch(c);
}
#endif

/****************************************************************************
****************************************************************************/
#if __FLAT__
#define keypressed kbhit
#define keyheadtail() /* */

#ifdef MSWINDOWS
int bioscharacter(void) {
  int c;

  c=x_getch();

  if (!c) {
    c=x_getch() * 256;
    return c;
/****************************************************************************
Old protestant trick. I can just barely remember this, but when the stupid OS
returns 0, it means it's got a non-ASCII character under its belt -- i.e. it's
sending the 16-bit value as two bytes. Rock on, eh?
****************************************************************************/

  }

  if (c & 255)
  return c & 255;
}

#else
int bioscharacter(void) {
  return x_getch();
}
#endif

dumpbioscharacter() {
  while (keypressed())
  bioscharacter();
}

#else

#define pKyHEAD ( (int far *) MK_FP(0x40,0x1a))
#define pKyTAIL ( (int far *) MK_FP(0x40,0x1c))
#define pKySTART ( (int far *) MK_FP(0x40,0x1e))
#define KyWHAT (*((int far *)MK_FP(0x40,*pKyHEAD)))

#define keyheadtail()  ( * (pKyHEAD) != * (pKyTAIL) )

#define keypressed kbhit


int bioscharacter(void) {
  int c;
  c=bioskey(0);
  if (c & 255) c &= 255;
  return c;
}

dumpbioscharacter() {
  while (keypressed())
  bioskey(0);
}

/* get a string into b. Clears n-1 space on screen first.
   However, adjusts n to fit in window, if window.
  Returns
  0:  normal.
  else: some special character: ESCKEY, HELPKEY.
        string terminated at then.
  ^HOME: clears buffer.
  Returns CR if buffer is empty.
  returns cursor to original position.
  Sets-up with any string that is currently there.
*/

#endif

/****************************************************************************
****************************************************************************/


/* == wwwgets, except uses customizable cputs() routine known as cputs. This
is so you can show your odd control characters as highlighted. */

int winsert=WINSERT;

/* returns NZ if string is empty and style wants arrows returned. */
int emptyarrows(char *b, int index, int style) {
  return (!index) && (!*b) && (style & stylARROWS);
}

#define MAXSTART (70) /* if it's bigger, it crlf. */
#define MAXRIGHT (79)

int w4gets(char *b, int width, int upper, int style,
int *insert, int *index, int achar, int trailcharacter,
int (*xcputs)(), int (*xputch)(), int weirdchars) {
  int i, t, c,x,y,
#if 0
  ctype,
#endif
  iinsert,
  done=NO, redis=YES, dosqueak=NO, start=YES, n;
#if CHECK_CTLA
  Gwas_ctla = NO;
#endif
#if !__FLAT__
  fixvga();
#endif
  --width;              /* leave room for terminator. */
  if (wherex()>MAXSTART)
  xcputs("\r\n");
  if (width > (n=MAXRIGHT-wherex()))
  width=n;
  y=wherey();
  x=wherex();
  iinsert=(*insert & WINSERT);
  b[width]='\0';        /* just in case. */
  if (*index > (t=strlen(b))) *index=t;
#if ALWAYSWEIRD
  weirdchars=YES;
#endif

  while(!done) {
    if ((style & stylEXIT)
    && (*index >= width) ) {
      c=0;
      done=YES;
      continue;
    }

    if (redis) {
#ifndef MSWINDOWS
      redisplay();
#endif
      redis=NO;
      gotoxy(x,y);
/*    cputs(b);             /* put in the current string. */
      (*xcputs)(b);
      if (trailcharacter)
      xputch(trailcharacter);
      cmult(' ',width-strlen(b));
    }
    if (dosqueak) {
      dosqueak=NO;
      dumpbioscharacter();
      xputch(7);
    }
    gotoxy(x+*index,y);
    if (achar) {
      c=achar;
      if (weirdchars) goto DODEFAULT;   /* hmmmm. */
    }
    else {
      c=bioscharacter();
    }
    switch (c) {

#if CHECK_CTLA
      case 'A'-CTL:
      Gwas_ctla = YES;
      break;
#endif

      case CR:
      case LF:
      case 'Z'-CTL:

      if ( (*insert & CR0OK) && (strlen(b))) c=0;
      else
      if (!*index)
      c=CR;     /* nada. */
      else c=0;
      done=YES;
      break;

      case 'S'-CTL:
      case LEFTARROW:
      if (*index) -- (*index);
      else
      if (emptyarrows(b,*index,style))
      done=YES;
      break;

      case 'D'-CTL:
      case RIGHTARROW:
      if (emptyarrows(b,*index,style))
      done=YES;
      else
      if (*index < strlen(b)) ++(*index);
      break;

      case BS:
      if (!*index) break;
      --*index;
      /* fall thru to DEL. */

      case 'G'-CTL:   /* oh a little more wordstar. */
      case DEL:
      if (b[*index]) {
        redis=YES;
        t=strlen(b);
        for (i=*index; i <= t; ++i) b[i]=b[i+1];
      }
      break;

      case INS:
      case 'V'-CTL:
      if (!(*insert & WINSERTNOKEY)) {
        (iinsert ^= 1);
        redis=YES;
        break;
      }
      goto DODEFAULT;

#ifdef MSWINDOWS
      case HOME:
      if (*index) *index=0;
      else *index=strlen(b);
      break;
#else
      case HOME:
      *index = 0;
      break;
      
      case END:
      *index = strlen(b);
      break;
#endif      

      case CTLHOME:
      *index=0;
      *b=0;
      redis=YES;
      break;

#if CTLQOK
      case 'Q'-CTL:
      switch(bioscharacter()) {
        case 'S':
        case 'S'-CTL:
        *index=0;
        break;

        case 'D':
        case 'D'-CTL:
        *index=strlen(b);
        break;

        default:
        dosqueak=YES;
        break;
      }
      break;
#endif

      DODEFAULT:
      default:
/*      if ( (c==esckey) || (c==F1)) done=YES; */
      if ((c==ESC) || !(c&255)
#if 1   /* Fri 04-09-1993. c<' ' is covered below @ !achar // but I want it
        for exiting with ^X etc. */
      || (c<' ' && (!achar))
#endif
      ) done=YES;
      /* return any function or control key. */
      else if ((style & stylNOSPACES) && (c==' '));
      else if ((style & stylONLYN) && !isdigit(c));
      else if ((style & stylSIGN) && !isdigit(c) &&
      !((c=='-') && !*index));
      else if ((style & stylALPHAN) && !isalnum(c));
      else {
        if (start && !(*insert & WINOCLR) ) {
/* clear the boogie. */
          *index=0;
          *b=0;
          redis=YES;
        }

        if (!achar) {       /* allow stick-in of funny chars. */
          if ( ((c>127) && !weirdchars)
          /* Mon 04-12-1993. Allow strangeness. */
            || (c<' ')) {
            dosqueak=YES;
            break;
          }
          if (upper &&
          ((c=toupper(c)) > '_')
          && !weirdchars) {
            dosqueak=YES;
            break;
          }
        }
        if (!b[*index]) {        /* end of string. */
          if (*index < width) {
            b[(*index)++]=c;
            b[*index]='\0';
            xputch(c);
            redis |= trailcharacter;
            /* show trailing character again. */
          }
          else dosqueak=YES;
        }
        else if (iinsert) {
          if ( (t=strlen(b)) < width) {
            for (i=t; i>=*index; --i)
            b[i+1]=b[i];
            b[(*index)++]=c;
            redis=YES;
          }
          else dosqueak=YES;
        }
        else {        /* not end of string; writeover. */
          b[(*index)++]=c;
          xputch(c);
        }
      }
      break;
    }
    start=achar=0;
  }
  gotoxy(x,y);
  return c;
}

_f int wwwgets(char *b, int n, int upper, int style,
int *insert, int *index, int achar, int trailcharacter) {
  return w4gets(b,n,upper,style,insert,index,achar,trailcharacter,
  x_puts,x_putch,
  NO);
}

/****************************************************************************
****************************************************************************/
/* style gets. Fri 05-07-1993.*/
_f int wsgets(char *b, int n, int upper, int style) {
  int xinsert;
  int index=BIGINDEX;
  xinsert=winsert | WINOCLR;
  return wwwgets(b,n,upper,style,&xinsert,&index,0,0);
}

/* upper gets. Fri 05-07-1993. */
_f int wugets(char *b, int n, int upper) {
  return wsgets(b,n,upper,NO);
}

/* clears first, otherwise == wsgets. */
_f int wsgetsclr(char *b, int n, int upper, int style) {
  *b='\0';
  return wsgets(b,n,upper,style);
}

/* clears first, else == wugets. */
_f int wugetsclr(char *b, int n, int upper) {
  return wsgetsclr(b,n,upper,NO);
}


/****************************************************************************
****************************************************************************/

/* just gets. */
_f int wwgets(char *b, int n) {
  return wugets(b,n,NO);
}

/* == wwgets, but clears string. */
_f int wgets(char *b, int n) {
  *b='\0';
  return wwgets(b,n);
}

/****************************************************************************
behaves like a congets. Returns NULL if guy pressed esc whatever.
****************************************************************************/
char *wcongets(char *b, int n) {
  int result=wgets(b,n);
#ifdef MSWINDOWS
  x_puts("\r\n");
#else
  x_puts("\n");
#endif
  switch(result) {

    case CR:
    case 0:
    return b;

    case ESC:
    case 3:
#ifdef MSWINDOWS
    exit(1);
#else
    exeunt(1);
#endif

    default:
    return NULL;
  }
}


/****************************************************************************
****************************************************************************/
#if TESTALONE
main() {
  char buffo[37];
  wgets(buffo,37);
}
#endif


