{****************************************************************************
The problem is, the average list-of-paths tree file does not show the parent
child thingey easily.

The information I need to recover is like

----------------------------------------
        <-- empty
 bundle
  works
 Documents
 Documents and Settings
  All Users
   Application Data
  WinSxS
   InstallTemp
----------------------------------------
(root)
bundle
works
gregor
comp

and the annoying thing is, that *is* the information one gets when scanning
directories -- except the result *isn't sorted*. Hmmm..... Oh let's do a sorted
scan. It'll scan a short list of the directories in each directory etc.

Wed 9/25/02 5:46 pm Ok. Now there'll be a file "tree" which is like the above
*and* sorted. See add_the_children or something.

Sat 10/26/02 8:39 am. Well of course that didn't work out either. Now we're
back exactly as it was in OwenView, a file of paths, a file of pictures, and a
file of offsets to the other two.


the paths file is like:

1234567
\
\bundle
\bundle\works
\gregor
\gregor\comp
\gregor\comp\b3
\gregor\comp\brotchen
\gregor\comp\delphi16
\gregor\comp\delphi16\no
\gregor\comp\delphi16\old
\gregor\comp\five
\gregor\comp\five.sad
\gregor\comp\old
\gregor\configs
\gregor\configs\dos
\gregor\jgf
\gregor\jgxp
\gregor\jgxp\jgxp1
\gregor\ls

the picture is like (this varies as different fits take hold of me):

(root)
bundle
works
gregor
comp
b3
brotchen
delphi16
dcrjunk
didntwork
no
old
five
five.sad
old
configs
dos
jgf
jgxp
jgxp1
ls


I'm using the old oem characters. I'm actually going to paint the thing, but
this way at least I can look at it in normal dos editors. // But then I
decided to just use the text, and use a memo component.

Sat 10/26/02 8:40 am. And then after doing all that, I finally discovered the
memo component *slows down* at the bottom of the text, *just like an old
stupid CP/M text editor!* Ah the wunders the ever turning circling fate! So
now I'm going to go back to painting the thing, pretty-much, again, the way it
was in OV -- except of course there we got to do character-based stuff, which
was much easier.

****************************************************************************}

const

{$ifdef LINUX}
{$define ASCIIGraf2}
{$endif}

{$ifdef MSWINDOWS}
{$define ASCIIGraf2}
{$endif}



{$ifdef TermGRAF1}

gfntH            = '';  {   --    }

gfntHdown        = '';  {   -.    }

gfntV            = '';  {    |    }

gfntVright       = '';  {    |-   }

gfntVendright    = '';  {    |_   }

gfntBlank        = ' ';

{$define gfntSIZE1}

{$endif}

{$ifdef TermGRAF1hex}

gfntH            = #$C4;
gfntHdown        = #$BF;
gfntV            = #$B3;
gfntVright       = #$C3;
gfntVendright    = #$C0;
{$define gfntSIZE1}

{$endif}



{$ifdef TERMGraf2}

gfntH            = '';  {   --    }

gfntHdown        = ' ';  {   -.    }

gfntV            = ' ';  {    |    }

gfntVright       = '';  {    |-   }

gfntVendright    = '';  {    |_   }

gfntBlank        = '  ';

{$define gfntSiZE2}

{$endif}

{$ifdef ASCIIGraf2_Not}
gmult = 512;

{gfntH            	= '--';  {    --   }

gfntHdown        	= '. ';  {    .    }

gfntV            	= '| ';  {    |    }

gfntVright       	= '|-';  {    |-   }

gfntVendright    	= '`-';  {    |_   }

gfntBlank        	= '  ';


{wgfntH = 		ord('-')*gmult+ord('-'); }
wgfntHdown = 		ord('.')*gmult+ord(' ');
wgfntV = 		ord('|')*gmult+ord(' ');
wgfntVright = 		ord('|')*gmult+ord('-');
wgfntVendright = 	ord('`')*gmult+ord('-');
wgfntBlank = 		ord(' ')*gmult+ord(' ');

{$define gfntSIZE2}
{$endif}

{$ifdef ASCIIGraf2}
{let's try again}
{gmult = 512;}
gshift = 8;
{I don't know why I used 512 anyway.}

{gfntH            	= '--';  {    --   }

gfntHdown        	= '. ';  {    .    }

gfntV            	= '| ';  {    |    }

gfntVright       	= '|-';  {    |-   }

gfntVendright    	= '`-';  {    |_   }

gfntBlank        	= '  ';


{wgfntH = 		ord('-')shl gshift + ord('-'); }
wgfntHdown = 		ord('.')shl gshift + ord(' ');
wgfntV = 		ord('|')shl gshift + ord(' ');
wgfntVright = 		ord('|')shl gshift + ord('-');
wgfntVendright = 	ord('`')shl gshift + ord('-');
wgfntBlank = 		ord(' ')shl gshift + ord(' ');

{$define gfntSIZE2}

{$endif}


{****************************************************************************
****************************************************************************}

