{splash.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit splash;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QTypes, QMenus;

type
  Tfsplash = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    Label_WindowsWhine: TLabel;
    PopupMenu: TPopupMenu;
    Closesplash: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClosesplashClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fsplash: Tfsplash;
  issplashing : boolean;

implementation

{$R *.xfm}

procedure Tfsplash.FormCreate(Sender: TObject);
begin
{$ifdef LINUX}
  top := 0;
  left := 0;

  width := screen.width;
  height := screen.height;
{$endif}
  formstyle := fsStayOnTop;
  issplashing := true;
{$ifdef MSWINDOWS}
  with Label_WindowsWhine do begin
    visible := true;
{    left := 10;
    top := 10;  }
  end;
{$endif}
end;

{****************************************************************************
in case the program gets stuck make picture less lethal.
****************************************************************************}
procedure Tfsplash.Timer1Timer(Sender: TObject);
begin
  timer1.enabled := false; {goodbye }
  formstyle := fsnormal;
  close;
{  enabled := false;  } {that makes it *more* lethal...}
end;

procedure Tfsplash.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  issplashing := false;
end;

procedure Tfsplash.ClosesplashClick(Sender: TObject);
begin
  formstyle := fsnormal;
  close;
end;

end.
