{chitchat.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

unit chitchat;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, publics;

type
  Tchit = class(TForm)
    AbortBut: TBitBtn;
    SkipBut: TBitBtn;
    OkBut: TBitBtn;
    chat: TMemo;
    Wreck: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure AbortButClick(Sender: TObject);
    procedure SkipButClick(Sender: TObject);
    procedure OkButClick(Sender: TObject);
    procedure WreckClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    chit_result : ResultAction;
  end;

var
  chit: Tchit;


implementation

{$R *.xfm}
uses sbrs, code, fontfun;

procedure Tchit.FormCreate(Sender: TObject);
begin
  autoscroll := true;
end;

{raOK, raNFG, raABORT }

procedure Tchit.AbortButClick(Sender: TObject);
begin
  chit_result := raAbort;
end;

procedure Tchit.SkipButClick(Sender: TObject);
begin
  chit_result := raNFG;
end;

procedure Tchit.OkButClick(Sender: TObject);
begin
  chit_result := raOK;
end;

procedure Tchit.WreckClick(Sender: TObject);
begin
  if usuref('Just go ahead do it all without any further complaints?')
  then begin
    chit_result := raWRECK;
    modalresult := mrOK;
  end;
{the caller is supposed to preserve the wreck advice.}
end;

procedure Tchit.FormShow(Sender: TObject);
begin
  fixfonts(chit);
  formguard(chit);

  chit_result := raNFG;
  {In LX, "X" control remains on form on odd-numbered Tuesdays, so we default
  close without button to this, just in case.}
end;

procedure Tchit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  chat.font.color := clBlack;
  {someone might've changed it.}
end;

end.
