{cpyfiles.pas

Wed 1/15/03 7:37 pm Foolishly centralizing references to current directory
from random form1.thisfv.status.caption versus thetree.selectedpath. Now
they're all decided where FullDirName and DirName get assigned.

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}
{.$define FOCUS_FIX1}
{$define CPY_TRICKS}
{$define CHECK_YES_2}  {adopt different strategery}
{$define CHECK_YES_RENAME}
{****************************************************************************
Tue 1/16/2007 1:53 pm. Like for copy more options:

        [] Skip overwrite               1
        [] Skip newer                   2
        [] Skip "same"                  3

   and clicking anything higher in the list would click all the ones below,
   see? Thus disambiguating things a little. Quotes on "same" because we don't
   really know.

So I implemented the checkboxes but I will conditional the actual copy logic.
Note that we DON'T do it in move, because it would be ambiguous  if I skip a
move, should I nevertheless delete the source? Eh? So only copy. The idea is
actually to make it like my JCOPY program, which is strangely useful for
updating things i.e. just the new stuff.

****************************************************************************}

{****************************************************************************
shortcut keys:  onm

AbcDEfghijklMNOpqrStuvwxYz
****************************************************************************}


unit cpyfiles;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QButtons, QTypes, QComCtrls, publics, code;

type

  Tcpmvdel = class(TForm)
    CancelButton: TBitBtn;
    OkButton: TBitBtn;
    Timer1: TTimer;
    ProgFileCount: TProgressBar;
    ProgByteCount: TProgressBar;
    Image1: TImage;
    NumbersLabel: TLabel;
    DestinationEdit: TComboBox;
    DirButton: TButton;
    DontSaveCheck: TCheckBox;
    Memo_DriveInfo: TMemo;
    Button_SpaceBLR: TButton;
    EditLabel: TLabel;
    CheckBox_ErrorStop: TCheckBox;
    GroupBox_skip: TGroupBox;
    CheckBox_overwrite: TCheckBox;
    CheckBox_newer: TCheckBox;
    CheckBox_same: TCheckBox;
    Timer_warn: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelButtonClick(Sender: TObject);
    procedure DestinationEditCloseUp(Sender: TObject);
    procedure DirButtonClick(Sender: TObject);
    procedure DontSaveCheckClick(Sender: TObject);
    procedure DestinationEditKeyPress(Sender: TObject; var Key: Char);
    procedure Button_SpaceBLRClick(Sender: TObject);
    procedure DestinationEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox_overwriteClick(Sender: TObject);
    procedure Timer_warnTimer(Sender: TObject);
  private
    { Private declarations }
    osidle_wason,
    dont_cancel,
    slashallowed,
    pleasestop,
    pleaseclose : boolean;
    fname,
    DirName,  //i.e. the name of the dir WITHOUT the full path.
    FullDirName:string;

    fcount : integer;
    fmarked : boolean;

    see_tree_files: boolean;
    cpyResult : string;

    wreckon : boolean;

    curdir : string;

{$ifdef LINUX}
    same_fs,
{$endif}
    isd_panel,
    writeoverfirst,
    writeover : boolean;

{$ifdef FOCUS_FIX1}
    pleaseokfocus : boolean;
{$endif}
    check_yes: boolean;

    procedure writeoveron_off(turnon:boolean);
    procedure CopyFiles;
    procedure MoveFiles;
    procedure renamefiles;
    procedure deletefiles;
    procedure OKFocus(ifdir:boolean = false);
    procedure editFocus(select:boolean = true);
    procedure xinit;
    procedure dontsavemaybe;
    procedure dirok(abool:boolean);
    procedure fix_driveinfo;
{$ifdef LINUX}
    procedure deletecaption;
{$endif}

    procedure xOK;

    procedure killflags;

    procedure gcheckoid(begincopy:boolean);

{$ifdef FOCUS_FIX1}
    procedure focusoid;
{$endif}

    procedure fixnewdirs;
    procedure addnewdir;

    procedure fixskip;

    procedure fix_jcopy;

    procedure bewarned;
    procedure nowarning;

  public
    TheAction : fileaction;

  end;

var
  cpmvdel: Tcpmvdel;

  cpyf_didsomething : boolean;
  {should be set to true if did anything, i.e. didn't cancel. However,
  doesn't mean everything worked-out, apparently.}

  Glast_rate_per_minutes : string;

function cpyf(what:fileaction):string;
function checkbump(story:string; howmuch:integer = 1):boolean;
procedure CpyDstOff(fakealso:boolean = false);

implementation

{$R *.xfm}
uses main, sbrs, dir, files, fileutil, options, osinfo,
strutils, qt, fontfun
//, qclipbrd
{$ifdef LINUX}
, Libc
//, exec
{$endif}
{$ifdef MSWINDOWS}
, weirdo
{$endif}
,DateUtils
;

{const
BYTEPROGDIV = 128;  {divide byte progress by the amount}

procedure seeprog(turnon:boolean; {slowdown:integer;}
filecount_too:boolean = true; max:cardinal = 0);
forward;

var otherlist, badlist, newdirs:Tstringlist;

plzupdateform1 : boolean;

dststring:string;

function dstbytes:string;
var
x:int64;
begin
  result := '';

  if length(dststring)<1 then
  exit;

  x := DiskBytes(dststring);

  if (x>0) then
  result :=
  safe_format(' (%s)',[numbercommas(x)]);

end;

{****************************************************************************
I don't remember why these routine *aren't* methods of cpmvdel, but probably
something to do with circular reference.... // Friday, March 28, 2003 4:11 pm
well it's a brave new world now. They're all going to be type Gcheckback now,
so I can mix 'n' match 'em with different thingeys.

Wednesday, May 26, 2004 1:47 pm. I brutally simplified the Gcheck routine.
****************************************************************************}

const

max_prog = $800 {  $1000};

checkbump_divisor : integer = 1;

var
checkbump_gone, checkbump_max : integer;



checkbump_each,
checkbump_start : TDateTime;


allbytes : int64;

{.$define SHOW_JUNK}
function bumprate:string;
var
{$ifdef SHOW_JUNK}
bytes60,
{$endif}
seconds:int64;
begin
  seconds := secondsbetween(now{GetTime},checkbump_start);

  if seconds=0 then begin
    result := '';
    exit;
  end;

{$ifdef SHOW_JUNK}
  bytes60 := allbytes * 60;
{$endif}

  Glast_rate_per_minutes := numbercommas( (allbytes*60) div seconds);

  result :=
  safe_format(
{$ifdef SHOW_JUNK}
  ' (%d bytes; %d/%d)'+
{$endif}
  ' (%s bytes/min)',
  [
{$ifdef SHOW_JUNK}
  allbytes,bytes60,seconds,
{$endif}
//  numbercommas( (allbytes*60) div seconds)
  Glast_rate_per_minutes
  ]
  );
end;

function checkbump(story:string; howmuch:integer = 1):boolean;
var
newposition : integer;
const
slowcount : integer = 0;

{****************************************************************************
quoted things appear as themselves; but of course you have to quote the
quotes...
****************************************************************************}
HOUR_FORMAT = 'h:nn s''"''';
MINUTE_FORMAT = 'n"''"s''"''';
SECONDS_FORMAT = 's''"''';

  function showatime(starttime:TDateTime):string;
  var
  interval:Tdatetime;
  hour, minute, dummy:word;
  begin

    interval := now {gettime}-starttime;

    decodeTime(interval,hour,minute,dummy,dummy);

    if hour>0 then   //that would be trouble.

    DateTimeToString(result,HOUR_FORMAT,interval)

    else if minute>0 then
    DateTimeToString(result,MINUTE_FORMAT,interval)

    else
    DateTimeToString(result,SECONDS_FORMAT,interval);

  end;

begin
  result := false;

  if plzupdateform1 then begin
    form1.update;
    try
      cpmvdel.setfocus;
    except
      on exception do;
    end;
  end;

  plzupdateform1 := false;

  with cpmvdel do begin

    newposition :=
    ProgByteCount.position +
    (howmuch div checkbump_divisor);

    if newposition> ProgByteCount.max then
    newposition := 0;

    ProgByteCount.position := newposition;

    if checkbump_max>0 then begin
      inc(checkbump_gone,howmuch);
      inc(allbytes,howmuch);
      caption := safe_format('%s / %s%s'
      + '%s'
      ,
      [numbercommas(checkbump_gone),
      numbercommas(checkbump_max),
      dstbytes
      ,bumprate
      ]);
    end;

    if not isd_panel then begin
      if checkbump_start=checkbump_each then
      story := safe_format('%s (%s)',[story,showatime(checkbump_start)])
      else
      story := safe_format(
      '%s (%s, %s)'
      ,
      [story,
      showatime(checkbump_each),
      showatime(checkbump_start)
      ]);
    end;

    editlabel.caption := story;

    {apparently it doesn't bother updating until yield or something.}
    update;
    delphi_yield;

    if pleasestop
    then begin
      stop_mask_fix := true;
      if usuref('Give up?') then
      result := true
      else begin
        pleasestop := false; {missing until Wednesday, July 30, 2003 2:15 pm}
      end;
    end;

  end;
end;


{****************************************************************************
****************************************************************************}
procedure Tcpmvdel.bewarned;
begin
  if not Goptions.bewarned then
  exit;

  EditLabel.font.size := 10;
  EditLabel.Font.style := [fsBold];

  Timer_warn.enabled := true;


end;

procedure Tcpmvdel.nowarning;
begin
  Timer_warn.enabled := false;
  EditLabel.Font.size := 8;
  EditLabel.Font.style := [];
  EditLabel.Color := clBackGround;
end;

{****************************************************************************
****************************************************************************}
procedure fixroomleft(s,d:string; var os_sourcesize:int64);
var
overwrite:boolean;

begin
  if not Goptions.dbytes then begin
    os_SourceSize := -1;
    exit;
  end;

{$ifdef LINUX}
  overwrite :=
  ExtractFileName(s)=ExtractFileName(d);
{$endif}

{$ifdef MSWINDOWS}
  overwrite :=
  SameText(ExtractFileName(s),ExtractFileName(d));
{$endif}

  if not overwrite then
  exit;

  if FileExists_unq(d) then
  dec(os_SourceSize,os_fSize(d));
  {if it becomes 0 or less, that's ok; os_fcopy/move treat that as
  nada.}

end;



{****************************************************************************
****************************************************************************}

function copymoveafile(fv:Tfv; index:integer; xcopy:boolean;
isdir:boolean):boolean;
var
s,d:string;
r : ResultAction;
t:Tos_f;
pleaseskip : boolean;
os_SourceSize,
thefilesize:int64;
LABEL
SAY_SKIPPED;

label SKIPCHECK;  {another dangerous goto...}

  function evalr:boolean; {if true, exit.}
  begin
    result := false;    {don't give up}

    if r<>raNA then begin

      if r=ra_Same_Overwrite_OK then begin
        pleaseskip := true;
        exit;
      end;

      if r=raWRECK then begin
        cpmvdel.wreckon := true;
        exit;
      end;

      if r=raABORT then
      cpmvdel.pleasestop := true;

      if r<>raOK then
      result := true;   {give-up.}
    end;
  end;

  function FigureOutDestination(s,d:string):string;
  begin
    result := ExpandFileName(d);
    if os_fHasAttr(result,faDirectory) then begin
      result := fslash(result)+
      extractFileName(s);
    end;
  end;

{$ifdef I_Made_it_external}
  procedure fixroomleft;
  var
  overwrite:boolean;

  begin
    if not Goptions.dbytes then begin
      os_sourceSize := -1;
      exit;
    end;

{$ifdef LINUX}
    overwrite :=
    ExtractFileName(s)=ExtractFileName(d);
{$endif}

{$ifdef MSWINDOWS}
    overwrite :=
    SameText(ExtractFileName(s),ExtractFileName(d));
{$endif}

    if not overwrite then
    exit;

    if FileExists_unq(d) then
    dec(os_SourceSize,os_fSize(d));
    {if it becomes 0 or less, that's ok; os_fcopy/move treat that as
    nada.}
  end;
{$endif}

begin
  result := false;

  pleaseskip := false;

  plzupdateform1 := true;   {checkbump checks this.}

  if index<0 then begin
    errorf('copymoveafile: index<0');
    exit;
  end;

  t := Tos_f(fv.fls.objects[index]) ;

  s := fv.status.caption + t.name; // i.e. directory + name.

  d := cpmvdel.DestinationEdit.text;

  if isdir then
  d := d+t.name;

  dststring := d;

  if not FileExists_unq(s) then begin
    cpmvdel.ProgFileCount.color := clRed;
    badlist.add(safe_format('%s (doesn''t exist)',[s]));
    exit;
  end;

  thefilesize := os_fSize(s);
  os_SourceSize := thefilesize;

{********************************************************}
  if cpmvdel.wreckon then
  goto SKIPCHECK;

{$ifdef CPY_TRICKS}

  if
  FileExists(d) then
  with cpmvdel do begin
    result := true;       //to exit without error.

//note these checkboxes have priority.
    if CheckBox_overwrite.checked and
    FileExists(d) then
    goto SAY_SKIPPED;

    if
    CheckBox_newer.checked and
    (FileAge(d) >= FileAge(s))
    then
    goto SAY_SKIPPED;

    if CheckBox_same.checked and
    sameSizeTime(s,d) then
    begin
      SAY_SKIPPED:
      file_skipifmarked(fv,index);
      exit;
    end;

    result := false;      //back to failure.

//if ANY checkbox, skip other checks (?).
    if CheckBox_same.checked then
    goto SKIPCHECK;

  end;

{$endif}

  r := samefile(s,d);               {check same fileness.}

  if evalr then           {think carefully about r result.}
  exit;

  if pleaseskip then
  goto SKIPCHECK;

  if cpmvdel.wreckon then
  goto SKIPCHECK;

  r := newerOK(s,d);  {test for newerok. I used to think I should test
                      this even if wreckon, but no....}
  if evalr then
  exit;

  if cpmvdel.wreckon then
  goto SKIPCHECK;

  if r=raNA then
  r := overwriteOK(s,d);
  if evalr then
  exit;

  SKIPCHECK:
{********************************************************}

  seeprog(true,false,thefilesize);

  checkbump_max := thefilesize;

  fixroomleft(s,d,os_sourcesize);

  try
    checkbump_each := now; //GetTime;
    if checkbump_start=0 then
    checkbump_start := checkbump_each;

    if xcopy then
    result := os_fCopy(s,d,os_SourceSize)
    else
    result := os_fMove(s,d,os_SourceSize);
  except on exception do
    result := false;
  end;

  if result then begin
    file_checkifmarked(fv,index);
    if xcopy then
    file_oldnew('',FigureOutDestination(s,d))
    {ExpandFileName(d) }
    else
    file_oldnew(ExpandFileName(s),ExpandFileName(d));

  end else begin
    cpmvdel.ProgFileCount.color := clRed;
    badlist.add(s);
  end;

end;

procedure copyMoveFiles(xcopy:boolean; n:string);
var
{x,} i:integer;
t:Tos_f;
isdir:boolean;

  function parenCpyerror:string;
  begin
    if length(Glast_copy_error)>0 then
    result := safe_format(' (%s)',[Glast_copy_error])
    else
    result := '';
  end;
begin
{$ifdef Linux}
  cpmvdel.DestinationEdit.text := homeize(cpmvdel.DestinationEdit.text);
{$endif}

  cpmvdel.DestinationEdit.text :=
  fdeslash(cpmvdel.DestinationEdit.text);

  isdir := DirectoryExists(cpmvdel.DestinationEdit.text);

  if isdir then
  cpmvdel.DestinationEdit.text :=
  fslash(cpmvdel.DestinationEdit.text);

  if (cpmvdel.fcount>1) and (not isdir) then begin
    errorf('"%s" isn''t directory; won''t %s multiple files '+
    'to another file',[cpmvdel.DestinationEdit.text,n]);
    exit;
  end;

  if (not xcopy)
  and (not isdir)
  and (not DirectoryExists(ExtractFilePath(cpmvdel.DestinationEdit.Text)))
  then begin
    errorf('"%s" must include directory for %s',
    [cpmvdel.DestinationEdit.text,n]);
    exit;
  end;

  seeprog(true);

  cpmvdel.ProgFileCount.max := cpmvdel.fcount;

  i := 0;

  if cpmvdel.fmarked then
  while i<form1.thisfv.filecount do begin
    if cpmvdel.pleasestop
    then break;

    {if we get around the loop and pleasestop is true, that means user
    aborted a copy/move, in which case they should all be aborted, I
    think. Before it was putting up the abort dialogue twice, which is
    boring.}

    if cpmvdel.CheckBox_ErrorStop.checked
    and (badlist.count>0) then
    break;

    t := Tos_f(form1.thisfv.fls.objects[i]) ;

    if file_ismarked(t) then begin
      delphi_yield;
      if
      (cpmvdel.pleasestop)
      and usuref('Give up?')
      then break;
{it breaks the wrong loop anyway. // what? }

      checkbump_each := now; //GetTime;
      if copymoveafile(form1.thisfv,i,xcopy,isdir) then begin
{        cpmvdel.ProgFileCount.stepit; }
        cpmvdel.ProgFileCount.position :=
        cpmvdel.ProgFileCount.position + 1;
        cpmvdel.ProgFileCount.update;
        if xcopy then
        inc(i);     {copy doesn't remove the source, so onto the next. If I
        don't do this, it'll still be unmarked so kuel....}
      end else
      inc(i);       {i.e. didn't work.}

    end else
    inc(i);         {i.e. wasn't marked}

  end else
  copymoveafile(form1.thisfv,file_selected_index,xcopy,isdir);

  seeprog(false);

  if
//  (not cpmvdel.pleasestop) and
//it should report the error no matter if abort/cancel whatever.
  (badlist.count>0) then begin
    errorf('Couldn''t %s %s%s',[n,badlist.text,parenCpyerror]);
  end;

end;

{****************************************************************************
****************************************************************************}

procedure Tcpmvdel.FormCreate(Sender: TObject);
begin
  autoscroll := true;
  NumbersLabel.caption := NumbersLabel.caption + NumbersLabel.Caption;
  {make sure there're many numbers.}
end;

{I don't know what cpyf does.... It does the whole thing you silly! I.e. Main
form calls this guy.}
function cpyf(what:fileaction):string;
begin
  cpmvdel.cpyResult := '';
  cpmvdel.TheAction := what;
  cpmvdel.showmodal;
  result := cpmvdel.cpyResult;
  form1.fileshintoid;
  set_tricky;
end;

procedure Tcpmvdel.Timer1Timer(Sender: TObject);
begin
  timer1.enabled := false;

  if pleaseclose then
  close;

{$ifdef FOCUS_FIX1}
  if pleaseokfocus then begin
    pleaseokfocus := false;
    editfocus(true);
    OKfocus(true);
  end;
{$endif}

end;

type

f_d_behavior = (f_d_restore, f_d_save, f_d_clear, f_d_clear_all);

var
fakedst : string;

f_lastdestination:string = '';

{****************************************************************************
fakedst is a kluje used to make a created directory appear as the default
destination for copy/move -- once.
****************************************************************************}

procedure fiddle_dest(behavior:f_d_behavior);
var
found:integer;
begin
  with cpmvdel do begin

//do this no matter what, if. I was missing it for CpyDstOff stupid...
    if behavior=f_d_clear then begin
      f_lastdestination := '';
      exit;
    end;

    if behavior=f_d_clear_all then begin
      f_lastdestination := '';
      fakedst := '';
      exit;
    end;



    if (form1.thepanel=d) or
    ( (TheAction<>xcopy) and (TheAction<>xmove) ) then
    exit;

    case behavior of

      f_d_restore: begin
        if length(fakedst)>0 then begin
          f_lastdestination := fakedst;
          if otherlist.find(fakedst,found) then begin
            otherlist.delete(found);
          end;
          fakedst := '';
        end;
        if length(f_lastdestination)>0 then begin
          DestinationEdit.text := f_lastdestination;
          DestinationEdit.selectall;
        end;
      end;

      f_d_save: begin
        f_lastdestination := DestinationEdit.text;
        adduniquething(otherlist,DestinationEdit.text);
      end;

    end;
  end;
end;

procedure CpyDstOff(fakealso:boolean = false);
begin
  if fakealso then
  fiddle_dest(f_d_clear_all)
  else
  fiddle_dest(f_d_clear);
end;

{****************************************************************************
****************************************************************************}
procedure Tcpmvdel.killflags;
begin
  pleaseclose := false;
  pleasestop := false;
{$ifdef FOCUS_FIX1}
  pleaseokfocus := false;
{$endif}
  check_yes := false;

end;

{$ifdef FOCUS_FIX1}
procedure Tcpmvdel.focusoid;
begin
  pleaseokfocus := true;
  timer1.enabled := true;
end;
{$endif}

procedure Tcpmvdel.FormShow(Sender: TObject);

  procedure delete_setup;
  begin
    dontsavemaybe;
{$ifdef LINUX}
    deletecaption;
{$else}
    caption := 'delete';
{$endif}
    DestinationEdit.visible := false;
    NumbersLabel.visible := false;
    image1.visible := true;
    OKFocus;
  end;

begin
  fixfonts(cpmvdel);
  formguard(cpmvdel);

  xinit;

{$ifdef KY_CANCEL}
  cancelbutton.visible := true;
  checkbox_errorStop.visible := true;
{$endif}

  nowarning;

  dont_cancel := false;

  osidle_wason := Gidle_off; //might not have to, 'cause no focus whatever.

  checkbump_start := 0;

  allbytes := 0;

  dststring := '';
  Glast_copy_error := '';

  GroupBox_skip.visible := false;

  {crankily alter behavior}
  form1.dontchange_dir_after := true;

  writeoverfirst := true;

  Button_SpaceBLR.visible := false;
  writeoveron_off(false);

  seeprog(false);
  dirok(false);

{  infof('high(integer): %d; low(integer): %d',
  [high(integer),low(integer)]); }

{let's be a little paranoid, and require this feature to get enabled for each
usage. I think. }
  DontSaveCheck.visible := false;
  DontSaveCheck.checked := false;
  Gos_delete_dontsave := false;   {get's falsed in formclose too.}

  cpyf_didsomething := false;

  Memo_DriveInfo.visible := false;

  file_oldnew_begin;

  badlist.clear;
  badlist.sorted := false;

  curdir := fdedrive(thetree.selectedpath);

  wreckon := false;   {user hasn't requested total destruction.}
  ProgFileCount.color := clBackground;

  leftmain;

  killflags;

  editlabel.caption := '';
{  editlabel.visible := true; }

  Destinationedit.visible := true;
{  DirButton.visible := true; }
  Numberslabel.visible := true;
  image1.visible := false;

  if form1.thepanel=d then begin
    isd_panel := true;
    FullDirName := thetree.selectedpath
  end else begin
    isd_panel := false;
    FullDirName := form1.thisfv.status.caption;
  {these are *almost* always the same but let's not guess. I know that "home"
  Wed 1/15/03 7:39 pm moves the directory select even in the file panel, even
  though it probably shouldn't.}

  end;

{$ifdef LINUX}
  same_fs :=

  (TheAction=xdelete) and
  isdel_dir and
  (Gdel_id = disk_id(fdeslash(FullDirName)));

  deletecaption;

{$endif}

  DirName := xFileName(FullDirName);

  try
    chdir(FullDirName); {forgot until 8/7/02. When you edit the destination of a
    copy -- as, commonly, you want to copy an existing file to another -- you
    shouldn't have to include the full path; but it did.... // wha?}
  except on
    e: exception do begin {forgot until Wednesday, December 4, 2002 2:23 pm}
      errorf('chdir("%s") failed (rescan?); error: %s',
      [FullDirName,e.Message]);
      pleaseclose := true;
      timer1.enabled := true;
    end;
  end;

  if pleaseclose then
  exit;

  checkbox_errorStop.visible := false;

  case form1.thepanel of
    d: case TheAction of
      xcreate: begin
        fixnewdirs;   //add the newdirs list to the combo box.

        caption := 'create directory';
        editlabel.caption := safe_format('Create new directory in "%s":',[FullDirName]);
        Destinationedit.Text := 'newdir~';
        EditFocus(true);
      end;

      xrename: begin
        Button_SpaceBLR.visible := true;
        caption := 'rename directory';
        editlabel.caption :=
        safe_format('rename directory "%s" to:',[DirName]);
        Destinationedit.text := DirName;
        EditFocus(true);
      end;

      xdelete: begin
        bewarned;
        delete_setup;
        editlabel.caption := safe_format('delete directory "%s"?'
        ,[FullDirName]);
{        DestinationEdit.text := FullDirName; }
{Fri 9/19/03 12:06 pm. for some demented reason, this was different than the
file delete, giving you a pointless chance to edit the directory name.}
      end;
    else
      pleaseclose := true;
    end;


    f1,f2: begin
      fcount := file_thiscount_complain(fname,fmarked);

      if fcount<0 then begin
        pleaseclose := true;
      end;

      CheckBox_ErrorStop.visible := fcount>1;

      dirok(true); {but some file ops still don't allow it, q.v.}

      case TheAction of
        xcopy: begin
{$ifdef CHECK_YES_2}
          check_yes := true;
{$endif}
          fix_jcopy;

          caption := 'copy';

          fix_driveinfo;

{$ifdef FOCUS_FIX1}
          focusoid;
{$endif}

          if fcount>1 then begin
            editlabel.caption :=
            'Copy files to directory:';
            form1.copymovesuspects(DestinationEdit,true,otherlist);
          end else begin
            editlabel.caption := safe_format('Copy "%s" to:',[fname]);
            form1.copymovesuspects(DestinationEdit,false,otherlist);
            {oh see he's just getting the directories you might want to
            copy to.}
          end;
          editfocus(true);

        end;

        xmove: begin
          bewarned;
{$ifdef CHECK_YES_2}
          check_yes := true;
{$endif}
          fix_jcopy;
          caption := 'move';

          fix_driveinfo;

{$ifdef FOCUS_FIX1}
          focusoid;
{$endif}

          if fcount>1 then begin
            editlabel.caption :=
            'Move files to directory:';
            form1.copymovesuspects(DestinationEdit,true,otherlist);
          end else begin
            editlabel.caption := safe_format('Move "%s" to:',[fname]);
            form1.copymovesuspects(DestinationEdit,false,otherlist);
          end;
          editfocus(true);

        end;

        xrename: begin
{$ifdef CHECK_YES_2}
//          check_yes := true;
//nah never need it for rename; the default value is intentionally wrong.
{$endif}
          Button_SpaceBLR.visible := true;
          caption := 'rename';
          dirok(false);

          if fcount>1 then
          editlabel.caption :=
          'Rename files to (use *, ?):'
          else
          editlabel.caption :=
          safe_format('rename file "%s" to:',[fname]);
          DestinationEdit.text := fname;
          EditFocus(true);
        end;

        xdelete: begin
          bewarned;
          if fcount>1 then begin
            editlabel.caption :=
            safe_format('Delete %d files in %s?'
            ,
            [fcount,FullDirName]);
          end else begin
            editlabel.caption :=
            safe_format('Delete "%s"?'
            ,
            [FullDirName+fname]);
          end;

          DestinationEdit.visible := false;
          dirok(false);
          delete_setup;

        end;
      else
        pleaseclose := true;
      end;
    end;
  end;

  fiddle_dest(f_d_restore);

  timer1.enabled := true;

end;

procedure Tcpmvdel.OkButtonClick(Sender: TObject);
begin
  dont_cancel := true;
//  enabled := false;
  xOK;
//  enabled := true;
//I WANT him to be able to cancel....
//  dont_cancel := false;
end;

procedure Tcpmvdel.xOK;
var
contents:Tdir_contents;
er:string;
oldparent, oldselected, newselected : integer;
oldname, newname: string;
mkdirsuccess: boolean;
const
DIR_SLOW_COUNT = 499 {1000};
DIR_MAX = max_prog;
{there is something screwy here but I know not what. Anyway, those values
produce visible progress indicator.}
label
MRHACK;

begin

//  modalresult := mrOK;  //this makes Linux stop seeing clicks.
  case form1.thepanel of
    d: begin

      see_tree_files := true;

      case TheAction of

        xcreate: begin

          if cantdelete(OSmkdir) then {check os.ini permissions}
          goto MRHACK;
//          exit;

          mkdirsuccess := false;

          seeprog(true,false,DIR_MAX);

          try
            thisdirectory;
            mkdir(DestinationEdit.text);
            mkdirsuccess := true;
          except
            on e: exception do
            ioerrorf('mkdir error: %s',[E.Message]);
          end;

          if not mkdirsuccess then
//          exit;
          goto MRHACK;

          if DirectoryExists(DestinationEdit.text) then begin
            if
            (not Goptions.mkdirsearch) or
            (thetree.find(FullDirName+DestinationEdit.text,0,search_EXACT)<0)
            then
            thetree.new_adddir(thetree.selected,DestinationEdit.text);
            cpyResult := DestinationEdit.text;
            file_oldnew('',FullDirName+DestinationEdit.text);
            fakedst := FullDirName+DestinationEdit.text;
          end;

          osdirectory;
          addnewdir;
          cpyf_didsomething := true;
        end;

        xrename: begin

          if cantdelete(OSrendir) then
//          exit;
          goto MRHACK;

          oldselected := thetree.selected;
          oldname := thetree.getpath(oldselected);

          seeprog(true,false,DIR_MAX);
          try
            chdir('..');
            if
            {form1.parentdirectory and }
            renameFile(DirName,DestinationEdit.text) {do the operating
            system rename}
            then begin
              {now fix our tree data}
              thetree.select(oldselected);
              oldparent := thetree.parent;

              newname :=
              fslash(ExtractFilePath(fdeslash(FullDirName)))+
              DestinationEdit.text;

              thetree.new_RenameDir(thetree.selected,DestinationEdit.text);

{$ifdef IAMSTUPID}
{BUG060303a. there is a problem here. oldselected is meaningless now, because
the renaming process could re-arrange the order of things. It's amazing it
ever worked.}

              file_renamedir(oldname,thetree.getpath(oldselected));
              {fix-up the captions on the file panels.}
{$endif}

{now find-out what happened to the newly named directory, by searching for it.
We optimize this a bit by starting-off at the oldparent position. It should
always work of course. "thetree.find" is kind of cranky, in that it calls an
abort routine in main; but main will know it's not interested and all should
work out.}

              newselected :=
              thetree.find(newname,oldparent,search_EXACT);

              if newselected>=0 then begin
                thetree.select(newselected);
                file_renamedir(oldname,newname);
              end;

              {thetree.showselect;  }
              cpyf_didsomething := true;
              {thetree.showselect;}

              file_oldnew(FullDirName,newname);

            end else
            errorf('Can''t rename "%s"',[DirName]);
          except
            on e: exception do
            ioerrorf('renamefile error: %s',[E.Message]);
          end;
        end;

        xdelete: begin

          if cantdelete(OSdeletedir) then
//          exit;
          goto MRHACK;

          thetree.freeze;
{          thetree.pix.show(false); }

          try
            oldselected := thetree.selected;
            if form1.parentdirectory then begin
              contents := Tdir_contents.create;
              caption := 'describing directory';
              seeprog(true); //missing until Friday, January 21, 2005 2:39 pm.
              if dir_describe(FullDirName,false,contents)
              then begin
                if contents.rosys then begin
                  errorf(
                  'can''t delete'+LNEND+
                  '"%s"'+LNEND+'%s'+LNEND+'%s '+
                  rostring
                  +' files/dirs!',[
                  FullDirName,
                  contents.dirdat,
                  numbercommas(contents.filerosys)]
                  );
                end else begin
                  if usuref(
                  'Delete directory "%s"'+LNEND+'%s'+LNEND+'containing '+
                  '%s directories, %s files containing %s bytes?',
                  [FullDirName,contents.dirdat,
                  numbercommas(contents.dircount),
                  numbercommas(contents.filecount),
                  numbercommas(contents.filebytes)]) then begin
                    caption := 'deleting directory';
                    seeprog(true,false,
                    contents.dircount+contents.filecount+
                    cardinal(DIR_MAX));

                    thetree.select(oldselected);
                    if (not deletedir(FullDirName))
                    or (not thetree.new_deldir(oldselected)) then
                    errorf('Error deleting "%s" (rescan?)',
                    [FullDirName])
                    else
                    cpyf_didsomething := true;
                    {THE OLD COMMENT: it's not clear what it did, but it did
                    something. // Wed 5/26/04 12:42 pm. Changed my mind, at
                    least for this one; don't say we did something unless we
                    actually deleted the thing -- basically so it won't
                    skitter back to the parent directory.}

                  end;
                  file_oldnew(FullDirName,'');
                end;

                thetree.cuteselect;
              end else begin
                if contents.couldnt_find then
                er := 'couldn''t find'
                else
                er := 'unknown';
                errorf('Couldn''t figure-out directory "%s", error: %s',
                [FullDirName,er]);
              end;
              contents.free;
            end else
            errorf('Can''t delete root');
          except
            on e: exception do
            ioerrorf('rmdir error: %s',[E.Message]);
          end;
{          thetree.pix.show(true); }
          thetree.freeze(false);
        end;
      else
        pleaseclose := true;
      end;
    end;


    f1,f2: begin

      see_tree_files := false;

      case TheAction of
        xcopy: begin

          if cantdelete(OSCopyFile) then
//          exit;
          goto MRHACK;

          CopyFiles;
          cpyf_didsomething := true;
          safestuff(destinationedit.text);
        end;

        xmove: begin

          if cantdelete(OSdeletefile) then
//          exit;
          goto MRHACK;

          MoveFiles;
          cpyf_didsomething := true;
          safestuff(destinationedit.text);
        end;

        xrename: begin

          if cantdelete(OSrenamefile) then
//          exit;
          goto MRHACK;

          renamefiles;
          cpyf_didsomething := true;
        end;

        xdelete: begin

          if cantdelete(OSdeletefile) then
//          exit;
          goto MRHACK;

          deletefiles;
          cpyf_didsomething := true;

        end;
      else
        pleaseclose := true;
      end;
    end;
  end;
  MRHACK:
  modalresult := mrOK;
end;



procedure Tcpmvdel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{$ifdef NUTHIN}
  if dont_cancel then begin
    Action := canone;
    //but it doesn't actualy work. On tuesdays, or something.
    //and the dont_cancel is bad logic.
    exit;
  end;
{$endif}

  nowarning;

  fiddle_dest(f_d_save);

  form1.dontchange_dir_after := false;
  killflags;
  gcheckoid(false);
  file_oldnew_finish;
  badlist.clear;
  Gos_delete_dontsave := false;
  plzFview;
  throttle(false);    {oh why not....}

  Gidle_on(osidle_wason);

end;

procedure Tcpmvdel.CopyFiles;
begin
  copyMoveFiles(true {os_fCopy},'copy');
end;


procedure Tcpmvdel.MoveFiles;
begin
  copyMoveFiles(false {os_fMove},'move');
end;

procedure Tcpmvdel.deletefiles;
var
{x,} i:integer;
t:Tos_f;
dir:string;
slowcount : integer;
showmove : boolean;
{$ifdef LINUX}
aname : string;
os_SourceSize : integer;
{$endif}
{$ifdef RECYCLE}
recycle_w98:boolean;
{$endif}
const
Islowdown = 10;
{$ifdef LINUX}
slowdown : integer = Islowdown;
{$endif}
{$ifdef MSWINDOWS}
slowdown = Islowdown;
{$endif}

  procedure d_oldnew(dir,f_name:string);
  begin
    if showmove then
    file_oldnew(dir+f_name,
{$ifdef MSWINDOWS}
    thetree.drive + ':' +
{$endif}
    Goptions.del_dir+f_name)
    else
    file_oldnew(dir+f_name,'')
  end;

{$ifdef LINUX}
  procedure linux_lump(aname:string);
  begin
    os_SourceSize := os_fsize(aname);
    if isdel_dir then
    dststring := fdeslash(Goptions.del_dir);
    seeprog(true,false,os_SourceSize);
    checkbump_max := os_SourceSize;
    checkbump_each := now; //GetTime;
    if checkbump_start=0 then
    checkbump_start := checkbump_each;
  end;
{$endif}

begin
{$ifdef RECYCLE}
  recycle_w98 :=
  thetree.recycle and (Goptions.os=w9x)
  and (DontSaveCheck.visible)
  and (not DontSaveCheck.checked);
{$endif}
  seeprog(true);

  showmove :=
  isdel_dir and
  (DontSaveCheck.visible) and
  (not DontSaveCheck.checked);

{$ifdef LINUX}
  slowdown := Islowdown;

  if showmove and (not same_fs) then begin
    slowdown := 0;
    seeprog(true);
  end;
{$endif}

  ProgFileCount.max := fcount;

  dir := FullDirName;

  slowcount := 0;

  i := 0;
  if fmarked then
  while i<form1.thisfv.filecount do begin

    if CheckBox_ErrorStop.checked
    and (badlist.count>0) then
    break;

    t := Tos_f(form1.thisfv.fls.objects[i]) ;

    if file_ismarked(t) then begin
      inc(slowcount);

{$ifdef LINUX}
      if slowdown=0 then begin
        linux_lump(dir+t.name);
      end;
{$endif}

      if OS_Delete(dir+t.name
{$ifdef LINUX}
      ,os_SourceSize
{$endif}
      )
      then begin
        if (slowcount >= slowdown)
{$ifdef RECYCLE}
        or recycle_w98
{$endif}
        then begin
          ProgFileCount.position := ProgFileCount.position + slowcount;
  //see we add the slowcount -- before zeroing it please -- to the current
  //position, which was set above to fcount.
          slowcount := 0;
          delphi_yield;
        end;
        file_checkifmarked(form1.thisfv,i); {this is a safety check, because}
        d_oldnew(dir,t.name);
{        file_oldnew(dir+t.name,'');         {we're about to try to remove it
                                            from the files list}
      end else begin
        delphi_yield; //for errors of course; if it works, of course
                      //(doesn't in kylix)
        badlist.add(t.name);
        ProgFileCount.color := clRed;
        inc(i);     {i.e. didn't work.}
      end;

      if
      (pleasestop)
      and usuref('Give up file delete?')
      then break;

    end else
    inc(i);         {i.e. wasn't marked.}


  end else begin
{$ifdef LINUX}
    aname := dir+file_selected_name(form1.thisfv);
    if slowdown=0 then begin
      linux_lump(aname);
    end;
    if not OS_delete(aname,os_SourceSize)
{$else}
    if not OS_delete(dir+
    file_selected_name(form1.thisfv))
{$endif}
    then
    badlist.add(file_selected_name(form1.thisfv))
    else
//    file_oldnew(dir+file_selected_name(form1.thisfv),'');
    d_oldnew(dir,file_selected_name(form1.thisfv));
  end;

  seeprog(false);

  if
//  (not pleasestop) and
  (badlist.count>0) then begin
    errorf('Couldn''t delete %s',[badlist.text]);
  end;

end;

{****************************************************************************

old:  bingo.abc
mask: *.xyz
new:  bingo.xyz

old:  bingo.abc
mask: ??.xyz
new:  bi.xyz

old:  bingo.abc
mask: ??mno.xyz
new:  bimno.xyz

****************************************************************************}

procedure Tcpmvdel.renamefiles;
type

fn = record
  name, ext:string;
end;

var
mask, oldname, newname: fn;
editname,
dir:string;
i:integer;
taketake2:boolean;

nomask : boolean;

const
dontrename = false;

  {using ?* in mask, move characters from old to new.}
  function fiddlestars(mask, old:string):string;
  var
  i:integer;
  starred : boolean;
  begin
    starred  := false;
    result := '';

    if nomask then begin
      result := mask;
      exit;
    end;

{if there's a ? in the mask, then copy the old letter to the new name.}
    for i:=1 to length(old) do begin
      if es(mask,i)='*' then
      starred := true;


      if starred or (es(mask,i)='?') then
      result := result + old[i]
      else begin
        if i>length(mask)
        then exit;

        result := result + mask[i];
      end;
    end;

{what if mask is longer than old?}
    for i:= length(old)+1 to length(mask) do begin
      if es(mask,i)='*' then
      break; { starred := true; the star terminates the mask, so whatever the
      old is even if short, il est fine.}

{now the idea is, the mask might be characters to rename with. }
      if mask[i]='?' then
      break;

{but if it isn't, "rename bongo. bingo.?23 ==> bingo.?23" can't be right,}

      result := result + mask[i];
    end;

  end;

  function tryrename(old,new:string):boolean;
  begin

    if dontrename then begin
      result := false;
      osinfof('Would''ve renamed "%s" to "%s"',
      [old,new]);
      exit;
    end;

    try
{$ifdef LINUX}
{****************************************************************************
I assume Linux will let you destroy destination if you rename something to it.
****************************************************************************}
      if FileExists_unq(new) then
      raise ERenameExists.CreateFmt
      ('can''t rename "%s" to "%s"; "%s" exists',
      [old,ExtractFileName(new),ExtractFileName(new)]);
{$endif}
      result := RenameFile(old,new);
{$ifdef MSWINDOWS}
      if result then
      os_setarc(new);
{$endif}
    except
      on E: Exception do begin
        Errorf('Rename error: %s',[E.message]);
        result := false;
      end;
    end;
  end;

  procedure dedot(var s:string);
  begin
    if s='.'
    then s := '';
  end;

//returns true if success.
  function starrename(oldrut,oldext:string; i:integer = -1):boolean; overload;
  begin
    result := false; //assume failure.

    oldname.name := oldrut;
    oldname.ext  := oldext;

    taketake2 :=
    (length(oldname.ext)<1) and
    (es(mask.ext,1)='.');

    if taketake2 then
    oldname.ext := '.';
  //that should work i.e. rename bingo. bongo. should work.

    newname.name := fiddlestars(mask.name,oldname.name);
    newname.ext := fiddlestars(mask.ext, oldname.ext);


  {$ifdef MSWINDOWS}
  {In Windows, an extension of a single dot is *always* meaningless; or who
  knows. I can't rename "bingo" to "bingo." at any rate}
    dedot(oldname.ext);
    dedot(newname.ext);
  {$endif}

  {$ifdef LINUX}
  {However in wild weird Unix, *ANYTHING* is OK.}
    if not FileExists_unq(dir+oldname.name+oldname.ext) then begin
      dedot(oldname.ext);
      dedot(newname.ext);
    end;
  {$endif}

    if tryrename(
    dir+oldname.name+oldname.ext,
    dir+newname.name+newname.ext) then begin

//no point in marking this one; it's going away.
      if i>=0 then
      file_checkifmarked(form1.thisfv,i);
{****************************************************************************
the file_checkifmarked MUST occur BEFORE the file_oldnew; if it occurs
afterwards, one marks the wrong file.
****************************************************************************}

      file_oldnew(
      dir+oldname.name+oldname.ext,
      dir+newname.name+newname.ext);

      if length(cpyresult)<1 then
      cpyresult := newname.name+newname.ext;
      ProgFileCount.stepit;
      result := true;

{$ifdef MSWINDOWS}
      os_SetArc(dir+newname.name+newname.ext);
          //Thursday, August 26, 2004 4:53 pm.
{$endif}


    end else begin
      ProgFileCount.color := clRed;
      badlist.add(safe_format('"%s" to "%s"',
      [oldname.name+oldname.ext,
      newname.name+newname.ext]));
//      inc(i);     {because it didn't work; otherwise we stay here
//                  forever.}
    end;

  end;

  function starrename(i:integer):boolean; overload;
  begin
    with form1 do
    result := starrename( Tos_f(thisfv.fls.objects[i]) .nameroot,
    Tos_f(thisfv.fls.objects[i]) .ext,i);

  end;

  function starrename(nameext:string):boolean; overload;
  begin
    result :=
    starrename(extractFName(nameext),extractFileExt(nameext));
  end;

begin
  with form1 do begin

    dir := thisfv.status.caption;

    editname:= ExtractfileName(DestinationEdit.text);

    mask.name := extractFname(editname);
    mask.ext := ExtractFileExt(editname);
    nomask := notwild(editname);

    if (fcount>1) and nomask then begin
      errorf('"%s" doesn''t have any ? or *',[editname]);
      exit;
    end;

    seeprog(true);

    ProgFileCount.max := fcount;

    cpyresult := '';

    i := 0;

    if fmarked then
    while i<thisfv.filecount do begin

      if CheckBox_ErrorStop.checked
      and (badlist.count>0) then
      break;

      if file_ismarked( Tos_f(thisfv.fls.objects[i]) )
      then begin

        delphi_yield;
        if
        (pleasestop)
        and usuref('Give up file rename?') then
        break;


{****************************************************************************
****************************************************************************}
        if not starrename(i) then
        inc(i);     {because it didn't work; otherwise we stay here
                    forever.}

      end else
      inc(i);   {i.e. wasn't marked. We have to go through the *whole list*
      again and again, because the file_oldnew process puts the newly-named
      file at the end, of course.}

    end else  //a single file.
{$ifdef LINUX}
{1. In Linux you *CAN* name a file "bingo*.ext".}
    if Goptions.renamestarqmark then begin
      {but only in OS if you put"rename*?=1" in os.ini. }
      if tryRename(dir+fname,dir+editname) then begin
        cpyresult := editname;
        file_oldnew(dir+fname,dir+editname);
      end else
      badlist.add(safe_format('"%s" to "%s"',
      [fname,editname]));
    end else
{$endif}
    begin
{2. Does starrename work for just anything? // Yes apparently.}
      if starrename(fname) then begin
        cpyresult := editname;
      end else
      badlist.add(safe_format('"%s" to "%s"',
      [fname,editname]));
    end;

{    file_scanthis; }

    seeprog(false);

  end;    {with form1}

  if
//  (not pleasestop) and
  (badlist.count>0) then begin
    errorf('Couldn''t rename %s',[badlist.text]);
  end;

end;

{****************************************************************************
****************************************************************************}

{$ifdef LINUX}
procedure Tcpmvdel.deletecaption;
begin
  if TheAction<>xdelete then
  exit;

  if same_fs
  or DontSaveCheck.checked then
  caption := 'delete'
  else
  caption := 'delete (saved to different file system)';

end;
{$endif}


{****************************************************************************
****************************************************************************}
procedure Tcpmvdel.OKFocus(ifdir:boolean = false);
begin
  if ifdir and (not DirectoryExists(cpmvdel.DestinationEdit.text)) then
  exit;

  OKButton.setfocus;
end;

procedure Tcpmvdel.EditFocus(select:boolean = true);
begin
  DestinationEdit.setfocus;

//  DestinationEdit.SelStart := 0;

  if select then begin
{$ifndef CHECK_YES_2}
    check_yes := true;
{$endif}
    DestinationEdit.selectAll;
//    DestinationEdit.SelStart := 0;
  end else begin
    DestinationEdit.selLength := 0;
  end;
end;

{****************************************************************************
****************************************************************************}

procedure seeprog(turnon:boolean;
filecount_too:boolean = true; max:cardinal = 0);

begin
  stop_mask_fix := true;    //seems reasonable to do it now anyways.

  with cpmvdel do begin

//    chkb_slowdown := setslowdown;

    checkbump_max := 0;
    checkbump_gone := 0;

//    Gcheck := checkbump;
    gcheckoid(true);

  {  if max>2147483647 then }
{    if max>cardinal(high(integer)) then
    max := high(integer);    }

    OkButton.visible := not turnon;
    Memo_DriveInfo.visible := not turnon;
    DirButton.visible := not turnon;
    with DestinationEdit do
    if visible then
    enabled := not turnon;

    if turnon then begin
      editlabel.caption := '';
      editlabel.visible := true;
    end;


    if max>0 then begin

  {fix progress indicator bug? It goes whacko when too big.}
      checkbump_divisor := 1;

      while max>max_prog do begin
        checkbump_divisor := checkbump_divisor * 2;
        max := max div 2;
      end;

      ProgByteCount.max := max;

    end;

    ProgByteCount.position := 0;

    if turnon then begin
      if filecount_too then begin
{see it's important filecount only gets reset when someone's turning it on.
I.e., the individual file copy/moves also call seeprog(true..) but without
filecount_too set to true. }

        ProgFileCount.visible := true;
        ProgFileCount.position := 0;
      end;
    end else begin
      ProgFileCount.visible := false;
    end;

    ProgByteCount.visible := turnon;
    update;

  end;
end;


procedure Tcpmvdel.CancelButtonClick(Sender: TObject);
begin
  pleasestop := true;

  if dont_cancel then
  exit;

  if not Timer1.enabled then begin
    close;
  end;
  wreckon := false;
end;

procedure Tcpmvdel.xinit;
const
done : boolean = false;
begin
  if done then
  exit;

  CheckBox_ErrorStop.checked := Goptions.copy_error_stop;
  done := true;

end;



procedure Tcpmvdel.DestinationEditCloseUp(Sender: TObject);
begin
  EditFocus;
end;

procedure Tcpmvdel.DirButtonClick(Sender: TObject);
begin
  DestinationEdit.sellength := 0;
  DestinationEdit.seltext :=
  CurDir;
  DestinationEdit.setfocus;
end;

{called for deletes.}
procedure Tcpmvdel.dontsavemaybe;
begin
{$ifdef RECYCLE}
  if thetree.recycle then begin
    dontsavecheck.hint :=
    'don''t send files to the recycle bin';
    dontsavecheck.visible := true;
    exit;
  end;
{$endif}

  if isdel_dir(true)
  and (not samedir(Goptions.del_dir,FullDirName))
  then begin
    dontsavecheck.hint :=
    safe_format(
    'don''t move files to "%s" instead of deleting',
    [Goptions.del_dir]);
    dontsavecheck.visible := true;
  end;

end;


procedure Tcpmvdel.DontSaveCheckClick(Sender: TObject);
const
here : boolean = false;
label
ENDNESS;
{$ifdef RECYCLE}
var
trash_prompt : string;
{$endif}
begin

  if here then
  exit;   // left off until Friday, April 29, 2005 2:05 pm!

  here := true;

  if DontSaveCheck.checked
  and (not Goptions.dont_save_ok)
  then begin

{$ifdef LINUX}
    if (not same_fs) then
    goto ENDNESS; //don't pester him then.
{$endif}

{$ifdef RECYCLE}
    if thetree.recycle then
    trash_prompt :=
    'Really just trash the files intead of sending them to the '+
    'recycle bin?'
    else
//    if isdel_dir then
    trash_prompt := safe_format
    ('Really just trash the files instead of moving them to '+
    '"%s"?',[Goptions.del_dir])
    ;

    if
    (not
    usuref(trash_prompt)) then
    DontSaveCheck.checked := false
{$else}
    if
    (not
    usuref('Really just trash the files instead of moving them to '+
    '"%s"?',[Goptions.del_dir]))
    then
    DontSaveCheck.checked := false
{$endif}

  end;
  //else it gets unchecked and we're all happy.

  ENDNESS:
  setfocus;

  Gos_delete_dontsave := DontSaveCheck.checked;
  {it gets cleared by exit -- I hope.}

{$ifdef LINUX}
  deletecaption;
{$endif}

  here := false;

end;

procedure Tcpmvdel.dirok(abool:boolean);
begin
  slashallowed := abool;
  DirButton.visible := abool;
end;


procedure Tcpmvdel.fix_driveinfo;
var
index:integer;
const
line_character = '{{';
begin
  if length(Goptions.driveinfo)<1 then
  exit;

  while true do begin
    index := pos(line_character,Goptions.driveinfo);
    if index<1 then
    break;              {while; only way out.}

    Goptions.driveinfo :=
    copy(Goptions.driveinfo,1,index-1)+
    LNEND+
    copy(goptions.driveinfo,index+length(line_character),60000);
  end;

  with Memo_DriveInfo do begin
    text := Goptions.driveinfo;
    visible := true;
  end;

end;

{****************************************************************************
function AnsiReplaceStr(const AText, AFromText, AToText: string): string;
****************************************************************************}

procedure Tcpmvdel.Button_SpaceBLRClick(Sender: TObject);
begin
  DestinationEdit.Text := fixname(DestinationEdit.Text);

  Editfocus;
{$ifdef CHECK_YES_RENAME}
  check_yes := true;
{$endif}
end;

procedure Tcpmvdel.DestinationEditKeyPress(Sender: TObject; var Key: Char);
var
oldsel:integer;
begin

  if (not slashallowed) and (key=slashchar) then begin
    key := #0;
    errorf(slashchar + ' not allowed here');
  end;

  if writeover and (destinationEdit.sellength<1)
  then with DestinationEdit do begin
    oldsel := selstart;
    text := copy(text,1,selstart)+copy(text,selstart+2,50000);
    selstart := oldsel;
  end;

end;

procedure Tcpmvdel.writeoveron_off(turnon:boolean);
begin
  writeover := turnon;
  if writeover then begin
{ DestinationEdit.cursor := crCross }  {oh of course non-functional}
    DestinationEdit.color := clYellow; {clNormalButton} {clTeal}
    if writeoverfirst then begin
      writeoverfirst := false;
      DestinationEdit.Sellength := 0;     {after all they don't want to
    make the current stuff disappear if they're writeovering....}
      DestinationEdit.Selstart := 0;    {and they probably want to start
      at the beginning of the buffer.}
    end;
  end else
{ DestinationEdit.cursor := crDefault  }
  DestinationEdit.color := clBase
  ;

end;

{$ifdef IT_DOESNT_DO_IT_ANYWAY}
procedure combo_paste(d:TComboBox);
begin
  infof('%s',[clipboard.astext]);
  combo_selectoid(d);
  infof('%s',[clipboard.astext]);
  exit;
  d.seltext := clipboard.astext;
end;

procedure combo_copy(d:TComboBox);
begin
  combo_selectoid(d);
  if d.sellength<1 then
  clipboard.astext := d.text
  else
  clipboard.astext := d.seltext;
end;
{$endif}

procedure Tcpmvdel.DestinationEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ssAlt in Shift then begin
    key := 0;
    exit;
  end;

  if check_yes then begin
    check_yes := false;
    if (key=ord('Y')) and Goptions.stupid_yes then begin
      key := 0;
      infof('If you want to alt-Y aka OK/YES, press alt key!');
      DestinationEdit.setfocus;
      exit;
    end;
  end;

  if (key = key_Insert) then begin
    if (Shift=[])
  {  or (key = ord('V')-CTL) } {no good anyway; that's paste!}
    then begin
      writeoveron_off(not writeover);
      key := 0;
 //     exit;
    end;

    exit;

//let |^Insert copy/paste go through.

{
    if (Shift=[ssCtrl]) then
    combo_copy(DestinationEdit)
    else if (Shift=[ssShift]) then
    combo_paste(DestinationEdit)
    ;

    exit;
}

  end;

  {Oh let's do some wordstar keys, eh?....}

  if Shift<>[ssCtrl] then
  exit;

  with DestinationEdit do
  case key of
    ord('S'): begin
      SelStart := SelStart-1;
    end;
    ord('D'): begin
      SelStart := SelStart+1;
    end;
    ord('X'): begin
      ItemIndex := ItemIndex+1;
    end;
    ord ('E'): begin
      if Itemindex>0 then
      ItemIndex := ItemIndex-1;
    end;

    ord('A'): begin
//      infof('hey');
      DestinationEdit.selectAll;  //just doesn't work that's all.
//no it's me doesn't work; I was setting sellength to 0 down there.
      key := 0;
      exit;
    end;

    ord('C'), ord('V'):
    exit;   //let copy/paste junk go through.

  else
    exit;
  end;

  key := 0;
  DestinationEdit.Sellength := 0;

end;

procedure Tcpmvdel.gcheckoid(begincopy:boolean);
const
oldGcheck : Gcheckback = nil;
begin
  if begincopy then begin
    if (@Gcheck<>@checkbump) then
    oldGcheck := Gcheck;
    Gcheck := checkbump;
  end else begin
    if @oldGcheck<>nil then
    Gcheck := oldGcheck;
    oldGcheck := nil;
  end;
end;

{****************************************************************************
stuck the newdirs list into the combo thingey.
****************************************************************************}

procedure Tcpmvdel.fixnewdirs;
var
i:integer;
begin

  DestinationEdit.items.clear;

  for i := 0 to newdirs.count -1 do begin
    adduniquething(DestinationEdit.items,newdirs[i]);
  end;

end;

procedure Tcpmvdel.addnewdir;
const
maxnewdirs = 25;
begin
  adduniquething(newdirs,DestinationEdit.text);
  while newdirs.count > maxnewdirs do
  newdirs.delete(maxnewdirs);
end;

{****************************************************************************
****************************************************************************}


procedure Tcpmvdel.CheckBox_overwriteClick(Sender: TObject);
begin
  fixskip;
end;

procedure Tcpmvdel.fixskip;
const
checkboxes : array[1..3] of TCheckBox = (nil,nil,nil);
here : boolean = false;
var
i, j:integer;
begin
  if here then
  exit;

  here := true;

  if checkboxes[1]=nil then begin
    checkboxes[1] := CheckBox_overwrite;
    checkboxes[2] := CheckBox_newer;
    checkboxes[3] := CheckBox_same;
  end;

  for i := 1 to 3 do begin

    if checkboxes[i].checked then
    for j := i+1 to 3 do begin
      checkboxes[j].checked := true;
      checkboxes[j].enabled := false;
    end
    else  //unchecked
    for j := i+1 to 3 do begin
      checkboxes[j].enabled := true;
    end;

  end;

  here := false;

end;

{****************************************************************************
****************************************************************************}

procedure Tcpmvdel.fix_jcopy;
var
t, jc:JCOPY;
i,h:integer;
s:string;
LABEL
DONE;
begin

  CheckBox_overwrite.checked := false;
  CheckBox_newer.checked := false;
  CheckBox_same.checked := false;
  GroupBox_skip.visible := true;

  jc := Goptions.jcopy_setting;

  if (Goptions.jcopy_file<>'')
  and FileExists(Goptions.jcopy_file) then begin
    h := FileOpen(Goptions.jcopy_file,fmOpenRead);
    if h>=0 then begin
      while hgets(h,s) do begin
        tokenate(s);
        if (tokens<1)
        or (tokenarray[low(tokenarray)][1]=';')   //skip comments.
        then
        continue;

        for i := low(tokenarray) to high(tokenarray) do begin
          t := jcopy_string_value(tokenarray[i]);
          if t<>jcopy_NADA then begin
            jc := t;
            goto DONE;    //take the first one.
          end;
        end;
      end;
      DONE:
      fileclose(h);
    end;
  end;

  case jc of
    jcopy_OVERWRITE: CheckBox_overwrite.checked := true;
    jcopy_NEWER:     CheckBox_newer.checked := true;
    jcopy_SAME:      CheckBox_same.checked := true;
  end


end;


{****************************************************************************
****************************************************************************}



procedure Tcpmvdel.Timer_warnTimer(Sender: TObject);
begin
  if EditLabel.color=clBackground then
  EditLabel.color := clRed
  else
  EditLabel.color := clBackground;
end;

initialization

badlist := TstringList.create;
otherlist := TstringList.create;
otherlist.sorted := true; //missing until Wed 10/19/2005 1:44 pm.!
newdirs := TStringList.create;

finalization

freeAndNil(badlist);
freeAndNil(otherlist);
freeAndNil(newdirs);


end.
