{dir.pas

See the bottom of main.pas for the BSD-style license.

}

{$I osops.i}

{****************************************************************************
i STILL didn't fix it Mon 12/12/2005 1:09 pm. Writing stupid_dir_sort.
****************************************************************************}
{$define STUPIDCASEBUG_rLB}
{****************************************************************************
****************************************************************************}

{****************************************************************************
dir.pas  Fri 5/10/02 3:00 pm
Fri 5/10/02 3:00 pm creation.
Wednesday, May 22, 2002 12:46 pm Changed to dir.pas. With directory junk.
****************************************************************************}
//i think these are debugish things....
{.$define dbgP_S}
{.$define cuteP_S}


unit dir;

interface

uses sysutils, classes, QComCtrls, QExtCtrls, {options, }
{sbrs, } publics, qstdctrls, jdisplay, qgraphics, inifiles;

type

Tdir_contents = class
  dirnumber0:integer;
  dircount, filecount, filebytes, filerosys:
  int64
  ;

  rut, couldnt_find, rosys, dir_rosys : boolean;
  dirdat : string;  {'is root' if root}
end;

const

compareFunc : function(const S1, S2: string): Integer = CompareText;

rootname = 'root';

{****************************************************************************
The Tdirectory thing. This replaces the alarming TTreeView, and will consist
of a picture somewhere on the main form, and then this class.
****************************************************************************}

extINFO = 'ifo';

//extTREE= 'tre';
//hasn't been used for a year or so ! Tuesday, July 20, 2004 1:43 pm.

{the extensions for the tree filename.}
extPATHS = 'pth';

{
a file like my old OV (without the drive 'though)
\
\bundle
\bundle\works
\Documents
\Documents and Settings
\Documents and Settings\All Users

}

extPIX   = '.pix';

{Some kind of picture shorthand, to draw the thing, like

-+(root)
 +-bundle
 | +-works
 +-Documents
 +-Documents and Settings
 | +-All Users
 | | +-Application Data

Yes exactly use ASCII characters of course (what operating system just
throughtfully xlated from my OEM piccers in OV). But note that I *draw* these
things with graphics, see jdisplay.

}

extOFFSETS = '.ofs';
{For ever line of directory, a set of offsets into the above two files.}

infohead = 'info';
{miscellaneous information about the directory tree is stored in a
windows-style INI file; separate from OS.INI. At the very least since
writing to an INI file in Kylix smashes the comments.}

{****************************************************************************
The confusion of BigIMinus, sIndex and low(integer)

BigIMinus was a constant defined in sbrs.pas supposed to be the most-negative
integer, which they claim is -2147483648 and which indeed is returned by
low(integer).

sIndex is used by the Ttree subroutines as the default value for index, and
means "use select", and I defined it as BigIMinus, and tried defining
BigIMinus as -2147483648 *and* low(integer). Neither worked. I assume the
equality operator ("=") or the default mechanism was sad.

So we forget BigIminus. It is constant no more forever.

oooh so when I changed sIndex to -37, F9, it *didn't* work (one error is after
a scanit selects the root directory). But when I went recompile everything,
it "took". Oh so sad so sad.

But apparently it *should be* a *large* negative number. Like a bad person, I
actually pass select() negative numbers and let it figure it out. Oh such
sorrow. Of course it could just as well be a large positive number....

At any rate, I will pay no attention to low(integer) forever...

Wednesday, April 6, 2005 2:01 pm. So now I want to use <0 instead of sIndex.
// I gave up on that actually.

****************************************************************************}

sIndex = -2147483647;

type

Roffsets = record
  key,
  parent,above_sibling,below_sibling,
  path,
  pix:integer;
end;

Rselect = record
  plz : boolean;
  selstart,
  sellength : integer;
end;

TTreefile = class
  handle : integer;
  name : string;
  ini : boolean;    {set if it's an ini file.}
  inif:Tinifile;

  constructor Create(n:string; is_ini:boolean = false);
  destructor Destroy; override;

  {returns true if it's good.}
  function FopenR: boolean;
  function fClose:boolean; {returns true if actually closes.}
  procedure fdelete;
  function fexist:boolean;

{$ifdef DEBUG_TREE_OPEN}
  public
{$else}
  private
{$endif}
  opencount : integer;
  procedure fcloseanyway;

end;



Ttree = class
  autodirscan,      //enter unknown directory without asking.
  local_wasset,     //if user set it on or off.
  local : boolean;  //allow owen show to restore to this tree and in other
                    //ways treat it as a local drive.
  index : integer;  //should contain its index in Goptions.trees.
  vscroll:Tscrollbar;
  fixingscroll:boolean;   {when active, scroll bars shouldn't call.}
{$ifdef MSWINDOWS}
  drive : string[1];
{$endif}

  name,               {the name from the Goptions list, ijut! For error
                      messages.}
  lastFileselectdir,
  otherdir,
  homedir : string;  {start directory}

  retry_wait : integer;
{$ifdef RECYCLE}
  recycle : boolean;
{$endif}

  exclude:TStringList;
  rootwarning,
  alwayshome, enterhome : boolean;

  infoFile,
  pathsFile,
  picturesFile,
  offsetsFile
  :Ttreefile;

  count,                  {total directory count of course}
  oldselected,
  selected : integer;     {the number of the currently selected directory
                          ranging from 0 .. count-1.}

  pix : Tjgodis;          {the grand new just-paint directory image}

  selectedpath:string;   {set to selected path after select.}

  onselectchange : procedure;

{$ifdef Linux}
  LinuxSys : boolean;
{$endif}

  xinfo_skip,
  xinfo : integer;
  xinfo_big : integer;

  option_tree_index : integer;
  {the index in Goptions.trees}

  dont_v_invisible : boolean;   {q.v.}

  screen_top,screen_bottom: integer; {index of top and bottom of screen *in*
  offset files. I.e. 0-based directory number of top and bottom of dir
  screen.}


  constructor Create (n:string) ;

  destructor Destroy; override;

  function isbadnet(complain:boolean = false):boolean;
  //returns true if badness.
  procedure begoodnet;

  procedure decode_alwayshome(value:integer);

  {scans the selected branch into scannedtree.}
  function srange(var index:integer):boolean; {true if it altered.}

{cancel_noshow_select (in select and show), if true, *doesn't* show the select
manually --  i.e. overriding the dir_fix shennanigans and show the select
anyway.}

  procedure select(index:integer = sIndex; cancel_noshow_select : boolean =
  false);

  procedure yselect(y:integer);     {given y pixel index in pix, do select.}

  function selecty:integer;       {return y coordinate of selected dir.}

{paint the selected thingey. Paints whole directory thing if necessary.}
  procedure showunselect(index:integer = sIndex);
{  procedure showselect(index:integer = sIndex);  }

  function scrollto(where:integer):boolean;
  function scroll(whichway:integer):boolean;

  procedure cuteselect(index:integer = sIndex);  {try to make select cute}
  procedure cuteify;      {cuter.}

  function parent(what:integer = -1):integer;
  {return index of parent of dir; defaults to selected.}

  function next_sibling(what:integer = -1):integer;
  {return index of next sibling below dir; defaults to selected.}

  function previous_sibling:integer;  {above}

  procedure delete_aux;

  function load:boolean;
  {load the thing, updating various accessory files or whatever.}

  function getpath(index:integer):string;
  function getpix(index:integer):string;

//  function find(what:string; where:integer; exact:boolean):integer;
  function find(what:string; where:integer; kind:Tsearch_kind):integer;


  function level(index:integer):integer;

  function savehomedir(otherdir:string = ''):boolean;
  procedure savehometree;

  procedure resize;

  procedure dirselect;
  procedure dirunselect;
  procedure dirupdating;
  procedure dirunupdating;
  procedure skip(leftcharacter:integer);

  function rut:string;  {return the rut name.}

{----------------------------------------}
{public new scan}
{----------------------------------------}
  function new_scan(what:integer; newonly:boolean; maxlevel:integer;
  newone:string = ''):boolean;

  function new_deldir(which:integer):boolean;
  function new_renameDir(which:integer; newname:string):boolean;
  function new_addDir(add_parent:integer; name:string):boolean;
{----------------------------------------}

  function forget_dirs(rut,depth:integer):boolean;

  procedure fixscroll; {See BAD DIR SCROLL LOGIC comment in main}

  procedure freeze(doit:boolean = true);

  procedure screentop(save:boolean);


  private
  badnet : boolean; //reset by load, begoodnet; set by isbadnet.

  froze : boolean;

  parent_sibling_key : integer;

{$ifdef cuteP_S}
  nocute : boolean;
{****************************************************************************
when set, (1.) DON'T do fast retrieve, (2.) dbg message for any such requests.
Gets cleared by invalidateParentSibling
****************************************************************************}
{$endif}

  procedure invalidateParentSibling;

  procedure killParentSibling(var o:Roffsets);

  function getparent(which:integer):integer;
  procedure putparent(child,parent:integer);

  function getAsibling(which:integer):integer;
  procedure putAsibling(what,sibling:integer);

  function getBsibling(which:integer):integer;
  procedure putBsibling(what,sibling:integer);

  function ifscroll:boolean;   {See BAD DIR SCROLL LOGIC comment in main}


  function gp(index:integer):string;
  {get path of index directory.}

//  function gl(s:string):integer;
  {produce level for path-like thing in s}

  function getoffsets(index:integer; var offs:Roffsets):boolean;

  function fixpaths:boolean;

  procedure show(selectcute : boolean = false; cancel_noshow_select : boolean
  = false);

  procedure commonselect(index:integer = sIndex);

{----------------------------------------}
{private new scan}
{----------------------------------------}
  function tree_start(EndIndex1:integer):boolean;

  function tree_finish(EndIndex1,StartIndex2:integer; newpathsName:string;
  fixstart:integer=-1; fixend:integer=-1):boolean;

  function step4(o,d_o:Roffsets; h_dof:integer; var acount:integer):boolean;

  function tree_pix(s:string):string;
  function tree_fxpx(start,stop,count:integer; offname,pixname:string):boolean;

  procedure xxinfo;

{$ifdef STUPIDCASEBUG_rLb}
  procedure stupid_dir_sort(what:TStringList);
{$endif}
end;

{****************************************************************************
****************************************************************************}
procedure infotalk;
function infoerror(const TheFormat: string;
const Args:array of const):string;


function decentdirectory(f:TSearchRec):boolean;
function indecentdirectory(f:TSearchRec):boolean;

function deletedir(fullpath:string):boolean;

function dir_describe(p:string; rut:boolean; contents:Tdir_contents = nil):
boolean;


{****************************************************************************
I'm putting Tvisited in here because its dependent on Ttree and I want to use
it in bigvist.
****************************************************************************}

const
favoritemarker = '_';

type

Tvisited = class
  tree : Ttree;
  directory:string; //i mean, why not?
  index : integer;
  keep : boolean; //don't purge.
  constructor Create(t:Ttree; i:integer; d:string);
  function defavorite:string;
  function favoritize:string;
end;

{****************************************************************************
****************************************************************************}

{$ifdef DEBUG_TREE_OPEN}
procedure checkopen(t:Ttree);
{$endif}

implementation


uses sbrs, main, qforms, files, options, code, exec,
log
{$ifdef LINUX}
,Libc
{$endif}
{$ifdef MSWINDOWS}
,weirdo
{$endif}
,fileutil
,osinfo
,DateUtils
,qdialogs
,qcontrols
,cpyfiles
;

const

tctag = '~';

etc_recon_error = ' (etc / reconstruct tree?)';

{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{$ifdef LOG_SCAN}

procedure logit(const TheFormat:string; const Args: array of
const); overload;
begin
  if Goptions.scanlog then
  lg('scan',TheFormat,Args);
end;

procedure logit(const TheFormat:string); overload;
begin
  logit(Theformat,[]);
end;

procedure logSizes;
  procedure namesize(x:Ttreefile);
  begin
    logit('%s:%s',[x.name,numbercommas(GetFileSize(x.name))]);
  end;
begin
  with thetree do begin
    namesize(infoFile);
    namesize(pathsFile);
    namesize(picturesFile);
    namesize(offsetsFile);
  end;
end;

{$endif}

{****************************************************************************
****************************************************************************}


var
ST_start,       {start new_scan, new_deldir, new_renamedir, new_addir}

ST_end_scan,

ST_start_tree_start,
ST_end_tree_start,

ST_start_tree_fxpx,
ST_end_tree_fxpx,

ST_start_tree_finish,

ST_step4_start,
ST_step4_stop,

ST_end_tree_finish: os_ticks;

ST_valid : boolean;

procedure ST_begin;
begin
  ST_valid := false;
  ST_start := Get_ms;
  ST_end_scan := St_start;  {in case there isn't any scan time?}
end;

{****************************************************************************
****************************************************************************}

function indecentdirectory(f:TSearchRec):boolean;
begin
  result :=
  (
  ((f.Attr and faDirectory)<>0) and
  (CompareStr(f.Name,'.')=0) or
  (CompareStr(f.name,'..')=0)
  );
end;

function decentdirectory(f:TSearchRec):boolean;
begin
  result :=
  not (
  ((f.Attr and faDirectory)=0) or
  (CompareStr(f.Name,'.')=0) or
  (CompareStr(f.name,'..')=0)
  );
end;


{****************************************************************************
****************************************************************************}
{this is private, and shouldn't be called if not allowdelete.}
const
ddel_ok = true;

function recursive_ddir(dir:string):boolean;
var
F:TsearchRec;
ffresult:integer;

begin
  result := false;

  try
    chdir(dir);
  except
    on E: exception do begin
      errorf('couldn''t chdir(%s), error: %s',
      [dir,E.Message]);
      exit;
    end;
  end;


  ffresult := findfirst('*',
  faDirectory or
{$WARN SYMBOL_PLATFORM OFF}
  faHidden or
  faReadOnly or
  faSysFile
{$WARN SYMBOL_PLATFORM ON}
  ,f);

  while (ffresult=0) do begin
    inc(Gcheck_count);
    if ((Gcheck_count and Gddir_n)=0) then begin
      mask_fix(Gddir_n);
      if Gcheck(f.name) then begin
        findclose(f);
        exit;
      end;
    end;

    if decentdirectory(f) then begin
      if not recursive_ddir(f.name) then begin
        findclose(f);
        exit;
      end;
    end;

    if (f.Attr and faDirectory)=0 then
    if not os_delete(f.name) then begin
{here we use f.name even while search is still underway. This *must* work
because how else would you do it? I suppose you could be required to assemble
a list of all the desired files and then whack them....}
      errorf('Couldn''t delete %s',[f.name]);
      findclose(f);
      exit;
    end;


    ffresult := findnext(f);
  end;

  findclose(f); {probably have to do it now to delete the directory.}

  chdir('..');    {goto parent directory.}


  try
    if ddel_ok then
    rmdir(dir)
    else
    osinfof('dir:ddel_OK is false; would''ve removed directory %s',[dir]);

    result := true;

  except
    on e: exception do
    ioerrorf('rmdir error: %s',[E.Message]);
  end;

end;


function deletedir(fullpath:string):boolean;
var
cwd:string;
begin
  refix_again(true);  //Thu 7/16/2009 5:51 pm.

  result := false;

  mask_fix(Gddir_n,true);  //init.

  cwd := getcurrentdir;


  deslash(fullpath);
  try
    chdir(fullpath);
    chdir('..');
    result := recursive_ddir(xfilename(fullpath));
  except
    on e: exception do
    ioerrorf('deletedir error: %s',[E.Message]);
  end;

  chdir(cwd);

end;

{****************************************************************************
****************************************************************************}

var
dirnumber0:integer;
dircount, filecount, filebytes,
filerosys:
int64
;

function ro_sys(F:TsearchRec):boolean;
begin
  if (f.attr and
  (
{$WARN SYMBOL_PLATFORM OFF}
  faReadOnly
{$ifdef MSWINDOWS}
  or faHidden
  or faSysFile
{$endif}
{$WARN SYMBOL_PLATFORM ON}
  ))<>0
  then begin
    inc(filerosys);
    result := true;
  end else
  result := false;
end;


function r_dir_describe(p:string):boolean;
var
F:TsearchRec;
ffresult:integer;
begin
  result := true; {assume success.}

// deslash(p); //omitted until Monday, October 25, 2004 12:33 pm!?
// no no. Let's do it this way.
  slash(p);     //and remove all the silly "+slashchar+"s.

  ffresult := findfirst(p+'*',

{****************************************************************************
Kylix 3 apparently honors these directory bits; faHidden for instance is a
.directory or .file; I believe faSysFile designates symlinks other oddities.
Delphi 7 still thinks they're platform-dependent.
****************************************************************************}

{$WARN SYMBOL_PLATFORM OFF}
  faHidden or
  faReadOnly or
  faSysFile or
{$WARN SYMBOL_PLATFORM ON}
  faDirectory
  ,F);

  while ffresult=0 do begin

    inc(Gcheck_count);
    if ((Gcheck_count and Gdescribe_n)=0) then begin
      mask_fix(Gdescribe_n);
      if Gcheck(p) then begin
        result := false;  {fail.}
        exit;
      end;
    end;

//    ro_sys(f);    //no have to do decent dir check so don't see ., .. (dot
//    dirs)

    if (f.attr and faDirectory)=0 then begin    // it's a file.
      inc(filecount);
      inc(filebytes,
{$ifdef MSWINDOWS}
{$WARNINGS OFF}
    (f.finddata.nFileSizeLow
    or (f.finddata.nFileSizeHigh shl 32))
{$WARNINGS ON}
//I borrow from os_fSize, fileutil.pas.
{$endif}

{$ifdef LINUX}
      f.size
{$endif}
      );
      ro_sys(f);

{$ifdef CHECK_SYS_RO_FOR_DIRS_TOO}

      if (f.attr and
      (
{$WARN SYMBOL_PLATFORM OFF}
      faReadOnly
{$ifdef MSWINDOWS}
      or faHidden
      or faSysFile
{$endif}
{$WARN SYMBOL_PLATFORM ON}
      ))<>0
      then
      inc(filerosys);
{$endif}
    end else if DecentDirectory(F) then begin
      ro_sys(f);
      inc(dircount);
      result := r_dir_describe(p+f.name);
      if not result then begin
        findclose(F);
        exit;
      end
    end;

    ffresult := findnext(F);
  end;

  findclose(F);

end;



{****************************************************************************
if caller passes contents, he is responsible for clearing it, which will
happen more-or-less normally if he creates the thing, which he normally would.
****************************************************************************}
function dir_describe(p:string; rut:boolean; contents:Tdir_contents = nil):boolean;
var
F:TsearchRec;
ffresult:integer;
dirdat : string;
dirnumb_1:integer;
TheDir_isro:boolean;
wason : boolean;
label
ENDNESS;
begin
  refix_again(true);  //put in Thu 7/16/2009 5:51 pm.

  result := false;

  wason := Gidle_off ;

  dirdat := '';

  deslash(p);

//do this here so we can count enclosing readonly/sys dir.
  dircount  := 0;  {don't count containing dir.}
  filecount := 0;
  filebytes := 0;
  filerosys := 0;
  TheDir_isro := false;

  mask_fix(Gdescribe_n, true);   //start it off.

  if rut then begin
    dirdat := 'is root';
    if contents<>nil then
    contents.rut := true;
  end else begin
  {oh see this is the description of the directory. If it's rut, you don't
  describe it.}
    ffresult := findfirst(p,
{$WARN SYMBOL_PLATFORM OFF}    {see comment at fahidden above}
    faHidden or
    faReadOnly or
    faSysFile or
{$WARN SYMBOL_PLATFORM ON}
    faDirectory
    ,F);

    while ffresult=0 do begin
      if decentdirectory(F) then begin
        TheDir_isro := ro_sys(F);  //check if IT'S read-only please!

        datetimetoString(
        dirdat,
        'm/d/yyyy hh:nn:ss AM/PM',
        filedatetodatetime(F.time));
{$ifdef MSWINDOWS}
        if Goptions.os=XP then
        dirdat :=
        'created ' + dirtime_string(f)+LNEND+
        'written ' + dirdat
        else
        dirdat :=
        'created ' + dirdat;
{$endif}

{$ifdef LINUX}
        dirdat := 'written '+ dirdat;
{$endif}

        if TheDir_isro then
        dirdat := dirdat+LNEND+'>>> "'+fslash(p)+'" is '+rostring+' <<<';

        findclose(F);

        break;

      end;

      ffresult := findnext(F);
    end;

    if length(dirdat)<1 then begin
      findclose(F);
      if contents=nil then begin
        errorf('Couldn''t locate directory %s!',[p]);
        goto ENDNESS;
      end else begin
        contents.couldnt_find := true;
        goto ENDNESS;
      end;
    end;

  end;

  if contents<>nil then begin
    contents.dirdat := dirdat;
    contents.dir_rosys := TheDir_isro;
  end;

  dirnumber0 := thetree.find(p,0,search_EXACT);
  dirnumb_1 := dirnumber0;

  if dirnumb_1>=0 then
  inc(dirnumb_1);

  if not r_dir_describe(p) then
  goto ENDNESS;

  result := true;

  if contents=nil then begin
//someone wants to see something; turn-off stupid "stop" button.
    form1.progress(0);

    osinfof(
    '%s'+LNEND+
    'directory #%s/%s ($%x)'+LNEND+
    '%s'+LNEND+
    'contains %s directories, %s files containing %s bytes'+LNEND+
    '(%s files/dirs are '+rostring+')'
    ,
    [
    fslash(p),
    numbercommas(dirnumb_1),numbercommas(thetree.count),dirnumber0,
    dirdat,
    numbercommas(dircount),
    numbercommas(filecount),
    numbercommas(filebytes),
    numbercommas(filerosys)]);
  end else begin
    contents.dirnumber0 := dirnumber0;
    contents.dircount := dircount;
    contents.filecount := filecount;
    contents.filebytes := filebytes;
    contents.filerosys := filerosys;
    contents.rosys := contents.filerosys>0;
  end;

  ENDNESS:
  Gidle_on(wason);

  mask_fix(Gdescribe_n, true);   //erase any dbg messages.

end;


{****************************************************************************
****************************************************************************}
//caller is in charge of making sure he doesn't call wrong.
procedure Ttree.screentop(save:boolean);
const
oldtop : integer = -1;
oldbottom : integer = -1;
begin
  if save then begin
    oldtop := screen_top;
    oldbottom := screen_bottom;
  end else begin
    if (oldtop<0) or (oldbottom<0) then
    exit;

    screen_top := oldtop;
    screen_bottom := oldbottom;
    oldtop := -1;
    oldbottom := -1;
  end;
end;



function Ttree.srange(var index:integer):boolean;
var
old : integer;
begin

  old := index;
  intrange(0,count,index);
  result := old <> index;

end;

procedure Ttree.showunselect(index:integer = sIndex);
begin
  if index=sIndex then
  index := selected;

  intrange(0,count-1,index);

  if (index>=screen_top) and (index<=screen_bottom) then
  pix.wrln(index-screen_top,getpix(index));

end;


{
procedure Ttree.showselect(index:integer = sIndex);
begin
  if index=sIndex then
  index := selected;

  intrange(0,count-1,index);

  if (index>=screen_top) and (index<=screen_bottom) then
  pix.iwrln(index-screen_top,getpix(index));

end;
}

procedure TTree.commonselect(index:integer = sIndex);
begin
  if index=sIndex then
  index := selected;

  intrange(0,count-1,index);
{a little harmless error fixing.}

  if (index<>selected) then
  showunselect;

  if index=sIndex then
  index := selected;

  srange(index);

  oldselected := selected;
  selected := index;

  selectedpath := getpath(selected);

  fixscroll;

end;


{****************************************************************************
Wed 4/06/2005 2:03 pm. I considered just changing cuteselect, but that's
useful for moving around the directory tree *without* repainting everything.
So cuteify'll just stick the select up in the top portion of the thing.
****************************************************************************}

procedure Ttree.cuteify;
begin

  commonselect(sIndex);
  show(true);

  if Assigned(onselectchange) then
  onselectchange;

end;

procedure Ttree.cuteselect(index:integer = sIndex);
var
cute : boolean;
fudge : integer;
begin

  commonselect(index);

  fudge := pix.scrlines div 7;

  cute :=
  (selected < (screen_top+fudge)) or
  (selected > (screen_bottom-fudge))
  ;


  show(cute);

  if Assigned(onselectchange) then
  onselectchange;

end;

procedure Ttree.select(index:integer = sIndex; cancel_noshow_select : boolean
= false);
begin
  commonselect(index);

  show(false,cancel_noshow_select);

  if Assigned(onselectchange) then
  onselectchange;

end;

{based on the y pixel thing, select dir line. Uses jdisplay code to figger-out
what line, & etc.}
procedure Ttree.yselect(y:integer);  {given y index, do select.}
begin
  select(pix.yline(y)+screen_top);
end;

function Ttree.selecty:integer;       {return y coordinate of selected dir.}
begin
  result :=
  (selected - screen_top) * pix.lineheight
  + (pix.lineheight div 2);
end;

{return true if scrolling is possible.}
{See BAD DIR SCROLL LOGIC comment in main}
function Ttree.ifscroll:boolean;
{var
oldvisible : boolean;  }
begin
  result := false;

  if vscroll=nil then
  exit;

{  oldvisible := vscroll.visible; }


  if pix.scrlines>count then begin
    if not dont_v_invisible then
    vscroll.visible := false;
  end else begin
    vscroll.visible := true;
    vscroll.max := count-pix.scrlines {-1};
    result := true;
  end;

{  if vscroll.visible<>oldvisible then
  pix.show(true);
    {Friday, November 7, 2003 11:19 am with dir_fix active, occasionally I
    can see *through* the vertical scroll! Maybe this'll fix it... //
    didn't Wednesday, December 17, 2003 8:52 am.}

end;

{See BAD DIR SCROLL LOGIC comment in main}
function Ttree.scrollto(where:integer):boolean;
var
s, t, b : integer;
begin
  result := false;

  if not ifscroll then
  exit;

  t := where;
  intrange(0,count-pix.scrlines,t);

  b := t + pix.scrlines-1;

  showunselect;

  screen_top := t;
  screen_bottom := b;

  if selected<screen_top then
  s := screen_top else
  if selected>screen_bottom then
  s := screen_bottom else
  s := selected;

{ showanway; Fri 8/22/03 6:15 pm. But it didn't do select as below. Without
select, scrolling wouldn't update the caption on the bottom of the directory.
Anyway, select() does the show, and if "showanyway" does the show no matter
what, which I gather is what we want, since we just unshowed. Or something.
}

  select(s,true);

  result := true;

end;

function Ttree.scroll(whichway:integer):boolean;
begin
  result := scrollto(screen_top+whichway);
end;

procedure Ttree.skip(leftcharacter:integer);
begin
{  leftc := leftcharacter;}
  pix.skip(leftcharacter);
  show;
end;

{produce level for path-like thing in s. getpath and other code calls this
with a slash-terminated string. When you compare levels -- i.e. between
Ttree.getpath values like Ttree.level and strings in the actual paths file,
which DON'T have terminating slashes -- you have to adjust things.}

{$ifdef _ITS_SBRS_SLASHLEVEL_NOW}
function Ttree.gl(s:string):integer;
var
i:integer;
begin
  result := -1; {I don't know why I did this; I suppose because I wanted root
  to return 0.}

  for i := 1 to length(s) do begin
    if s[i]=slashchar then
    inc(result);
  end;
end;
{$endif}

{returns depth or level of suspected directory.}
function Ttree.level(index:integer):integer;
begin
  result := slashlevel(getpath(index));
end;

{return the index of the parent. -1 if nonesuch.}
function Ttree.parent(what:integer = -1):integer;
var
slevel:integer;
label
ENDNESS, ENDNESS2;
begin
  if what<0 then
  what := selected;

  result := -1;

{speed things up a little by making everything open already?}
  if not pathsFile.fopenR then
  exit;

  if not offsetsFile.fopenR then
  goto ENDNESS2;    //remember to close the paths file.


  result := getparent(what);
  if result>=0 then
  goto ENDNESS;

  result := what;
  slevel := level(result);

  if slevel=1 then
  result := 0   {all 1st-level leaves have root for parent}
  else
  while(result>0) do begin
    if level(result)<slevel then
    break;    //thru to putparents.
    dec(result);
  end;
{and it'll return with 0 if nothing else}

  offsetsFile.fclose;
  putparent(what,result);
  goto ENDNESS2;

  ENDNESS:
  offsetsFile.fclose;

  ENDNESS2:
  pathsFile.fclose;

end;

{return index of next sibling of selected dir.}
function Ttree.next_sibling(what:integer = -1):integer;
var
slevel:integer;
label
ENDNESS0, ENDNESS, ENDNESS2;
begin
  if what<0 then
  what := selected;

  result := -1;

  if not pathsFile.fopenR then
  exit;

  if not offsetsFile.fopenR then
  goto ENDNESS2;

  result := getBsibling(what);
  if result>=0 then
  goto ENDNESS;

  result := what;

  slevel := level(result);

  if slevel=0 then begin
    result := count;
    goto ENDNESS0;
  end;

  while(result< (count-1)) do begin
    inc(result);
    if level(result)<=slevel then
    goto ENDNESS0;
  end;

  result := count;

  ENDNESS0:
  offsetsFile.fclose;
  putBsibling(what,result);
  goto ENDNESS2;


  ENDNESS:
  offsetsFile.fclose;
  ENDNESS2:
  pathsFile.fclose;

end;

{returns selected's above sibling}
function Ttree.previous_sibling:integer;
var
slevel:integer;
begin

  result := -1;

  if not offsetsFile.fopenR then
  exit;

  result := getAsibling(selected);
  offsetsFile.fclose;

  if result >= 0 then begin
    exit;
  end;

  if not pathsFile.fopenR then
  exit;

  result := selected;

  slevel := level(result);

  while(result>0) do begin
    dec(result);
    if level(result)<=slevel then
    break;
  end;
{and it'll return with 0 if nothing else}

//  offsetsFile.fclose;
  pathsFile.fclose;

  putAsibling(selected,result);

end;



{****************************************************************************
****************************************************************************}
procedure Ttree.delete_aux;
begin
  PicturesFile.fdelete;
end;

{load the file, maybe updating some of the files or something. Perhaps
by dates....}
function Ttree.load:boolean;
var
h:integer;
label
LOADITANYWAY;
begin
  result := false;
  skip(0);    {reset left-scroll}

  if not Goptions.dont_kill_offsets then begin
    h := FileAge(offsetsFile.name);
    if h>=0 then begin
      if
      FileDateToDateTime(h) <
{
function EncodeDateTime(const AYear, AMonth, ADay, AHour, AMinute,
ASecond, AMilliSecond: Word):
TDateTime; }

      EncodeDateTime(2004,7,20,17,02,0,0) then
      DeleteFile(offsetsFile.name);

{Because I changed the size of the offsets file around then.}

    end;
  end;

  if (not pathsFile.fexist)
  or (not picturesFile.fexist)
  or (not offsetsFile.fexist)
  or (not infoFile.fexist)

  then begin


    if pathsFile.fexist and (Goptions.xlate or
    usuref( 'Some "%s" files missing; concoct them from %s?',
    [name, pathsFile.name ]))
    and fixpaths
    and tree_start(-1)
    and tree_finish(-1,-1, pathsFile.name)
    then
    goto
    LOADITANYWAY;

    if not usuref('"%s" files missing; make-up a blank?',
    [name]) then
    exit;

    h := StupidNewFile(pathsFile.Name);
    hprintf(h,slashchar+LNEND);

    FileClose(h);

    result :=
    tree_start(-1) and
    tree_finish(-1,-1,
    pathsFile.name
    );

{    result := tree_start(-1);
    result := result
    and tree_finish(-1,-1,pathsName,-1,-1);  }

    if not result then begin
      pathsFile.fdelete;
    end else begin
      select(0);
    end;

    exit;

  end;
  LOADITANYWAY:
{files exist. Get the famous info.}

  if (infoFile.FopenR)
  then begin

    count := infoFile.inif.ReadInteger(infohead,'count',0); //count

    if alwayshome then
{$ifdef LINUX}
    homedir :=
    fslash(infoFile.inif.ReadString(infohead,'homedir',homedir));
    otherdir :=
    fslash(infoFile.inif.ReadString(infohead,'otherdir',otherdir));
    if length(otherdir)<1 then
    otherdir := homedir;
{$endif}

{$ifdef MSWINDOWS}
    homedir :=
    fslash(
    fredrive(
    infoFile.inif.ReadString(infohead,'homedir',homedir),drive[1]) );
    {get the home from the one saved. + Monday, May 5, 2003 4:59 pm
    make sure it has a drive. This should heal itself someday but
    its otherwise so boring.}

    otherdir :=
    fslash(
    fredrive(
    infoFile.inif.ReadString(infohead,'otherdir',otherdir),drive[1]) );
    if length(otherdir)<1 then
    otherdir := homedir;

{$endif}

    parent_sibling_key :=
    infoFile.inif.ReadInteger(infohead,'key',parent_sibling_key);

    infoFile.fclose;

    if length(homedir)<1 then begin
      homedir := originaldir;
    end;
    if length(otherdir)<1 then begin
      otherdir := originaldir;
    end;

    begoodnet;
    result := true;
  end;

end;

procedure Ttree.savehometree;
var
h:integer;
begin
  if not local then
  exit;

  h := StupidNewFile(Goptions.treeifo);
  if h>=0 then begin
    hprintf(h,'%s'+LNEND,[name]);
    FileClose(h);
  end;

end;

function Ttree.savehomedir
(otherdir:string = '')
:boolean;
var
dir : string;
begin
  result := false;

  savehometree;

  if enterhome and (length(lastFileselectdir)>0) then
  dir := lastFileselectdir
  else if alwayshome then
  dir := homedir;

  if infoFile.FopenR
  then begin
    infoFile.inif.WriteString(infohead,'homedir',dir);
    if Goptions.otherdir
    and (length(otherdir)>0) then
    infoFile.inif.WriteString(infohead,'otherdir',otherdir);
    infoFile.fclose;
    result := true;
  end;
end;


{return the path of the indexed dir.}
function Ttree.gp(index:integer):string;
var
offs: Roffsets;
begin
  result := '';

  if getoffsets(index,offs) then begin
    if not pathsFile.FopenR then
    exit;

    if FileSeek(
    pathsFile.handle,offs.path,0)>=0 then
    hgets(pathsFile.handle,result);

    pathsFile.fclose;
  end;
end;

function Ttree.getpath(index:integer):string;
begin
  result := gp(index);
{$ifdef MSWINDOWS}
  result := drive+':'+result;
{$endif}
  slash(result);
{getpath returns something that chdir will change to. Apparently, it
likes trailing slashes. I don't, 'though.}
end;

function Ttree.getpix(index:integer):string;
var
offs: Roffsets;
begin
  result := '';

  if getoffsets(index,offs) then begin
    if not picturesFile.FopenR then
    exit;

    if FileSeek(picturesFile.handle,offs.pix,0)>=0 then
    hgets(picturesFile.handle,result);
    picturesFile.fclose;
  end;
end;

{****************************************************************************
****************************************************************************}

procedure Ttree.resize;
begin
  pix.show(true);

{  pix.skip(0); }
  fixscroll;    {See BAD DIR SCROLL LOGIC comment in main}
  show;
end;

{assuming select and screen_top are valid values, show things. Does *not* do select
and all that that entails; it's a little obscure but I've gone through three
iterations and it got scrambled a little.}

procedure Ttree.show(selectcute : boolean = false; cancel_noshow_select :
boolean = false);
var
aline, index:integer;
s:string;
R:Roffsets;

label ENDNESS;

  procedure fix;
  begin
    intrange(0,count,screen_top);

    screen_bottom := screen_top + pix.scrlines - 1;

    if screen_bottom>=count then begin
      screen_bottom := count-1;
      screen_top := screen_bottom - pix.scrlines+1;
      if screen_top<0 then
      screen_top := 0;
    end;
  end;

  {****************************************************************************
  show just the select to speed things up.
  ****************************************************************************}
  procedure show_just_select;
  begin
    if cancel_noshow_select then
    exit;

    pix.show(true,false);   {temporarily enable display.}

    pix.iwrln(selected-screen_top,getpix(selected));

    showunselect(oldselected);

{    if (oldselected>=screen_top)
    and (oldselected<=screen_bottom) then begin
      pix.wrln(oldselected-screen_top,getpix(oldselected));
    end;

{it doesn't appear for some reason I mean yawn.... 'n what the heck I'm
trying to speed things up anyway.}


{    pix.wrln(selected-screen_top,getpix(selected));  }

    pix.show(false,false);  {disable again.}
  end;

begin

{  mswait(500);  }
{trying to test various dir fixes}

{so maybe they aren't right...}
  intrange(0,count-1,screen_top);
  intrange(0,count-1,selected);

  if selectcute then begin
    screen_top := selected - (pix.scrlines div 4);
  end else begin

    if selected < screen_top then begin
      screen_top := selected;
    end else if selected > screen_bottom then begin
      screen_top := selected - (pix.scrlines-1);
    end;

  end;

  fix;

  if froze then begin
    goto ENDNESS;
  end;

{*after* cute figuring. }
  if pix.dontshow then begin
    show_just_select;
    goto ENDNESS;
  end;

  index := 0;

  if not getoffsets(screen_top,R) then
  goto ENDNESS;

  if (not picturesFile.FopenR)
  or (Fileseek(picturesFile.handle,R.pix,0)<0) then
  goto ENDNESS;

  for aline := screen_top to screen_bottom
  +1 {Wed 12/03/03 6:38 pm. so I don't see a half-line blank on the bottom? //
  Yes. Because of this, the "break" just below gets executed when I'm at the
  end of the tree, but that's cool; I want the break code for safety's sake,
  and might as well be useful too....}

  do begin
    if not hgets(
    picturesFile.handle
    ,s) then begin
      break;
    end;
    if aline=selected then
    pix.iwrln(index,s)
    else
{let select do that. // oh but sometimes it doesn't....}
    pix.wrln(index,s);

    inc(index);
  end;

{****************************************************************************
Tue 11/04/03 11:32 am. I thought this looked kind of bizarre; doesn't seem to
do anything.

  for aline := screen_bottom+1 to screen_bottom+2 do begin
    if hgets(h,s) then
    pix.wrln(index,s)
    else
    pix.wrln(index,'');
    inc(index);
  end;

****************************************************************************}

{finish off a short dir.}
  for aline := index to pix.scrlines do begin
    pix.wrln(aline,'');
  end;

  xxinfo;

  ENDNESS:
  picturesFile.fclose;

end;

procedure Ttree.dirselect;
begin
{  dirselected := true; }
  pix.backg := selColor;
  show;
end;

procedure Ttree.dirunselect;
begin
{  dirselected := false; }
  pix.backg := unselColor;
  show;
end;

procedure Ttree.dirupdating;
begin
  pix.foreg := clLtGray {0 {gray};
  show;
end;

procedure Ttree.dirunupdating;
begin
  pix.foreg := clBlack;
  show;
end;

{****************************************************************************
****************************************************************************}
{****************************************************************************
Mon 12/12/2005 12:32 pm. If exact, if he didn't include a slash char, match
exactly on *last element*; if he *includes* a slash character, do it the way
it used to be.
****************************************************************************}

function Ttree.find(what:string; where:integer; kind:Tsearch_kind):integer;
var
start, stop, j,i : integer;
lowerwhat:string;
whatslash : boolean;
path : string;
offs:Roffsets;
wascumulative:boolean;
//During cumulative esarch, after a certain number of tries...
//cumtries,
//the cumulative mask is altered so we check less.
cummask:integer;
cumtime : ticktime;

label
ENDNESS;

  function checkdir:boolean;
  var
  apos : integer;
  begin

    if kind = search_EXACT_SLASH then begin
      result :=
{$ifdef MSWINDOWS}
      CompareText(
      what,
      path
      )
{$endif}
{$ifdef LINUX}
      CompareStr(
      what,        {exact case compare in linux}
      path
      )
{$endif}
      =0;
    end else
    if kind=search_EXACT then begin

      result :=
{$ifdef MSWINDOWS}
      pos(
      lowerwhat,lowercase(path)+slashchar)
            //+slashchar 'cause path doesn't have a trailing slash.
      >0
{$endif}
{$ifdef LINUX}
      pos(what,path+slashchar)
      >0
{$endif}
//if *any* complete path element matches search it's a hit.

    end else begin

      if whatslash then
      apos := pos(lowerwhat,lowercase(path)
      + slashchar {let him find bingo\ instead of bingo\next? I.e. if I
      typed "bingo\" it would find the 1st subdirectory in "bingo" instead
      of the first path with "bingo\" in it.}
      )
      else
      {if what the guy's looking-for doesn't contain slash, then
      only search the right-most part of the directory name.}
      apos := pos(lowerwhat,lowercase(xFileName(path)));

      if kind=search_CONTAINS then
      result := (apos > 0)
      else
      //it's search_BEINGS_WITH
      result := (apos = 1);
    end;

  end;

  procedure cumshow(fast:boolean);
  var
  s:string;
  begin
    if fast then begin
      s := 'F';
      cummask := Gfcumu_n;    //check frequently.
      delay_z(cumtime,100);
    end else begin
      s := 's';
      cummask := Gcumu_n;     //check less frequently.
    end;

    form1.Label_LXstat.caption := s;

  end;

begin
  result := -1; {assume failure.}

  wascumulative := Giscumulative; //in case it goes off while we're here.

  if wascumulative then begin
    cummask := Gfcumu_n;   //check frequently to start.
    cumshow(true);
  end else begin
    cummask := Gcumu_n;
//    dbg('');
  end;

{$ifdef MSWINDOWS}
  what := fdedrive(what);       {rip-off "c:" junk.}
{$endif}

  intrange(0,count-1,where);
  {now that I'm feeding it random numbers, directory indices stored
  with files.}

  whatslash := pos(slashchar,what)>0;
  {what contains slash character.}

  if (kind=search_exact)
  and (whatslash) then begin

    kind := search_EXACT_SLASH;

    deslash(what);      {because dirs stored without trailing slash.}

    if (es(what,1)<>slashchar) then
    what := slashchar+what;
    {make sure it has leading slash, in case user left off.}

  end
  else
  if (kind=search_exact) then
  what := slashchar + what + slashchar;
  //if it's exact but no slashes, make-up a slashed path element.

  lowerwhat := lowercase(what);
{LINUX and WINDERS should have a lower-case version for inexact comparisons.}

  if (not getoffsets(where,offs))
  or (not pathsFile.FopenR) then
  goto ENDNESS;

  for j := 1 to 2 do begin {because we want to do the end before the
  beginning, i.e. search the list starting at where, then do the
  rest.}
    if j=1 then begin
//      if where>=count then
//      continue;         {if we're *at* the end, skip it and do the other one?}

    {do the end}
      if (FileSeek( pathsFile.handle,offs.path,0)<0) then begin
        goto ENDNESS;
      end;

      start := where;
      stop := count-1;
    end else begin
    {do the beginning.}
      if (FileSeek( pathsFile.handle ,0,0)<0) then begin
        goto ENDNESS;
      end;
      start := 0;
      stop := where-1;
    end;

    {do either one}
    for i := start to stop do begin
//so show the stupid prompt even if not cumulative?
      inc(Gcheck_count);
      if (Gcheck_count and cummask)=0 then begin
        form1.filesM_stat.caption := safe_format('%d:%s',[i,path]);
        if wascumulative then begin
          delphi_yield;

          if (not Giscumulative)
          or (MyKeyQueue.count>0) then begin
            Gcumulative_stopped := true;
  //          dbg('Gcumulative_stopped');
            goto ENDNESS;
          end;

//it's cumulative.

{****************************************************************************
So basically the idea here is Gfcumu_n==1, and as long as there're keys
coming, we check as fast as we can; because, basically, if the user's typing
another cumulative search key, we're just going to have to start the search
again, and we might as well speed that up. Once however, there are no keys for
a while, then we goto super slow checking -- which speeds up the
search of course. This corresponds to my (aka "user's") typical behavior,
which is to type a bunch of characters to search for a directory....
****************************************************************************}
          if MyKeyQueue.count>0 then begin
            cumshow(true);
          end else begin
            if delay_z(cumtime) then
            cumshow(false);
          end;

        end;
      end;

      if (not hgets(pathsFile.handle,path)) then begin
        goto ENDNESS;
      end;

      if checkdir then begin
        result := i;
        goto ENDNESS;
      end;
    end;
  end; {j}

  ENDNESS:
  pathsFile.fclose;

  form1.filesM_stat.caption := '';

end;


{****************************************************************************
take a file of paths and fix it.

OS paths:
  \
  \bundle\
  \bundle\works\
  \Documents\
  \Documents and Settings\
  \Documents and Settings\All Users\

documentation for my previous effort on this; I *knew* I'd need it again!

OV paths:
J. G. Owen Shell (c) 1992. Live long and prosper.
123
c:\
c:\ATI                              ATI
c:\ATI\INSTALL                        INSTALL
c:\Compaq                           Compaq
c:\Compaq\Help                        Help
c:\Compaq\Imouse                      Imouse
c:\Compaq\Internet                    Internet               [A]
c:\Compaq\Internet\Brando               Brando               [B]
c:\Compaq\VidPhone                    VidPhone
c:\Compaq\VidPhone\bitmaps              bitmaps
c:\Compaq\VidPhone\Layout               Layout
c:\Compaq\VidPhone\Layout\Intro           Intro
c:\Compaq\VidPhone\Standby              Standby
c:\Compaq\VidPhone\Uninstall            Uninstall
c:\cpqdrv                           cpqdrv
c:\cpqdrv\aas                         aas
   12345678
                                    this stupid tre safe_format
                                    is not more Mon 10/14/02 4:08 pm.

fixpaths checks if pathsname is an OV paths file, and if so fixes it. Returns
true if isn't OV file, or if it fixed it good. An OV file has leading drive:
and a strange first line signature. This should only be called when the offset
and pix file are missing or something.

//and what the heck lets fix some other abberrations while we're here....
****************************************************************************}

function Ttree.fixpaths:boolean;
var
t:integer;
tname, s:string;
isov : boolean;
label
ENDNESS;
begin
  result := false;      {assume failure}

  t := -1;

  if not pathsFile.FopenR then
  exit;

  if not hgets(pathsFile.handle,s) then
  goto ENDNESS;

  isov :=
  CompareText(s,'J. G. Owen Shell (c) 1992. Live long and prosper.')=0;
  {hgets discards control characters.}

  if not isov then
  FileSeek( pathsFile.handle ,0,0);

  tname := os_temporary;
  t := StupidNewFile(tname);
  if t<0 then
  goto ENDNESS;

  while(hgets( pathsFile.handle ,s)) do begin

    if (length(s)<1) or
    sbrs.isspace(s[1]) then     {for some reason, Kylix sees c lib before
                                my sbrs}
    continue;
    {Thursday, February 19, 2004 12:12 pm. Dump empty lines.}

    if isov then
    s := copy(s,3,10000);

    if length(s)>1 then
    deslash(s);             {enforce unslashedness}
    hprintf(t,'%s'+LNEND,[s]);
  end;

  pathsFile.fclose;

  FileClose(t);
  t := -1;

  os_delete(pathsFile.name);
  RenameFile(tname,pathsFile.name);

  result := true;

  count := 0; {Friday, May 2, 2003 12:57 pm. Not that I understand the //count
  logic, but the system is rigged to concoct a new set of tree files when
  it's given a single pth file, even an OV pth file. It works the *first*
  time after OS starts, but failed the *second* -- because the count
  wasn't in the init zero state.}

  ENDNESS:
  pathsFile.fclose;

  if t>=0 then
  FileClose(t);

end;

procedure Ttree.fixscroll;
begin
  if not ifscroll then
  exit;

  fixingscroll := true;

  vscroll.position := screen_top;

  fixingscroll := false;

end;

function Ttree.getoffsets(index:integer; var offs:Roffsets):boolean;
label
BADNESS;
begin
  result := false;

  if not offsetsFile.FopenR then
  exit;

  if FileSeek(offsetsFile.handle,sizeof(offs)*index,0)<0 then
  goto BADNESS;

  if FileRead(offsetsFile.handle,offs,sizeof(offs))<>sizeof(offs) then
  goto BADNESS;

  result := true;

  BADNESS:
  offsetsFile.fclose;

end;


{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
Mon 11/25/02 4:27 pm. The grand new scan code. I wrote all this stuff once;
this is the second run at it. As hard as it may be to believe, it tidies
things up considerably and also optimizes the picture-fixing, which before
(and in the 2,000 previous iterations in the previous 16-bit MSDOS OwenView)
would do the whole pix file every time.

So to discard the entire tree, caller'd do

1. tree_start(-1)
3. tree_finish(-1,-1,pathsName)

at least that's what load does.

****************************************************************************}
{$I ospix.i}

function Ttree.tree_start(EndIndex1:integer):boolean;
var
offsetsize,
spt,spx,sof,
dpt,dpx,dof:integer;
o:Roffsets;
label
ENDNESS;
begin

{$ifdef LOG_SCAN}
  logit('tree_start: begin');
{$endif}

  refix_again
//  (true)   //all the other ones are true....
//but then again this is called by everyone; maybe I just wanted to make sure
//in case some day it got called by somebody else.
  ;

{$ifdef LOG_SCAN}
  logit('refixed');
{$endif}

  mask_fix(Gscan_n,true);    //init mechanism.

  ST_start_tree_start := Get_ms;

  result := false;
  ST_valid := false;

  spt := -1;
  spx := -1;
  sof := -1;
  dpt := -1;
  dpx := -1;
  dof := -1;


  if Gcheck('tree_start') then
  goto ENDNESS;

{note that within tree_start, self.count is valid, since we're just
dealing with what exists.}

{for some reason we want the whole thing. I don't think this happens.}
  if EndIndex1>(count-1) then begin
    if (not os_fCopy(pathsFile.name,pathsFile.name+tctag))
    or (not os_fCopy(picturesFile.name,picturesFile.name+tctag))
    or (not os_fCopy(offsetsFile.name,offsetsFile.Name+tctag))

    then
    goto ENDNESS;
    result := true;
    goto ENDNESS;
  end;

{in this case we want to add stuff to the end. For instance might be scanning
the last directory on the tree. The last index is the last entry.}
  if EndIndex1=count-1 then begin

    o.path := os_fSize(pathsFile.name);
    o.pix := os_fSize(picturesFile.name);

    offsetsize := count * sizeof(o);

  end else begin
{note that this one works with EndIndex1=-1. No u idiot it works with
EndIndex = 0. We *always* preserve the topmost entry -- which is the
root.}

    if not getoffsets(EndIndex1+1,o) then
    goto ENDNESS;
    offsetsize := (EndIndex1+1)*sizeof(o);

  end;

  {--------------------}
  if EndIndex1>=0 then begin

    spt := FileOpen(pathsFile.name,fmOpenRead);
    if spt<0 then
    goto ENDNESS;

    spx := FileOpen(picturesFile.name,fmOpenRead);
    if spt<0 then
    goto ENDNESS;

    sof := FileOpen(offsetsFile.Name,fmOpenRead);
    if sof<0 then
    goto ENDNESS;
  end;

  {--------------------}
  dpt := StupidNewFile(pathsFile.name+tctag);
  if dpt<0 then
  goto ENDNESS;

  dpx := StupidNewFile(picturesFile.name+tctag);
  if dpx<0 then
  goto ENDNESS;

  dof := StupidNewFile(offsetsFile.Name+tctag);
  if dof<0 then
  goto ENDNESS;

  {--------------------}
  if EndIndex1>=0 then begin
    if
    (not os_hCopyBlock(spt,dpt,o.path)) or
    (not os_hCopyBlock(spx,dpx,o.pix)) or
    (not os_hCopyBlock(sof,dof,offsetsize)) then
    goto ENDNESS;
  end;
  {if it's less than 0, the destinations are empty, all is well.}

  result := true;

  ENDNESS:
  MaybeClose(spt);
  MaybeClose(spx);
  MaybeClose(sof);
  MaybeClose(dpt);
  MaybeClose(dpx);
  MaybeClose(dof);

  ST_end_tree_start := Get_ms;

{$ifdef LOG_SCAN}
  logit('tree_start: end');
{$endif}

end;

{****************************************************************************
****************************************************************************}
function Ttree.tree_pix(s:string):string;
var
thislength,
lastname_index, thisdepth,i : integer;
thisname : string;
begin

  thislength := length(s);

  if thislength<2 then begin
    result := gfntHdown+'(root)';
    exit;
  end;

  thisdepth := 0;      {just try and follow the existing logic. Note we
  assume that *these* paths *do not* have concluding slashes -- basically
  because that's the way OV is.... So this pathtree mechanism was developed
  when I was still using the tabbed-tree thingey saved by the broken Ttree
  component, but it does seem kind of handy.}

  lastname_index := 0;
  for i := 1 to thislength do begin
    if s[i]=slashchar then begin
      lastname_index := i+1;
      inc(thisdepth);
    end;
  end;

  result := '';

  thisname := copy(s,lastname_index,10000);

  for i := 1 to (thisdepth-1) do
  result := result+gfntV;
  result := result+gfntVright+thisname;

end;


{****************************************************************************
****************************************************************************}
{****************************************************************************
fix the pixname file from index start to stop; count is the count of the
pixname file; i.e. it's the new count which, if all goes well, will be the new
count of the tree. offname is the name of the offsets file.
****************************************************************************}
function Ttree.tree_fxpx(start,stop,count:integer;
offname,pixname:string):boolean;
var
hoffsets,hpix,
i,j:integer;
error,
thisline,
linebelow : string;
{$ifdef gfntSIZE2}
linethis_s,
linebelow_s : string[2];
{$endif}
{$ifdef gfntSIZE1}
linebelow_c : char;
{$endif}
offs : Roffsets;

label
BADNESS;

  function xx_getoff(index:integer):boolean;
  begin
    result := false;
    if FileSeek(hoffsets,sizeof(offs)*index,0)<0 then
    exit;

    if FileRead(hoffsets,offs,sizeof(offs))<>sizeof(offs) then
    exit;

    result := true;

  end;

begin
{$ifdef LOG_SCAN}
  logit('tree_fxpx: begin');
{$endif}

  ST_start_tree_fxpx := Get_ms;

  result := false;

  hoffsets := -1;
  hpix := -1;

  error :=
  safe_format('tree_fxpx: couldn''t open offsets file "%s" for read',
  [offname]);

  hoffsets := FileOpen(offname,fmOpenRead);
  if hoffsets<0 then
  goto BADNESS;

  error :=
  safe_format('tree_fxpx: couldn''t open pix file "%s" for read',
  [pixname]);

  hpix := FileOpen(pixname,fmOpenReadWrite);
  if (hpix<0) then
  goto BADNESS;

  if stop>=count then
  linebelow := ''
  else begin
    if
    (not xx_getoff(stop)) or
    (FileSeek(hpix,offs.pix,0)<0) or
    (not hgets(hpix,linebelow)) then
    goto BADNESS;
  end;

{there are two versions of the code, depending on the how the pictures are to
be stored. gfntSIZE1 was when I was using windows OEM graphics characters;
gfntSIZE2 is for the ASCII version, so pretty-much certain. See ospix.i}

{$ifdef gfntSIZE1}
  for i := stop-1 downto start do begin
    if xx_getoff(i) and
    (FileSeek(hpix,offs.pix,0)>=0) and
    hgets(hpix,thisline) and
    (FileSeek(hpix,offs.pix,0)>=0) {reseek}
    then begin
      for j := 1 to length(thisline) do begin
        linebelow_c := es(linebelow,j);
        case (thisline[j]) of
          gfntV: begin
            if
            (linebelow_c<>gfntVendright) and
            (linebelow_c<>gfntVright) and
            (linebelow_c<>gfntV)
            then
            thisline[j] := ' ';
          end;

          gfntVright: begin
            if
            (linebelow_c<>gfntVendright) and
            (linebelow_c<>gfntVright) and
            (linebelow_c<>gfntV)
            then
            thisline[j] := gfntVendright;
          end;
        end;
      end;

      error :=
      safe_format('user aborted',[0]);

      if main_abort('tree_fxpx:'+thisline,new_fixmask) then
      goto BADNESS;

      hprintf(hpix,'%s',[thisline]);
      {no line end. we're just replacing chars.}

      linebelow := thisline;
    end;
  end;
{$endif}

{$ifdef gfntSIZE2}
  for i := stop-1 downto start do begin
    if xx_getoff(i) and
    (FileSeek(hpix,offs.pix,0)>=0) and
    hgets(hpix,thisline) and
    (FileSeek(hpix,offs.pix,0)>=0) {reseek}
    then begin
{****************************************************************************
****************************************************************************}

      for j := 1 to length(thisline) do begin
        if (j and 1)=0 then
        continue;

        linebelow_s := copy(linebelow,j,2);
        linethis_s  := copy(thisline,j,2);

        if
        (linethis_s=gfntV) and
        (linebelow_s<>gfntVendright) and
        (linebelow_s<>gfntVright) and
        (linebelow_s<>gfntV) then begin
          thisline[j]   := gfntBlank[1];
          thisline[j+1] := gfntBlank[2];
        end else
        if
        (linethis_s=gfntVright) and
        (linebelow_s<>gfntVendright) and
        (linebelow_s<>gfntVright) and
        (linebelow_s<>gfntV) then begin
          thisline[j]   := gfntVendright[1];
          thisline[j+1] := gfntVendright[2];
        end;

      end;

      error :=
      safe_format('user aborted',[0]);

      if ((i and Gscan_n)=0) then begin
        mask_fix(Gscan_n);
        if Gcheck('tree_fxpx:'+thisline) then
        goto BADNESS;
      end;

      hprintf(hpix,'%s',[thisline]);
      {no line end. we're just replacing chars.}

      linebelow := thisline;
    end;
  end;
{$endif}

  result := true;

  BADNESS:
  MaybeClose(hpix);
  MaybeClose(hoffsets);
  st_end_tree_fxpx := Get_ms;

{$ifdef LOG_SCAN}
  logit('tree_fxpx: end');
{$endif}

  if not result then



end;

{****************************************************************************
****************************************************************************}


{$define DBG_SEEK}

{$ifdef DBG_SEEK}
var
Glastinversion:string;
{$endif}

{.$O-}
{.$define DBG_STEP4}
function Ttree.step4(o,d_o:Roffsets; h_dof:integer; var acount:integer):boolean;
var
tried_seek:boolean;
start_count,
start_sought,
oldo_path : integer;

label
ENDNESS;

begin

{$ifdef DBG_SEEK}
  if Gosidle_on and Goptions.inversionmessage then
  dbg('step4: osidle is active');
{$endif}

  result := false;      //default to failure.

  oldo_path := -1;
  start_count := acount;
  start_sought := FileSeek(offsetsFile.handle,0,1);  //get current position.

  tried_seek := false;

{read in an offset from the old offsets into o.}
  while
  FileRead(offsetsFile.handle ,o,sizeof(Roffsets))=sizeof(Roffsets)
  do begin

{$ifdef DBG_STEP4}
    if ((acount and Gscan_n) = 0) then
    dbg('path:%d pix:%d',[o.path,o.pix]);
{$endif}

{add-in the difference to both, into o.}
    inc(o.path,d_o.path);
    inc(o.pix, d_o.pix);


{****************************************************************************
Mon 1/03/2005 12:58 pm. This is the fearsome INVERSION error; now I've removed
all the comments and endless conditionals and what is left is isolation of
step4 as a separate routine and, of course, the test for the inversion --
which should never happen ever. Tue 6/14/2005 11:19 am. But it did, because I
forgot to turn-off osidle in a new feature. I never did understand why osidle
causes this error; I'm content to blame some secret disability deep within
Kylix/Delphi, but it could be some stupid thing I'm doing in there I still
haven't figured-out.....
****************************************************************************}

    if (o.path < oldo_path) then begin
      //oops inverted offset should never happen. This happens about 1 to
      //20 40? tests. Infrequently, but often-enough. But only on development
      //machine....
{$ifdef LOG_SCAN}
      logit('STEP 4 inverted path offset: count:$%x; next:%d; previous:%d',
      [acount,o.path,oldo_path]);
{$endif}

{$ifdef DBG_SEEK}
      if Goptions.inversionmessage then
      dbg('step4: cnt:$%x; nxt:$%x; prv:$%x; Dpth:$%x; Dpix:$%x',
      [acount,o.path,oldo_path,d_o.path,d_o.pix]);

{****************************************************************************
don't think this helps anything; you get to see it in etc/info ("scan
timings") but I never have. I left the etc/info thingey in there 'though.

      Glastinversion :=
      safe_format(LNEND+'Step 4 inversion error #%d:'+LNEND+
      'cnt:$%x; nxt:$%x; prv:$%x; Dpth:$%x; Dpix:$%x',
      [dbg_count,acount,o.path,oldo_path,d_o.path,d_o.pix]);
      inc(dbg_count);
****************************************************************************}
{$endif}

      if tried_seek then begin

        errorf(
        'step4 fatal inversion error: '+
        'count:$%x; next:%d; previous:%d; '+
        'sorry... Could be gamma rays, eh? (tried re-seek)'
//although so far, the re-seek has always worked.
        ,
        [acount,o.path,oldo_path]);
        goto ENDNESS; //fail.

      end;

{try seeking back. This actually worked numerous times. What we're doing,
incidentally, is not seeking back exacctly, but seeking to exactly where we're
supposed to be anyway! Actually, since the bug has always occurred at count
$2000, I could just use constants here, but as I note somewhere below, maybe
there's some other stupid boundary further-in and might as well fix that if it
ever shows-up....}

      tried_seek := true;

      FileSeek(offsetsFile.handle,
      ((acount - start_count) * sizeof(Roffsets)) +
      start_sought
      ,0);  //don't bother checking nothing we can do anyway.

{     acount := start_count;
      that's not right! The count's fine. Supposedly we're fixing everything
      here, so the count should be fine. So why did it work? ... I have no
      idea.... This is fun, no? }

      continue;   //the while.

    end;

    oldo_path := o.path;

{write the new adjusted o offsets. // incidentally we don't care what happens
regarding parent_sibling, because we invalidated it already. Although actually
I see we're preserving the values. ? mmm....}

    if (FileWrite(h_dof,o,sizeof(Roffsets))<>sizeof(Roffsets)) then
    goto ENDNESS;

    inc(acount);    {count the little items.}

    if ((acount and Gscan_n_4) = 0) then begin
      mask_fix(Gscan_n_4);
    {every 8,000 directories or so, let the user try and cancel. This goes so
    fast it hasn't been an issue so far but what the heck.}
      if Gcheck(
      format('offsets (%d %d)',[o.path,o.pix])

//      'offsets'
      ) then
      goto ENDNESS;
    end;

//this is something leftover/broken Fri 1/07/2005 6:54 pm....
//    if ((acount and Gscan_n) = 0) then begin
//      if Gcheck('offsets') then
//      goto ENDNESS;
//    end;

    tried_seek := false;  {if we got here, it worked once at least.
    Conceivably, it could happen again later in the file, so why not fix that
    too?}

  end;
{that's that.}

  result := true;

  ENDNESS:

end;
{.$O+}

{****************************************************************************
****************************************************************************}
{where EndIndex1 is the index of the last record in the existing tree file we
should preserve, and StartIndex2 is the first index in the existing tree junk
we should use. newpathsName is the file containing paths we should stick in
the middle. If newpathsName=='' (del dir) then just ignore it. If fixstart and
fixend, use them for the fix tree argument instead of the computation. }

function Ttree.tree_finish(EndIndex1,StartIndex2:integer; newpathsName:string;
fixstart:integer = -1; fixend:integer = -1):boolean;
var
donew,
skip2 : boolean;
lnend_length,
acount,
endmiddlecount,
h_npn,            {newpathsName handle}

h_spt,            {source pathsName handle}
h_spx,            {source pix handle}
h_dpt,            {destination paths name handle}
h_dpx,            {destination pix file }
h_dof             {destination offsets file}
:integer;

d_o,              {difference offset}
o:Roffsets;
error,
spath,spix:string;
label
ENDNESS, ENDNESS_2;

  procedure detemp(name:string);
  begin
    DeleteFile(name);
    RenameFile(name+tctag,name);
  end;

begin


  result := false;
  ST_start_tree_finish := Get_ms;

  endmiddlecount := 0;
  {stop mindless warning}

  h_npn := -1;
  h_spt := -1;
  h_spx := -1;
  h_dpt := -1;
  h_dpx := -1;
  h_dof := -1;
  acount := EndIndex1+1;
  {the indices are 0-based.}
  skip2 := (StartIndex2<0) or (StartIndex2>=count);
  donew := length(newpathsName)>0;

{open the caller's file of paths.}
  if donew then begin
    error :=
    safe_format('FileOpen(newpathsName[%s],fmOpenRead)',[newpathsName]);

    h_npn := FileOpen(newpathsName,fmOpenRead);
    if h_npn<0 then begin
      donew := false;   //leave the file around Thu 3/10/2005 3:26 pm.
      goto ENDNESS;
    end;
  end;

  {--------------------}
  {goto the startindex2 of the source files, unless StartIndex<0, in which
  case just leave them closed. Or if it's the entire kaboosh, in which case
  ditto.}

  if not skip2 then begin
    error := 'getoffsets(StartIndex2,o)';
    if not getoffsets(StartIndex2,o) then
    goto ENDNESS;

    error := 'FileOpen(pathsFile.name,fmOpenReadWrite)';
    h_spt := FileOpen(pathsFile.name,fmOpenReadWrite);
    if (h_spt<0) or (FileSeek(h_spt,o.path,0)<0) then
    goto ENDNESS;

    error := 'FileOpen(picturesFile.name,fmOpenReadWrite)';
    h_spx := FileOpen(picturesFile.name,fmOpenReadWrite);
    if (h_spx<0) or (FileSeek(h_spx,o.pix,0)<0) then
    goto ENDNESS;

  end;

  {--------------------}
  {goto the end of the destination files.}
  error := 'FileOpen(pathsFile.name+tctag,fmOpenReadWrite)';
  h_dpt := FileOpen(pathsFile.name+tctag,fmOpenReadWrite);
  if (h_dpt<0) or (FileSeek(h_dpt,0,2)<0) then
  goto ENDNESS;

  error := 'FileOpen(picturesFile.name+tctag,fmOpenReadWrite)';
  h_dpx := FileOpen(picturesFile.name+tctag,fmOpenReadWrite);
  if (h_dpx<0) or (FileSeek(h_dpx,0,2)<0) then
  goto ENDNESS;

  error := 'FileOpen(offsetsFile.Name+tctag,fmOpenReadWrite)';
  h_dof := FileOpen(offsetsFile.Name+tctag,fmOpenReadWrite);
  if (h_dof<0) or (FileSeek(h_dof,0,2)<0) then
  goto ENDNESS;

  {--------------------}
  {now we'll take the stuff from the newpathsName, and whack it out to the
  destinations.

  //like he says; this is the part where we stick newly-found paths junk into
  the existing debris; i.e. we get a file of new paths, and then we take the
  beginning of the old paths file, stick the new paths on the end, and then --
  after this "donew" section in the middle here, i.e. down there somewhere --
  get the end of the old paths file, and stick that on the end. And of course
  take care of all the offests and pix (what we show in the tree display,
  more-or-less.}

  lnend_length := length(LNEND);

  o.path := FileSeek(h_dpt,0,2);
  o.pix  := FileSeek(h_dpx,0,2);
  o.key := 0;
  o.parent := -1;
  o.above_sibling := -1;
  o.below_sibling := -1;
  error := '(o.pix<0) or (o.path<0)';
  if (o.pix<0) or (o.path<0) then
  goto ENDNESS;

  error := 'while (hgets(h_npn,spath))';

  if donew then
  while (hgets(h_npn,spath)) do begin
    if ((acount and Gscan_n)=0) then begin
      mask_fix(Gscan_n);
      if Gcheck('t_f:new:'+spath) then
      goto ENDNESS;
    end;

    inc(acount);

    spix := tree_pix(spath);
    {create a pix out of a path.}

    if (FileWrite(h_dof,o,sizeof(o))<>sizeof(o))
    or (hprintf(h_dpt,'%s'+LNEND,[spath])<0)
    or
{store the pix.}
    (hprintf(h_dpx,'%s'+LNEND,[spix])<0) then
    goto ENDNESS;

    inc(o.path,length(spath)+lnend_length);
    inc(o.pix,length(spix)+lnend_length);

  end;

  endmiddlecount := acount;

  if skip2 then begin
    result := true;
    goto ENDNESS;
  end;

  {--------------------}
  {now we take the rest of the existing tree and slather it onto this new gang
  of files we're making -- creating, of course, the offsets file
  appropriately.}


{ok now Mon 5/24/04 2:39 pm we're doing to do it all with arithmetic. I found
that the *end* of this process -- this stuff here -- was taking all the time,
and disproportionately of course depending on how far up the tree we were
processing. I.e. if I changed a directory name near the root, it would take
much longer than I did it near the bottom of the tree. ("near the top" "near
the bottom" means "as displayed in the OwenShow tree display" == in the
name.pix file.)

So the ultimate fix is to do the ending part like

  1. figure-out what the offset of the old pix and old path is, for the first
  new ending entry.

  2. Figure-out what the current actual offsets are for the first new ending
  entry.

  3. Compute a difference.

  4. Just go through the source offset file, reading the source values, adding
  the difference, and writing it.

  5. Copy the end of the pix and paths file as blocks.

I believe I use a block scheme already in tree_start. // Yeah or something.
And for that mattter, I did this exact same fix to OwenView yeah this many
years ago or something like it.

}

  error :='not offsetsFile.fopenR';
  if not offsetsFile.fopenR then
  goto ENDNESS;

{ STEP 1. ==================================================== }

{now get the offsets of startindex2, AS THEY WERE.}
  error := 'not getoffsets(StartIndex2,d_o)';
  if not getoffsets(StartIndex2,d_o) then
  goto ENDNESS;

{now get the offsets of the end of the destination path and pix files, which
are the new offsets as they should be.

// Thu 8/05/2004 1:46 pm. They're the "new offsets as they should be" because
(1.) we threw-away everything between EndIndex1 and StartIndex2, (2.) then we
did everything anew, outputting the new pix, path and offsets, to h_dpx,
h_dpt, and h_dof (these files include copies of the old material from 0 to
EndIndex1 at the front of each). So now we're going to look at the old offset
for StartIndex2, and the *current* offset for the end of our h_dpx, h_dpt
files -- which are supposed to be corresponding points in the old and new
tree/pix info. }

{ STEP 2. ==================================================== }

  o.pix  := FileSeek(h_dpx,0,2); {the end of the pix file; current offset}
  o.path := FileSeek(h_dpt,0,2); {the end of the path file; current offset}

{so o.pix is the new offset. d_o.pix is the old offset. o.pix - d_o.pix is the
difference which should be aded to *all* the old offsets.

//Thu 8/05/2004 1:50 pm. Now we concoct difference for the two offsets, the
old startindex2 offsets -- contained in offsets record d_o -- and our current
end-of-file offsets, contained in offets record o. }

{ STEP 3. ==================================================== }

  d_o.pix  := o.pix - d_o.pix;
  d_o.path := o.path - d_o.path;

{now point the source offset handle to where we start, which is startindex2
more-or-less.}

  error := 'FileSeek( offsetsFile.handle,startindex2*sizeof(Roffsets),0)<0';

  if FileSeek( offsetsFile.handle,startindex2*sizeof(Roffsets),0)<0 then
  goto ENDNESS;

{ STEP 4. ==================================================== }
{$ifdef LOG_SCAN}
  logit('tree_finish: STEP4');
{$endif}

  ST_step4_start := Get_ms;
  error := 'not step4(o,d_o,h_dof,acount)';
  if not step4(o,d_o,h_dof,acount) then
  goto ENDNESS;

  ST_step4_stop := Get_ms;

{ STEP 5. ==================================================== }
{$ifdef LOG_SCAN}
  logit('tree_finish: STEP5');
{$endif}

{now let's do step 5.}
  error := 'os_hCopyBlock';
  if (not os_hCopyBlock(h_spt,h_dpt,0,true))
  or (not os_hCopyBlock(h_spx,h_dpx,0,true))
  then
  goto ENDNESS;

  result := true;

  ENDNESS:
  MaybeClose(h_npn);
  MaybeClose(h_spt);
  MaybeClose(h_spx);
  MaybeClose(h_dpt);
  MaybeClose(h_dpx);
  offsetsFile.fclose;
  MaybeClose(h_dof);

  if not result then
  goto ENDNESS_2;

  {--------------------}
  {Ok that was fun. *now* we have to fix the pix we just concocted.}

  if fixstart>=0 then begin

    result := tree_fxpx(fixstart,fixend,acount,
    offsetsFile.Name+tctag,
    picturesFile.name+tctag
    );

  end else begin

    if EndIndex1<0 then
    EndIndex1 := 0;

{"value assigned to 'StartIndex2' never used"}
//    if StartIndex2<0 then
//    StartIndex2 := count-1;

    result := tree_fxpx(EndIndex1,endmiddlecount+1,acount,
    offsetsFile.Name+tctag,
    picturesFile.name+tctag
    );

  end;

{****************************************************************************
****************************************************************************}

  if result then begin
    result := false;

    if donew then
    DeleteFile(newpathsName);

    if not infoFile.FopenR then
    goto ENDNESS_2;     {so near yet so far.}
{error exit to wrong place until Monday, June 28, 2004 11:44 am.}

    count := acount;

    infoFile.inif.WriteInteger(infohead,'count',count);
    InfoFile.fclose;

{the actual exit thingey.}
    detemp(pathsFile.name);
    detemp(picturesFile.name);
    detemp(offsetsFile.Name);


    result := true;

  end;

  ENDNESS_2:

  if not result then
  errorf('Error in scan (tree_finish:%s)',[error]);

  ST_end_tree_finish := Get_ms;
  ST_valid := true;

{$ifdef LOG_SCAN}
  logit('tree_finish: end');
{$endif}

end;

{****************************************************************************
re-scan the subdirectories of what; if newonly, only subdirs not present in
the current tree file; if maxlevel>0 then scan only to that depth.
****************************************************************************}
{.$define DEBUG_pac}
{Mon 1/13/03 5:34 pm. disappearing directory problem. When I would scan
/usr/lib/qt3-gcc3.2, the doc subdirectory wouldn't itself have any
subdirectories. But when I'd scan /usr/lib/qt3-gcc3.2/doc, hordes of subdirs.
This because doc was a symlink. So I put a dangerous "Sys OK" button on the
Linux version which defaults to off.}

{.$define DEBUG_pf8}
{Now in a new xp laptop I got.}

type
dir_tag = class
  recurseme : boolean;
  exclude_level : integer;
end;


function Ttree.new_scan(what:integer; newonly:boolean; maxlevel:integer;
newone:string = '' ):boolean;
var
exclude_level : integer;    //a "global" for recurse_children.
r,
rut:boolean;
sibling,
dh,
{levels, }
slevel,               {level of what}
newlevel,             {the level in which to check newonly}
thislevel : integer;  {the current level.}

{****************************************************************************
| | |-junk
| | | |-_1b
| | | |-`bingo-bongo
| | | |-1_ro
| | | | `-2_ro
| | | |-awongo
| | | |-owen
| | | | `-junk
| | | |-seven
| | | | `-1
| | | `-wongo

newonly_tops would             newonly_leaves
contain a list like

  _1b                          _1b
  `bingo-bongo                 `bingo-bongo
  `_ro                         1_ro   2_ro
  awongo
  owen
  seven
  wongo

the object in the tops list would contain the newonly_leaves list. So it never
actually exists. // well actually it exists to collect this stuff.

The plan is the fixonly routine will will-up its collection of existing stuff,
pretty-much the way it did with nlist.

Then recurse_children will do the same thing for the dirs *it* scans.

Then we can sort the tops list which will NOT sort the leaves -- which is what
I want.

****************************************************************************}
newonly_tops:TStringList;
j,i:integer;
tpaths:string;
label
BADNESS;

{****************************************************************************
FIXONLY, EZSORT VERSION

if newonly argument to scan is true, fixonly translates the existing paths
file into the stringlist newonly_tops. Each entry in newonly_tops is a
top-level directory in the section; each objects in newonly_tops is a
stringlist itself, containing the top-level directory name, and all the
subdirectory names. I.e., just as they came from the existing paths file.

****************************************************************************}

  function fixonly:boolean;
  var
  fixhi,
  thislevel,
  newlevel,
  src,
  i:integer;
  s:string;
  o:Roffsets;
  fx_leaves:TStringList;
  label
  BADNESS;

  begin

//init a special list which we will write to instead of the tpaths file.
    newonly_tops := jgo_slist;
    fx_leaves := nil;

    result := false;    {assume failure.}

    o.path := 0;      //make a pretend offset for path.
    getoffsets(what+1,o);
//if it doesn't get it, tough.

    newlevel := level(what)+1;

    src := FileOpen( pathsFile.name ,fmOpenRead);

    if (src<0)
    or (FileSeek(src,o.path,0)<0) then
    goto BADNESS;

{Thu 5/01/03 11:07 am. Wasn't seeing only new in root scans -- where it's
needed most! Because sibling for rut is set to -1 -- which jiggers various
other parts of this edifice -- but of course didn't work here.}
    if sibling<0 then
    fixhi := count-1
    else
    fixhi := sibling-1;

    for i := what+1 to fixhi do begin

      if not hgets(src,s) then
      goto BADNESS;

    {we store the paths without trailing slashes. But we produce them *with*,
    i.e. with level(). I'm examining the path file directly, where there are
    no trailing slashes. So I add 1.}
      thislevel := slashlevel(s)+1;

//      fixonly_list.add(s);
      if (thislevel=newlevel)
      then begin
        fx_leaves := jgo_slist;
        newonly_tops.addobject(s,fx_leaves);
      end;

      if fx_leaves<>nil then   //shouldn't happen.
      fx_leaves.add(s);
{****************************************************************************
I'm just adding all the subdirs I'm reading in here; but I left a sortable rut
in newtops. This process converts the read-in subdirs tree into a structure
like

    newonly_tops: adir   -->  fxy_leaf: adir
                                          asub
                                            asub
                                          maybe another sub

    another

etc.

****************************************************************************}

    end;

    result := true;

    BADNESS:
    if src>=0 then
    FileClose(src);

{$ifdef LINUX}
    newonly_tops.casesensitive := true;
    //so searchs in recurse_children will work for different-cased dirs.
{$endif}

  end;


{dh_open will append to any existing version of dst. This is intended; it's
supposed to work with the fixonly hallucination.}
  function dh_open:boolean;
  begin
    result := true; {assume success.}

    if dh>=0 then
    exit;

    dh := FileOpen(tpaths,fmOpenReadWrite);

    result := dh>=0;

    if result then
    FileSeek(dh,0,2);

  end;

  procedure dh_close;
  begin
    if Goptions.debugscan then begin
      FileClose(dh);
      dh := -1;
    end;
  end;

{****************************************************************************
****************************************************************************}
{$define DONT_SHORT}
  function recurse_children(parentdir:string ;
  only_leaves:TStringList):boolean;

  var
  F:TsearchRec;
  dummy,
  ffresult:integer;
  fullname,
  curslash:string;
  changed_dir : boolean;

  i:integer;
  dirlist:TStringList;
  ended:boolean;

  this_tag : dir_tag;
  e_l : integer;     //a little temp.

  label
  EZENDNESS,
  NEXTDIR,
  ENDNESS  ;

    function go_away:boolean;
    begin

      mask_fix(Gscan_n);

{$ifdef DONT_SHORT}
      result := Gcheck('scan:'+parentdir+slashchar+f.name);
{$else}
      result :=
      Gcheck(safe_format('scan:%s:%s',
      [
      shortstring(parentdir,10,true),
      shortstring(f.name,25,true)
      ]))
      ;
{$endif}


      if result then begin
        ended := true;
      end;

    end;

  begin
    result := true;   {assume success.}

    dirlist := jgo_slist;
    ended := false;

{$ifdef DEBUG_pac}
    if parentdir='/usr/lib/qt3-gcc3.2/doc' then begin
      osinfof('It''s /usr/lib/qt3-gcc3.2/doc');
    end;
{$endif}

    if (thislevel = maxlevel)
    or (thislevel = exclude_level)
    then begin
      exit;
    end;

    changed_dir := false;   {result from try chdir.}

    try
      chdir(parentdir);
      changed_dir := true;
    except
      on E: Exception do begin
        if Goptions.scantalk then
        errorf('(scantalk) new_scanpaths(%s) e.message: %s',
        [parentdir,E.Message]);
  {        childrenok := false;  }
  {that's wrong. We have to assume some scans will fail.}
      end
    end;

    if not changed_dir
    then exit;          {with result = true.}

    result := false;    {ok NOW we do failure.}

    curslash := fslash(parentdir);

    inc(thislevel);

    ffresult := findfirst('*',

  {$WARN SYMBOL_PLATFORM OFF}    {see comment at fahidden above}
    faHidden or
    faReadOnly or
    faSysFile or
  {$WARN SYMBOL_PLATFORM ON}
    faDirectory

    ,F);


    while (ffresult=0) do begin

      inc(Gcheck_count);
      if ((Gcheck_count and Gscan_n)=0)
      and go_away then
      goto ENDNESS;

{$ifdef DEBUG_pf8}
      osinfof('Dir:%s',[f.name]);
{$endif}
      if not decentdirectory(F) then
      goto NEXTDIR;

      fullname := curslash+f.name;

{$ifdef DEBUG_pac}
      if fullname='/usr/lib/qt3-gcc3.2/doc' then begin
        osinfof('It''s /usr/lib/qt3-gcc3.2/doc');
      end;
{$endif}

      if (exclude_level<0) then begin
      //if not doing global exclude_level already.
        if exclude.find(fullname,dummy)
        then begin
          e_l := integer(exclude.objects[dummy]);
          if e_l < 0 then   //-1 means for this directory.
          goto NEXTDIR;
        end else
        e_l := -1;
        //e_l/this_tag.exclude_level of -1 means no exclude.
      end else begin
        e_l := -1;
      end;

      this_tag := dir_tag.create;
      this_tag.exclude_level := e_l;
      dirlist.addobject(f.name,this_tag);
        //the actual execution of this nonsense occurs in the loop below or
        //something.

  {$ifdef LINUX}
  {$WARN SYMBOL_PLATFORM OFF}
      if (not LinuxSys) and ((F.attr and faSysFile)<>0) then
  {$WARN SYMBOL_PLATFORM ON}
      goto NEXTDIR;
                    {In Linux, file is socket, symbolic link, device file, or
                    FIFO. We'll stick it on the tree, but not explore. Someday
                    we should make it a different color or something but I
                    gather that's *really* challenging.... Oh here u are
                    ttreenode.imageindex; you could put a picture or
                    something.... Monday, August 5, 2002 3:58 pm / of course the
                    Ttree component was not actually functional.... But now it's
                    a memo I could probably figger-out some way to change the
                    color-- but I won't.}
  {$endif}

      this_tag.recurseme := true;
      //a marker meaning "recurse" this one.

      NEXTDIR:
      ffresult := findnext(f); {get the next, if any}
    end;

    ENDNESS:
    findclose(f);

    if ended then
    goto EZENDNESS;

{****************************************************************************
in ezsort we do all the work here, after gathering the names. (Nothing really
ez about it, is there?)
****************************************************************************}

    stupid_string_sort(dirlist);

    for i := 0 to dirlist.count-1 do begin
      inc(Gcheck_count);
      if ((Gcheck_count and Gscan_n)=0)
      and go_away then
      goto EZENDNESS;

      fullname := curslash + dirlist[i];


{****************************************************************************
here we implement the idiotic scan new directories only feature.
(Note that the EXCLUDE_LEVELS feature doesn't/shouldn't affect this, except if
level is -1 the directory name is disappeared even from this list.)
****************************************************************************}

      if (newlevel=thislevel) then begin

{****************************************************************************
this is the level where we don't do anything other than

1. add a new entry to newonly_tops, and scan its subdirs to a leaf thing.

or

2. skip it.

****************************************************************************}

        if (newonly_tops.IndexOf(fullname) < 0)
//we should add it, scan it.
        and
        (
        (newone='')
        or
{$ifdef MSWINDOWS}
        SameText(newone,dirlist[i])
{$endif}
{$ifdef LINUX}
        (newone=dirlist[i])
{$endif}
        )
        then begin
          only_leaves := jgo_slist;
          newonly_tops.addobject(fullname,only_leaves);
          only_leaves.add(fullname);  //it's the way it works.
        end else
        continue;   //the for; that is, get another dirlist entry.

      end else begin

{****************************************************************************
this code is what happens if we're not a new directories top level. If
only_leaves is non-nil, however, we've been CALLED by a new directories top
level thingoid, and we should add names to the leaf there. Else we actually
output the directory name to the paths file.
****************************************************************************}

        if only_leaves <> nil then
        only_leaves.add(fullname)
        else if dh_open then
        hprintf(dh,'%s'+LNEND,[fullname]);
  //i don't error-check here. bad bad.

      end;

{****************************************************************************
Now, still in the EZSORT version, we recurse. We pass the only_leaves arg as
appropriate.
****************************************************************************}

      this_tag := dirlist.objects[i] as dir_tag;

      if this_tag.recurseme then begin
        if this_tag.exclude_level>-1 then begin
//this won't happen if exclude_level is already > -1.
          exclude_level := this_tag.exclude_level + thislevel;
          if not recurse_children(fullname,only_leaves) then
          goto EZENDNESS;    //the for. Because that's what he does above.
          exclude_level := -1;
        end else begin
          if not recurse_children(fullname,only_leaves) then
          goto EZENDNESS;    //the for. Because that's what he does above.
        end;
      end;

    end;

    result := true;   {the only place result becomes true.}

    EZENDNESS:

    for i := 0 to dirlist.count-1 do
    (dirlist.objects[i] as dir_tag).free;

    dirlist.free;

    dec(thislevel);

  end;

begin
  refix_again(true);

{$ifdef LOG_SCAN}
  logit('new_scan: begin');
  logSizes;
{$endif}

  exclude_level := -1;    //init recurse_children "global" to nothing.

  result := false;
  newonly_tops := nil;

  dh := -1;     {set-up mechanism to make outputs. //this wasn' there until
  Friday, January 7, 2005 6:11 pm.}

  ST_begin;

  rut := (what=0);

  tpaths := os_temporary;

  if rut then
  sibling := -1
  else
  sibling := next_sibling(what);

{do something about levels.}
  slevel := level(what);
  thislevel := slevel;

  if maxlevel>0 then
  inc(maxlevel,slevel)
  else
  maxlevel := -1;

{$ifdef cuteP_S}
  nocute := true;
{$endif}

{deal with newonly.}
  if newonly then begin
    if not fixonly then
    goto BADNESS;
    newlevel := slevel + 1;
    dh := StupidNewFile(tpaths,true);
    if dh<0 then
    goto BADNESS;
  end else begin
    newlevel := -1;   {this prevents GPF access of nlist=nil.}
    dh := StupidNewFile(tpaths,true);
    {create/open the file. The true opens it in fmopenreadwrite, which might
    be necessary if Goptions.debugscan. }
    if dh<0 then
    goto BADNESS;
  end;

  r := recurse_children(gp(what) ,nil );

  if newonly_tops<> nil then begin
{$ifdef LINUX}
    newonly_tops.casesensitive := false;
{$endif}

    stupid_string_sort(newonly_tops);
//this works here, because we DON'T find on newonly_tops.

{****************************************************************************
We had to accumulate everything, instead of emitting them as we go. And then
we sort them.
****************************************************************************}
    for j := 0 to newonly_tops.count-1 do
    with TStringList(newonly_tops.objects[j]) do begin
      for i := 0 to count-1 do begin
        hprintf(dh,'%s'+LNEND,[strings[i]]);
      end;
      free;
    end;
  end;

  ST_end_scan := Get_ms;
  if (not r) then
  goto BADNESS;

  if dh>=0 then begin
    FileClose(dh);
    dh := -1;
  end;

  if (not tree_start(what))
  or (not tree_finish(what,sibling,tpaths))
  then
  goto BADNESS;

  result := true;

  BADNESS:
  osdirectory;      {scan changes directories, so.}

  if dh>=0 then
  FileClose(dh);

  DeleteFile(tpaths);


  freeandNil(newonly_tops);

  invalidateParentSibling;

{$ifdef LOG_SCAN}
  logSizes;
  logit('new_scan: end');
{$endif}

  mask_fix(Gscan_n,true);    //erase dbg message maybe.

end;

{****************************************************************************

| | | | |-Crypto                    7
| | | | | |-DSS                     8     which
| | | | | | `-MachineKeys           9
| | | | | `-RSA                    10
| | | | |   `-MachineKeys          11
| | | | |-HTML Help                12      sibling

12-7-1 ==> children.

Mon 11/25/02 4:30 pm. I have to fixpix from the parent to which or something,
i.e. we remove say RSA and RSA/MachineKeys up there and wind-up with

| | | | | |-DSS                     8     which
| | | | | | `-MachineKeys           9
| | | | |-HTML Help                12      sibling

which is broken there above HTML. So sibling is where which was before & etc
ad nauseum....

****************************************************************************}

function Ttree.new_deldir(which:integer):boolean;
var
theparent, thesibling:integer;
begin
  refix_again(true);

{$ifdef LOG_SCAN}
  logit('new_deldir: begin');
  logsizes;
{$endif}

  ST_begin;

  purge_directory(getpath(which));  {in main.}

  theparent := parent(which);
  thesibling := next_sibling(which);

{$ifdef cuteP_S}
  nocute := true;
{$endif}

  result :=
  tree_start(which-1) and
  tree_finish(which-1,thesibling,'',
  theparent,which);

{$ifdef LOG_SCAN}
  logsizes;
  logit('new_deldir: end');
{$endif}

  invalidateParentSibling;

  mask_fix(Gscan_n,true);    //erase dbg message maybe.

end;

{****************************************************************************
****************************************************************************}
function Ttree.new_renameDir(which:integer; newname:string):boolean;
var
i,
sh,
dh,
thetop,       {the area we got to get so... }
thebottom,    {... we can sort it.}
sibling,
oldlength,
oldindex:integer;
error,
s,
dst,
oldpath:string;
o:Roffsets;
dirlist:TStringList;
label
BADNESS;
begin
  refix_again(true);

{$ifdef LOG_SCAN}
  logit('new_rename: begin');
  logsizes;
{$endif}


  ST_begin;

  dirlist := jgo_slist;

  result := false;

  dh := -1;
  sh := -1;

  sibling := next_sibling(which);

{figure out the entire area we need to destroy.}
  thetop := parent(which);
  thebottom := next_sibling(thetop)-1;
  inc(thetop);

{$ifdef cuteP_S}
  nocute := true;
{$endif}

  oldpath := gp(which);
  oldindex := revpos(slashchar,oldpath);
  {this depends on path with no trailing /.}

  oldlength := length(oldpath) - oldindex;
  inc(oldindex);

  error := 'getoffsets(thetop,o)';
  if not getoffsets(thetop,o) then
  goto BADNESS;

  dst := os_temporary;
  dh := StupidNewFile(dst);

  error := 'StupidNewFile(dst)';
  if dh<0 then
  goto BADNESS;

  sh := FileOpen(pathsFile.name,fmOpenRead);

  error := 'FileOpen(pathsFile.name,fmOpenRead) or FileSeek(sh,o.path,0)';
  if (sh<0)
  or (FileSeek(sh,o.path,0)<0)
  then
  goto BADNESS;

  for i := thetop to thebottom do begin
    error := 'hgets(sh,s)';
    if not hgets(sh,s) then
    goto BADNESS;

    inc(Gcheck_count);
    if ((Gcheck_count and Gscan_n)=0) then begin
      mask_fix(Gscan_n);
      error := '';    //no error of course.
      if Gcheck('rename:'+s) then
      goto BADNESS;
    end;

    if (i>=which)
    and (i<=(sibling
    -1
    )) then begin
    {the -1 is wrong Thursday, March 10, 2005 5:58 pm! I wasn't renaming
    the *last* subdirectory o folly! // Tuesday, March 15, 2005 12:48 pm.
    oh folly indeed; it's still broken.}
      dirlist.add(
      safe_format('%s%s%s',
      [
      copy(s,1,oldindex-1),
      newname,
      copy(s,oldindex+oldlength,10000)
      ])
      );
    end else
    dirlist.add(s);

  end;

{$ifdef STUPIDCASEBUG_rLB}
  stupid_dir_sort(dirlist);
{$else}
  stupid_string_sort(dirlist);
{$endif}

  for i:=0 to dirlist.count-1 do begin
    hprintf(dh,'%s'+LNEND,[dirlist[i]]);
  end;

  MaybeClose(sh);   {it sets them to -1.}
  MaybeClose(dh);

  result :=
  tree_start(thetop-1) and
  tree_finish(thetop-1,thebottom+1,dst);

  if result and (which=selected) then
  select;

  BADNESS:

  dirlist.free;

  maybeclose(sh);
  maybeclose(dh);

  invalidateParentSibling;

{$ifdef LOG_SCAN}
  logsizes;
  logit('new_rename: end');
{$endif}

  mask_fix(Gscan_n,true);    //erase dbg message maybe.

  if (not result)
  and (length(error)>0) then
  errorf('Error in new_renameDIR:%s',[error]);

end;

{****************************************************************************
have to emit the whole section so tree_finish can sort it? That seems unduly
harsh.... I.e. it would mean if I wanted to add a directory on the root, I'd
have to sort the whole )(*&() thing.... Oh well let's do it that way now; we
can always cheat later if it's too annoying (i.e. find its sorted position in
the current directory and then insert it right there.) // Thu 9/15/2005 11:37
am. that is apparently what I did eventually; however now we are in the latter
days of EZSORT -- because the pdsortx strategy actually never worked with
differing-in-case-only directories.
****************************************************************************}

function Ttree.new_addDir(add_parent:integer; name:string):boolean;
var
i,
sibling,
sh,           {source}
dh:integer;   {destination handle}
error,
s,
dname:string;
o:Roffsets;

dirlist:TStringList;

label
BADNESS;
begin
  refix_again(true);

{$ifdef LOG_SCAN}
  logit('new_addDir: begin');
  logsizes;
{$endif}

  ST_begin;

  dirlist := jgo_slist;

  result := false;
  dh := -1;
  sh := -1;

  sibling := next_sibling(add_parent);

{$ifdef cuteP_S}
  nocute := true;
{$endif}

  if (add_parent+1)=count then begin
    o.path := os_fSize(pathsFile.name);
    o.pix := os_fSize(picturesFile.name);

{Fri 1/10/03 7:04 pm. We cheat for special case. I believe I wrote Ttree with
this in mind, since it's an obvious possiblity -- adding a directory at the
end of the tree. For instance, next_sibling knows about it, and produces a
bogus value equal to the directory count, i.e. the entry *below* the current
tree. But getoffsets is used in so many places, I didn't want to fool with it,
and I think I really need the special case only here. Note that the seek below
works, but if you *read* it, it'd fail; but it won't because add_parent+1 <
sibling-1. And I gather tree_finish knows. }

  end else begin
    error := 'getoffsets(add_parent+1,o)';
    if not getoffsets(add_parent+1,o) then
    goto BADNESS;
  end;

  dname := os_temporary;
  dh := StupidNewFile(dname);

  error := safe_format('StupidNewFile(dname[%s])',[dname]);
  if dh<0 then
  goto BADNESS;

  dirlist.add(
  safe_format('%s%s',[fslash(gp(add_parent)),name])
  );

{now open the paths file.}
  sh := FileOpen( pathsFile.name ,fmOpenRead);

  error :=
  safe_format('FileOpen(pathsFile.name[%s],fmOpenRead) or'+
  'FileSeek(sh,o.path,0)<0',[pathsFile.name]);

{seek to the place where our guy will go.}
  if (sh<0) or (FileSeek(sh,o.path,0)<0) then
  goto BADNESS;

{Oh I see, I'm copying a tiny chunk of the paths that *has to get sorted*.

  \gregor\OwenShow\doc\thoma2             add_parent
  \gregor\OwenShow\doc\thoma2\Demo        add_parent+1
  \gregor\OwenShow\doc\thoma2\Par
  \gregor\OwenShow\doc\thoma2\Pas         sibling-1
  \gregor\OwenShow\doc\thoma3             sibling

If I want to add a subdirectory to thoma2, I only have to sort Demo, Par, Pas,
and the new subdirectory.
}

  error := 'not hgets(sh,s)';

  for i := add_parent+1 to sibling-1 do begin
    if (not hgets(sh,s)) then
    goto BADNESS;

    dirlist.add(s);
  end;

{$ifdef STUPIDCASEBUG_rLb}
  stupid_dir_sort(dirlist);
{$else}
  stupid_string_sort(dirlist);
{$endif}

  error := 'hprintf(dh)<0';

  for i := 0 to dirlist.count-1 do begin
    if hprintf(dh,'%s'+LNEND,[dirlist[i]])<0 then
    goto BADNESS;
  end;

  maybeclose(sh);
  maybeclose(dh);

{then I call tree_start with the stuff *above* what I'm changing, and
tree_finish with the stuff below, and the third argument, the name of the file
I just concocted.}

  result :=
  tree_start(add_parent) and
  tree_finish(add_parent,sibling,dname);


  BADNESS:
  maybeclose(sh);
  maybeclose(dh);

  dirlist.free;

  invalidateParentSibling;

{$ifdef LOG_SCAN}
  logsizes;
  logit('new_addDir: end');
{$endif}

  mask_fix(Gscan_n,true);    //erase dbg message maybe.

  if not result then
  errorf('Error in new_addDir:%s',[error]);

end;

{****************************************************************************
****************************************************************************}
function Ttree.rut:string;  {return the rut name.}
begin
  result :=
{$ifdef MSWINDOWS}
  drive + ':' +
{$endif}
  SLASHCHAR;
end;


{****************************************************************************
****************************************************************************}
{$OPTIMIZATION OFF} {enormous arithmetic works better?}
function tiempo(milliseconds: os_ticks):string;
var
seconds,
ms:int64;

begin
  ms := milliseconds mod 1000;
  milliseconds := milliseconds div 1000;

  seconds := milliseconds mod 60;
  milliseconds := milliseconds div 60;

  if milliseconds = 0 then    {but its minutes now}
  result := safe_format('%d.%s',[seconds,formatint(ms,3)])
  else
  result := safe_format('%d:%s.%s',[milliseconds,
  formatint(seconds,2),formatint(ms,3)]);

end;

{Tuesday, December 9, 2003 10:47 am. This is *only* used by main goto_home,
which calls it once if the specified homedir doesn't exist. It stuffs the
error into ierr, which will be displayed by etc / info, but it also starting
today puts up an error box, because I never remembered the etc/info
nonsense.}
var
ierr : string;

function infoerror(const TheFormat: string;
const Args:array of const):string;
begin
  result := DateTimeToStr(Now) + ': ' +
  safe_format(TheFormat,Args);

  ierr := LNEND+'(infoerror) '+result;


//  ierr := LF+DateTimeToStr(Now) + ': ' +
//  safe_format(TheFormat,Args);
//  result := ierr;
end;


procedure infotalk;
var
ratetalk,
halttalk,
timetalk:string;
const
tla_date =
  'time stamp: '+
  sJGO_MON + '/' +
  sJGO_DATE + '/' +
  sJGO_YEAR + ' ' +
  sJGO_HOUR + ':' +
  sJGO_MIN + LF;

begin
  if Glast_rate_per_minutes<>'' then
  ratetalk :=
  safe_format('copy/move %s bytes/minute'+LNEND,[Glast_rate_per_minutes])
  else
  ratetalk := '';

  if ST_valid then
  timetalk :=
  safe_format(

  'total time: %s'+LF+
  'scan time: %s'+LF+
  'tree_start time: %s'+LF+
  'tree_finish time: %s'+LF+
  'step4 time: %s'+LF+
  'fix time: %s'
  ,
  [
  tiempo(ST_end_tree_finish-ST_start),
  tiempo(ST_end_scan-ST_start),
  tiempo(ST_end_tree_start-ST_start_tree_start),
  tiempo(ST_end_tree_finish-ST_start_tree_finish),
  tiempo(ST_step4_stop-ST_step4_start),
  tiempo(ST_end_tree_fxpx-ST_start_tree_fxpx)

  ])


  else
  timetalk := 'no valid scan time';

  timetalk := tla_date + timetalk + LF +
  safe_format('file sort: %s',[tiempo(ST_sort_done - ST_sort_start)]);

  if Goptions.halt then
  halttalk := '; exit with halt(0)'
  else
  halttalk := '';

//         1                        2
  osinfof('%s'+LNEND+
  'fls[%d]: %s'+LNEND+
//      3 4 5
  'os: %s%s%s'+LNEND+
//      6 7
  'ini: %s' {'%s'}
{$ifdef DBG_SEEK}
  +Glastinversion
{$endif}
  +LNEND+
  ratetalk+
  'checkspeed:$%x, %d'+LNEND+
  'checkmod:%d'+LNEND+
  'pgmdir:%s'+LNEND+
  'datadir:%s'+LNEND+

  'path:'+LNEND+'%s'

  , //1      2       3      4       5     6       7
  [timetalk,
  file_selected_index, form1.thisfv.fls[file_selected_index],
  ostag,halttalk,ierr,ininame, {pdtalk,}
  Goptions.checkspeed, Goptions.checkspeed,
  Goptions.checkmod,
  pgmdir,
  datadir,
//  getenvironmentvariable('PATH')
  pathlist_s
  ]);

end;

{$OPTIMIZATION ON}

{****************************************************************************
****************************************************************************}

procedure Ttree.xxinfo;
begin
  if xinfo>0 then begin
{$ifdef MSWINDOWS}
    if xinfo<2 then
    pix.bignote(uppercase(drive){+':'},selected-screen_top,xinfo_big)
    else
{$endif}
    pix.bignote(
    copy(name,xinfo_skip+1,xinfo)+' ',
    selected-screen_top,
    xinfo_big);
  end;
end;

{****************************************************************************
I have the pix.show() mechanism to suppress display, which is executed in
jdisplay. But then I optimized that, so it'd show the selection now and then
even if it didn't paint the whole directory -- which wrecked the directory
delete code, which also desired the display to stop, but *didn't* want the
selection shown. So now we have two mechanisms, one in here, one in jdisplay.
The one in here really looks more sensible I must say. // Well I sort-of see
the point; the pix one covers everything, even things I may concoct in the
future when I've forgotten about the pix mechanism. The freeze mechanism in
here is supposed to just do nothing for a particular thing. Ah but it's all so
complicated. At least I managed to throw-out bunches of code today Wed
12/17/03 4:19 pm.
****************************************************************************}

procedure Ttree.freeze(doit:boolean = true);
const
reshow : boolean = false;
begin
  froze := doit;
  if froze then begin
    if not pix.dontshow then
    reshow := true;     {need to show on again.}
    pix.show(false);    {turn off jdisplay show.}
  end else begin
    if reshow then
    pix.show(true);
    reshow := false;
  end;
end;

{****************************************************************************
Goes through the pathsname file and removes directory entries at the depth or
greater from the rut directory specified. *Caller* must do something with the
result -- do a reconstruct tree I think.
****************************************************************************}
type
Eos = class(exception);

function Ttree.forget_dirs(rut,depth:integer):boolean;
var
s:string;
thislevel,
forgetlevel,
rutlevel, index, src, dst:integer;
label
ENDNESS;

begin
{$ifdef LOG_SCAN}
  logit('forget_dirs: begin');
{$endif}


  result := false;    {failure}

{  src := -1;  }
  dst := -1;

  rutlevel := level(rut)-1;
  {see comments around sbrs slashlevel.}

  forgetlevel := rutlevel + depth;

  src := FileOpen(pathsFile.name,fmOpenRead);
  if src<0 then
  goto ENDNESS;

  dst := StupidNewFile(pathsFile.Name+tctag);
  if dst<0 then
  goto ENDNESS;

{now process the entire thing *before* our area.}
  for index := 0 to rut do begin

    {
    700 OK
    1000
    1050
    1075
    1082
    1091
    1092
    }
{
    if index=1092 then begin
      infof('index=%d; s="%s"',[index,s]);
//      goto ENDNESS;
    end;
}
    {
    1093
    1096
    1100
    1200
    1500 bad
    }

    if not hgets(src,s) then
    goto ENDNESS;

    if ((index and Gscan_n)=0) then begin
      mask_fix(Gscan_n);
      if Gcheck('forget_dirs:'+s) then
      goto ENDNESS;
    end;

    if hprintf(dst,'%s'+LNEND,[s])<0 then
    goto ENDNESS;

{
    try
      if not hgets(src,s) then
      raise Eos.createFmt('hgets(%s)',[s]);

      if hprintf(dst,'%s'+LNEND,[s])<0 then
      raise Eos.createFmt('hprintf(%s)',[s]);

      continue;

    except on E: exception do
      errorf('s:"%s" e:%s',[s,e]);
    end;

    goto ENDNESS;

}
  end;

{we don't care about the index anymore now.}

{ok we're at the directory after the rut, and we're going to check each
directory for its level, and deal with it.}
  while true do begin
    if not hgets(src,s) then
    break;      {it's a legal ending.}

    thislevel := slashlevel(s);

    if thislevel<forgetlevel then begin
      {otherwise, if >=forgetlevel, don't.}
      if hprintf(dst,'%s'+LNEND,[s])<0 then
      goto ENDNESS;
    end else
    purge_directory(s);   {in main}

    if thislevel=rutlevel then
    break;

    inc(Gcheck_count);
    if ((Gcheck_count and Gscan_n)=0) then begin
      mask_fix(Gscan_n);
      if Gcheck('forget_dirs:'+s) then
      goto ENDNESS;
    end;

  end;

{now we do the stuff after the area.}
  while (hgets(src,s)) do
  hprintf(dst,'%s'+LNEND,[s]);

  FileClose(src);
  FileClose(dst);
{****************************************************************************
So I left out the next two lines -- which made the code at ENDNESS close the
files twice -- and it did an "external exception". This exception apparently
had to power to go back in time, since I *couldn't* breakpoint on various
points above here and had to go through the thing bit by bit -- i.e. binary
search. That's why we love these easy-to-debug integrated environments.
****************************************************************************}
  src := -1;
  dst := -1;

  DeleteFile(pathsFile.Name);
  RenameFile(pathsFile.Name+tctag,pathsFile.Name);

  result := true;


  ENDNESS:
  if src>=0 then
  FileClose(src);

  if dst>=0 then
  FileClose(dst);

end;

{****************************************************************************
to use this fabulous code, just rename all the FileOpen and FileClose to
jgo_etc. Probably should make out will first too.... // Fri 6/25/2004 5:54 pm
this is something that the new improved TTreefile classes would've fixed.
****************************************************************************}
{$ifdef That_was_sad}
var
paths_count, paths_handle: integer;

function jgo_FileOpen(const FileName: string; Mode: LongWord): Integer;
begin
  result := FileOpen(FileName,Mode);

  if FileName=thetree.pathsname then begin
    if paths_count>0 then
    infof('bad paths_count');

    if result>=0 then

    inc(paths_count);
    paths_handle := result;
  end;
end;

procedure jgo_FileClose(Handle: Integer);
begin
  if (paths_count>0) then begin
    if (handle=paths_handle) then
    dec(paths_count);
  end;

  FileClose(Handle);
end;
{$endif}


{****************************************************************************
****************************************************************************}

constructor Ttreefile.Create(n:string; is_ini:boolean = false);
begin
  inherited Create;
  handle := -1;
  name := n;
  ini := is_ini;
  inif := nil;
  opencount := 0;
end;

destructor Ttreefile.Destroy;
begin

  fCloseAnyway;

  inherited destroy;

end;

function TTreefile.FopenR: boolean;
begin
  if ini then begin
    if inif=nil then
    inif := Tinifile.create(name);
    result := inif <> nil;
    exit;
  end;

  if handle<0 then begin
    handle := FileOpen(name,fmOpenRead);
    opencount := 0;
  end else begin
    inc(opencount);
    FileSeek(handle,0,0); {seek to beginning, eh?}
  end;

  result := handle >= 0;
end;


function TTreefile.fClose:boolean;
begin

  if opencount>0 then begin
    result := false;
    dec(opencount);
    exit;
  end;

  result := true;

  if ini then begin
    if inif<>nil then
    inif.UpdateFile;    {forgot until Tue 7/13/2004 6:08 pm. Makes development
    environment version selectively forget file count?}
    freeandnil(inif);
    exit;
  end;

  if handle<0 then
  exit;

  FileClose(handle);
  handle := -1;
end;

function Ttreefile.fexist:boolean;
begin
  fcloseanyway; //changed to anyway Thursday, August 5, 2004 2:04 pm.
  result := FileExists_unq(name);
end;

procedure Ttreefile.fcloseanyway;
begin
  opencount := 0;
  fclose;
end;

procedure Ttreefile.fdelete;
begin
  fclose;
  DeleteFile(name);

end;

{$ifdef DEBUG_TREE_OPEN}
procedure checkopen(t:Ttree);
begin

  if
//  true or
  (t.infoFile.opencount>0) or
  (t.pathsFile.opencount>0) or
  (t.picturesFile.opencount>0) or
  (t.offsetsFile.opencount>0) then
  dbg('%s: info:%d paths:%d pictures:%d offsets:%d',
  [
  t.infofile.name,
  t.infoFile.opencount,
  t.pathsFile.opencount,
  t.picturesFile.opencount,
  t.offsetsFile.opencount
  ]
  );

end;
{$endif}

{****************************************************************************
****************************************************************************}


destructor TTree.destroy;
begin
  freeandnil(exclude);  //added Thursday, February 2, 2006 1:54 pm.
  freeandnil(infoFile);
  freeandnil(pathsFile);
  freeandnil(picturesFile);
  freeandnil(offsetsFile);
end;

procedure Ttree.decode_alwayshome(value:integer);
begin
  alwayshome := false;
  enterhome := false;

  case value of
    1: alwayshome := true;
    2: begin
      alwayshome := true;
      enterhome := true;
      {any file enter thingey makes home. Like OV. }
    end;
  end;
end;

constructor Ttree.create (n:string) ;
begin
  inherited Create;

//implement global defaults here. So they're good if it's made-up.

  name := n;

  if name='' then
  name := 'nada';

  pathsFile := TtreeFile.create(punc_blr(name));

  rootwarning := true;

  decode_alwayshome(Goptions.alwayshome);

{$ifdef MSWINDOWS}
  drive     := lowercase(name[1]);
{$endif}

  xinfo         := Goptions.xinfo;
  xinfo_skip    := Goptions.xinfo_skip;
  xinfo_big     := Goptions.xinfo_big;

  if xinfo<2 then
  xinfo_skip := 0;

  rootwarning   := true;

  parent_sibling_key := $4F8B3B;

  retry_wait := Goptions.retry_wait;

  autodirscan := Goptions.autodir;

end;

{****************************************************************************
****************************************************************************}

function Ttree.getparent(which:integer):integer;
var
o:Roffsets;

begin
{$ifdef cuteP_S}
  if nocute then begin
    dbg('getparent');
    result := -1;
    exit;
  end;
{$endif}

  if getoffsets(which,o) and (o.key=parent_sibling_key) then
  result := o.parent
  else
  result := -1;
{$ifdef dbgP_S}
  dbg('getparent:%d',[result]);
{$endif}
end;

{kill the info in this record if not up to date. Set record's key to current
key.}
procedure Ttree.killParentSibling(var o:Roffsets);
begin
  if o.key<>parent_sibling_key then begin
    o.parent := -1;
    o.Above_sibling := -1;
    o.Below_sibling := -1;
    o.key := parent_sibling_key;
  end;
end;

procedure Ttree.putparent(child,parent:integer);

var
h:integer;
o:Roffsets;

label
ENDNESS;

begin
  h := FileOpen(offsetsFile.name,fmOpenReadWrite);
  if (h<0)
  or (FileSeek(h,sizeof(o)*child,0)<0)
  or (FileRead(h,o,sizeof(o))<>sizeof(o))
  then
  goto ENDNESS;

  killParentSibling(o);

  o.parent := parent;

  if (FileSeek(h,sizeof(o)*child,0) >= 0) then
  FileWrite(h,o,sizeof(o));

  ENDNESS:
  if h>=0 then
  FileClose(h);

end;

function Ttree.getAsibling(which:integer):integer;
var
o:Roffsets;

begin
{$ifdef cuteP_S}
  if nocute then begin
    dbg('getAsibling');
    result := -1;
    exit;
  end;
{$endif}

  if getoffsets(which,o) and (o.key=parent_sibling_key) then
  result := o.Above_Sibling
  else
  result := -1;
{$ifdef dbgP_S}
  dbg('getAsibling:%d',[result]);
{$endif}
end;


procedure Ttree.putAsibling(what,sibling:integer);
var
h:integer;
o:Roffsets;

label
ENDNESS;

begin
  h := FileOpen(offsetsFile.name,fmOpenReadWrite);
  if (h<0)
  or (FileSeek(h,sizeof(o)*what,0)<0)
  or (FileRead(h,o,sizeof(o))<>sizeof(o))
  then
  goto ENDNESS;

  killParentSibling(o);

  o.above_sibling := sibling;

  if (FileSeek(h,sizeof(o)*what,0) >= 0) then
  FileWrite(h,o,sizeof(o));

  ENDNESS:
  if h>=0 then
  FileClose(h);

end;

function Ttree.getBsibling(which:integer):integer;
var
o:Roffsets;
begin
{$ifdef cuteP_S}
  if nocute then begin
    dbg('getBsibling');
    result := -1;
    exit;
  end;
{$endif}

  if getoffsets(which,o) and (o.key=parent_sibling_key) then
  result := o.Below_Sibling
  else
  result := -1;
{$ifdef dbgP_S}
  dbg('getBsibling:%d',[result]);
{$endif}
end;


procedure Ttree.putBsibling(what,sibling:integer);
var
h:integer;
o:Roffsets;

label
ENDNESS;

begin
  h := FileOpen(offsetsFile.name,fmOpenReadWrite);
  if (h<0)
  or (FileSeek(h,sizeof(o)*what,0)<0)
  or (FileRead(h,o,sizeof(o))<>sizeof(o))
  then
  goto ENDNESS;

  killParentSibling(o);

  o.Below_sibling := sibling;

  if (FileSeek(h,sizeof(o)*what,0) >= 0) then
  FileWrite(h,o,sizeof(o));

  ENDNESS:
  if h>=0 then
  FileClose(h);

end;

procedure Ttree.invalidateParentSibling;
begin
{$ifdef cuteP_S}
  nocute := false;
{$endif}

  inc(parent_sibling_key);

  if infofile.FopenR then begin
    infofile.inif.WriteInteger(infohead,'key',parent_sibling_key);
    infofile.Fclose;
  end;

end;

{****************************************************************************
given what like

  \gregor\OwenShow\junkb
  \gregor\OwenShow\junk
  \gregor\OwenShow\junk\1_ro
  \gregor\OwenShow\junk\1_ro\2_ro
  \gregor\OwenShow\junk\1_ro\2_ro\3
  \gregor\OwenShow\junk\1_ro\2_ro\3\4
  \gregor\OwenShow\junk\1_ro\2_ro\3\4\5

sort *only the top levels* by dissecting the thing into the top level and
lesser levels, sorting and then reassembling.

****************************************************************************}
{$ifdef STUPIDCASEBUG_rLb}
procedure Ttree.stupid_dir_sort(what:TStringList);
var
last,
rut:TStringList;
i,j,
rutlevel:integer;
begin
  if what.count<1 then
  exit;

  rut := jgo_slist; //create a jgo-inited stringlist.

  rutlevel := slashlevel(what[0]);
{****************************************************************************
assume the first entry in "what" is a root-level directory -- i.e. at the
highest level in the list.

Right:

  /bingo/bongo/bomp
  /bingo/bongo/womp
  /bingo/bongo/womp/zomp

Wrong:

  /bingo/bongo/womp/zomp
  /bingo/bongo/bomp
  /bingo/bongo/womp

The alogrithms that call stupid_dir_sort know this, or so I hope.
****************************************************************************}

  last := nil;  //stops annoying compiler complaint.

  for i := 0 to what.count-1 do begin
    if slashlevel(what[i]) = rutlevel then begin
{****************************************************************************
when the current item in the "what" list has the same number of slashes as the
first item, then we're at the rut-level for the list. So, (1.) create a list
object for the non-ruts that may follow, and (2.) add the rut-level name *and*
the list to the rut list.
****************************************************************************}

      last := jgo_slist;
      rut.addobject(what[i],last);
    end else
{****************************************************************************
if it's *not* a rut-level thingey, add it to the list of leaves we created
above. Note that this assumes the *first* entry in "what" is *always* be
rutlevel. Actually it is of course by definition, since that's how we set-up
"rutlevel" above.
****************************************************************************}

    last.add(what[i]);
  end;

{$ifdef LINUX}
{****************************************************************************
//  rut.casesensitive := true;
//no no I want the dirs to be sorted without case. There's an option for
files, but I guess I didn't apply it to dirs.
****************************************************************************}
{$endif}

  stupid_string_sort(rut);
{****************************************************************************
so now we sort the rut list, but we're only sorting *the rut level*; the
leaves *remain* in their current order, because they're stuck in the objects
attached to the rut level string. This is the whole point of this ridiculous
exercise. (Because sorting a list *without* this maneuver can result in leaves
showing-up attached to the wrong rut-level dirs.)
****************************************************************************}

  what.clear;   //we clear-out the argument he passed.

//then we take the stuff we've collected and put it back there, but in the
//correct order.
  for i := 0 to rut.count-1 do begin
    //add a rut-level object.
    what.add(rut[i]);

    //then add any leaves. The stringlist test is superfluous.
    if rut.objects[i] is TStringList then begin

      for j := 0 to (rut.objects[i] as TStringList).count-1 do
      what.add( (rut.objects[i] as TStringList)[j] );

    //then get rid of the leaves list; its work is done.
      (rut.objects[i] as TStringList).free;

    end;
  end;

  rut.free;

end;


{$endif}
{****************************************************************************
****************************************************************************}

{$ifdef LINUX}
function Ttree.isbadnet(complain:boolean = false):boolean;
begin
  result := false;
end;
{$endif}

procedure Ttree.begoodnet;
begin
  badnet := false;
end;

{$ifdef MSWINDOWS}
{$ifdef BETTER_READY}
  function Ttree.isbadnet(complain:boolean = false):boolean;
  const
  here : boolean = false;
  label
  ENDNESS;

    function cursor_rut_exists:boolean;
    begin
      form1.cursoid(crhourglass);
      delphi_yield; //doesn't "take" otherwise on odd-numbered Tuesdays.
//      result := DirectoryExists(drive+':\');
      result := isDriveReady(drive);
      form1.cursoid(crdefault);
    end;

  begin
  //it's not badnet yet. Do a test.
    if (not badnet)
    and cursor_rut_exists then begin
      result := false;    //it's ok.
      exit;
    end;

    result := true;
    badnet := true;
  {****************************************************************************
  gets reset by load. Note that result is already true == bad.

  has to be here ABOVE errorf below, so re-entrance at above will see badnet and
  not try directory again.
  ****************************************************************************}

    if not complain then
    exit;


    if here then      //protect errorf from reentrance. 'cause it does
                      //modalend.
    exit;

    here := true;

  //badnet and complain.
    errorf('tree "%s" seems gone; switch trees or something',[name]);

    here := false;

  end;

{$else} {BETTER_READY}
  function Ttree.isbadnet(complain:boolean = false):boolean;
  const
  here : boolean = false;
  label
  ENDNESS;

    function cursor_directory_exists:boolean;
    begin
      form1.cursoid(crhourglass);
      delphi_yield; //doesn't "take" otherwise on odd-numbered Tuesdays.
      result := DirectoryExists(drive+':\');
      form1.cursoid(crdefault);
    end;

  begin
  //it's not badnet yet. Do a test.
    if (not badnet)
    and cursor_directory_exists then begin
      result := false;    //it's ok.
      exit;
    end;

    result := true;
    badnet := true;
  {****************************************************************************
  gets reset by load. Note that result is already true == bad.

  has to be here ABOVE errorf below, so re-entrance at above will see badnet and
  not try directory again.
  ****************************************************************************}

    if not complain then
    exit;


    if here then      //protect errorf from reentrance. 'cause it does
                      //modalend.
    exit;

    here := true;

  //badnet and complain.
    errorf('tree "%s" seems gone; switch trees or something',[name]);

    here := false;

  end;
{$endif}  {BETTER_READY}

{$endif}

{****************************************************************************
****************************************************************************}
function Tvisited.defavorite:string;
begin

//  if (copy(dir,1,length(favoritemarker))=favoritemarker) then
//  dir := copy(dir,length(favoritemarker)+1,5000);

  result := directory;

end;

function Tvisited.favoritize:string;
begin
  result := favoritemarker + directory;
end;

constructor Tvisited.Create(t:Ttree; i:integer; d:string);
begin
  inherited Create;

  tree := t;
  index := i;
  directory := d;
end;


{****************************************************************************
****************************************************************************}

end.
