{exec.pas

See the bottom of main.pas for the BSD-style license.

Fri 4/18/03 2:37 pm. This code is bad. The excuse is, I was figuring-out the
execution stuff while I was at it. It should be rewritten, but I'm not going
to, I'm just going to keep tinkering with cranky little flags and try to tidy
it up when I can.

}

{$I osops.i}

unit exec;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons, QComCtrls, publics, {options,} QTypes,
  QExtCtrls
{$ifdef LINUX}
  ,Libc
{$endif}
  ;

type
  Texecform = class(TForm)
    CancelButton: TBitBtn;
    OKButton: TBitBtn;
    ExecBox: TListView;
    Timer1: TTimer;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure execboxDblClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure ExecBoxClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function checkdoubleclick:boolean;
    procedure Timer1Timer(Sender: TObject);
    procedure ExecBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function exec_ok_logic(what:Texec):boolean;
    function execute(what:Texec ):boolean;
    procedure BitBtn1Click(Sender: TObject);
    procedure ExecBoxColumnResize(Sender: TObject; Column: TListColumn);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    currentdir:string;
    logexec,
    tryddir : boolean;

    xclicky : integer;

    exec_dif : integer;

    procedure execshow;
    function execit:boolean;
{    procedure seewait(show:boolean);  }

    procedure exec_restore(Sender:Tobject);
{$ifdef MSWINDOWS}
    function MSWINDOWS_exec(apname, apname_and_args:string; modal:boolean;
    chat:boolean=true):integer;
{$endif}
{$ifdef LINUX}
    function LINUX_exec(name: string; arguments: TStringList; modal : boolean;
    chat:boolean=true):integer;
{$endif}
    procedure hokay;
    procedure start_exec;
    procedure execClear;
    procedure clx_close;
    procedure exec_fit;

  public
    { Public declarations }

    cancelled,
    shortcut_key : boolean;   {set by caller if set-off by shortcut key}

    exec_result : integer;

    function checkexecs(key:Word; shift:TShiftState):boolean;
    procedure exec_args(arglist:Tstringlist; what:Texec);

  end;

var
  execform: Texecform;
{  exec_wasmodal : boolean; {set appropriately by execute.}

the_exec : Texec;
{a global used by main to help figure-out what just happened.}

{.$define DBG_WAIT}

{$ifdef LINUX}
Linux_exec_modalresult : Tmodalresult;
{This isn't used Wednesday, November 27, 2002 12:30 pm but the idea is
assigned the actual execform.modalresult seemed to blow-up in Linux.}

Gpid : PID_T;  //the pid Linux_exec gets. for kylixdelete maybe.
{$endif}

exec_refocus : boolean;

exec_failed_aborted : boolean;
//if it *isn't* set, doesn't necessarly mean it wasn't.

{****************************************************************************
1. caller is responsible for setting current directory. But I'm not absolutely
sure of that. 2. In windows, exec must include extension, apparently. It'll
search the path OK, but "y" didn't invoke "y.cmd" on the path; had to use
"y.cmd".

Thu 6/15/2006 10:08 am. os_exec is used, as the name suggests, for *OwenShow*
to exec programs. Apparently OwenShow used to do this a lot; now, the *only*
one who uses it is main, for restarting OwenShow!
****************************************************************************}

function os_exec(exec:string; arguments:TStringList;
modal:boolean = true; chat : boolean = false):
boolean;

{$ifdef NILLIFY}
procedure execnillify;
{$endif}


{$ifdef LINUX}
procedure checkzombies;
function Gpid_gone:boolean;
{$endif}

procedure maybe_fix_exec_state;

implementation

{$R *.xfm}

uses options, main, code, dir, sbrs, files, qt
{$ifdef MSWINDOWS}
,windows
{$endif}
, weirdo
, execp
{$ifdef LINUX}
//,Libc {weirdo }
,fileutil
{$endif}
,osinfo
,fontfun
,log
;

type

Targs = class
  S_select : string;        {the single selection.}

  L_marked_but_first,       {list of marked files but first}
  L_marked : TStringList;   {list of marked files.}

  S_marked_but_first,       {marked files without first}
  S_marked : string;        {space-separated marked files.}

  S_arg1 : string;          {first marked argument, or select if nonesuch.}

  marked : boolean;         {true if marked files after update.}
  directory : boolean;      {true if form1 was directory after update.}

  S_select_or_marked:string;        {marked or if nonesuch, select}
  L_select_or_marked:TStringList;   {ditto, list}

  constructor Create;
  destructor destroy; override;

  procedure update;                 {concot the vars.}
  procedure asterisk(x:Texec);      {change + to *s.}

  private
  procedure clear;

end;



var

{$ifdef MSWINDOWS}
needsrefocus,
{$endif}
exec_showing,
{well that might've been something; apparently there *is* a read-only property
"showing".}
pleaseclose,
shouldbeMROK,
waited_once : boolean;

emptye,         {an eternally empty execution for going @G on a file or list.}
blankexec : Texec;
                {used to assign to the_exec so I don't have to worry about
                it.}

args : Targs;



{****************************************************************************
****************************************************************************}


{It's hopless. I have no idea how this works anymore. But we'll try and whack
things in this routine so at least there's a known starting point. You
understand, execution takes forever so there's no time wasting. Code-wasting,
yes.... // Well now the rule is: *anyone* who *uses* exec should call this
*first*, then fiddle any silly flags. Probably (true). No-one in here should
call it. // Well wait a moment, "checkexecs" could call it. and should. // nah
just have the caller do it. The real way to fix this would be to refactor the
exec form so someone calls *it* -- but that's tedious to do here in Delphi
land.... }

procedure maybe_fix_exec_state;
begin
  {$ifdef MSWINDOWS}
  needsrefocus    := false;
  {$endif}
  exec_showing    := false;
  exec_failed_aborted    := false;
  pleaseclose     := false;
  shouldbeMROK    := false;
  waited_once        := false;

  with execform do begin
    cancelled     := false;
    shortcut_key  := false;
    Timer1.enabled := false;
  end;

end;

{Oh here's where I tried before....}
procedure Texecform.start_exec;
begin
{$ifdef DBG_WAIT}
  dbg('exec:start_exec');
{$endif}

  currentdir := thisdir_string;
  tryddir := false;

  exec_result := 0;
end;


{****************************************************************************
****************************************************************************}


procedure exec_refowait;
{$ifdef DBG_WAIT}
var s:string;
{$endif}

  procedure wait_activated;
  begin
    while
    not Application.active
    do begin
      mswait(250,false);
//      form1.update;     //make it stop disappearing?
//doing this seems to refocus form1. On Tuedays.
    end;

  end;


begin
{$ifdef DBG_WAIT}
  s:= '';
  if exec_refocus then
  s := ':exec_refous';
  if execform.pleaseclose then
  s := ':pleaseclose';
  dbg('refowait%s',[s]);
{$endif}

  if waited_once
  or exec_refocus
//  or execform.shortcut_key
  then
  exit;

//  mswait(1500);
  {another tinker number; if I return too soon, the main form starts
  churning and eventually refocuses *before* the execution of the
  non-modal spawn there. So we wait. Might make it a settable option
  someday. // but that's if it was invoked as a menu item. If it's invoked
  from a key press, apparently it's a good idea just to have no wait.}
{****************************************************************************
Tue 4/11/2006 12:04 pm. If I do it here, the main form snatches it back as
soon as it's over. But then I do it down here this way -- the "wait_activated"
is the key. Although it still doesn't work on odd-numbered Tuesdays.
****************************************************************************}

  waited_once := true;  {only do it once.}

//  mswait(Gnon_modaldelay+2000);
  Gnon_modaldelay := 0;

  wait_activated;

end;

procedure Texecform.FormCreate(Sender: TObject);
begin
  autoscroll := true;
  constraints.minheight := 135;
  constraints.minwidth := 240;
end;

procedure Texecform.execClear;
begin
{  for i := 0 to execbox.items.count-1 do begin
    if execbox.items[i].data<>nil then
    Texec(execbox.items[i].data).free;
  end; }
{ha ha ha I'm not supposed to free those; they get freed in
options. They're just pointers. ha ha....}
  execbox.items.clear;
end;


{****************************************************************************
This is *not* execform.formshow; it is *called* by formshow, for the purpose
of *showing* the user the things he can select. Then, apparently, after he
selects one of them, we go through the whole thing again when execit calls
execute, which uses the arguments procedure above. // Which actually means, I
see, that what it does below isn't terribly important; it's just a label.

Yes that's right this is *just* to show the user the selections.
****************************************************************************}

procedure Texecform.execshow;
var
i:integer;
t:Tlistitem;
e : Texec;
debris : string;
begin
  OKButton.visible := false;
{  start_exec; }
  execbox.Sorted := false;
  args.update;

{concoct a blank Tlistitem to do what we want (aka @G)? Or something.}
  t := execbox.items.add;  {"returns newly created listitem"}
  t.caption := '(whatever)';

  if args.marked then
  t.subitems.add(args.S_marked_but_first);

  emptye.r.exec := args.S_arg1;     {and fill in the exec field.}

{now do all the execs.}
  t.Data := emptye;           {stuff it in the data field of the Tlistitem.}

  for i := 0 to Goptions.execs.count-1 do begin
    e := Goptions.execs.Objects[i] as Texec;
                              {get the exec record stored in there.}
    if e.r.invisible then
    continue;                 {to heck with it.}

    t := execbox.items.add;   {get another item.}
    t.Data := e;     {store it in the listitem's data property.}

    Gnome_quote_evar := 0;

{get xops options.}
    debris := evarize(e.S_xops);


    if e.r.marked then
    debris := spaceadd(debris,args.S_marked)
    else if e.r.select then
    debris := spaceadd(debris,args.S_select)
    else if e.r.args then
    debris := spaceadd(debris,args.S_Select_or_marked);

    if Gnome_quote_evar=1 then
    debris := spaceadd(debris,'''');

    t.subitems.add(
    safe_format('%s %s',
    [evarize(e.r.exec),debris]));

{now display verboten}
    if (args.directory and (not e.r.in_dir))
    or ((not args.directory) and (not e.r.in_files)) then begin
      t.selectable := false; {that'ul learn them}
      t.caption := safe_format('~%s',[e.r.name]);
    end else
    t.caption := e.r.name;

    if length(e.r.key.show)>0 then
    t.caption := safe_format('%s (%s)',[t.caption,e.r.key.show]);

    if e.r.doubleclick then
    t.caption := safe_format('%s dclick',[t.caption]);

  end;

{Friday, August 9, 2002 6:49 pm there'll always be one, and it'll
always be selectable.}
  execbox.selected := execbox.items[0];
  execbox.update;

  hokay;    {fiddle some buttons.}


end;


{****************************************************************************
****************************************************************************}


procedure Texecform.FormShow(Sender: TObject);
begin

  fixfonts(execform);
  formguard(execform);

  exec_fit;

{$ifdef MSWINDOWS}
  if top<0 then
  top := 20;
  {it wandered off the top of the screen once.}
{$endif}
{  start_exec; }

{  args.update; }



  exec_showing := true;
  timer1.Enabled := true;
  execshow;

  execbox.setfocus; //Friday, July 30, 2004 5:21 pm.

  if shortcut_key then begin
{    shortcuttimer.enabled := true;
    exit; }

    execit;
    if exec_refocus then
    ExecBox.setfocus;
  end;

//  timer_stupid.enabled := true;

end;

procedure Texecform.execboxDblClick(Sender: TObject);
begin
  execit;
end;

procedure Texecform.OKButtonClick(Sender: TObject);
begin
  execit;
end;

procedure Texecform.hokay;
begin
  OKButton.visible := Execbox.Selected <> nil;
  if okButton.visible then
  Okbutton.setfocus;
end;

procedure Texecform.ExecBoxClick(Sender: TObject);
var
item:Tlistitem;
begin
  if execbox.selected=nil then begin
    item :=
    execbox.getitemat(3,xclicky);

    if item<>nil then
    execbox.selected := item;

  end;


  hokay;
  if not OKButton.visible then
  osinfof('Item disabled');
end;

procedure Texecform.ExecBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  xclicky := y;
end;


{
procedure Texecform.seewait(show:boolean);
begin
  waitlabel.Visible := show;
  Execbox.visible := not show;

  OKbutton.visible := not show;
end;
}

{$ifdef LINUX}
var
Linux_restored : boolean;
{$endif}

procedure Texecform.exec_restore(Sender:Tobject);
begin
  pleaseclose := true;

{Fri 11/22/02 5:00 pm. this was the whole secret of the thing. I had this
stupid little button on this form so the user could click it if they wanted to
abort their modal thingey, but then I had to make sure the form was visible
after they de-minimized OS from the task bar. This was sad and painful. And
then of course I realized it was completely useless when they activated the
thing with the hot key -- i.e. the form doesn't show then of course, although
I was idiotically setting-up the button anyway -- and it would have been
miserably complicated to fix that -- and then I realized, if they de-minimize
OwenShow, that's presumably enough to know they're bored with the modal
process. Of course! Of course.... It's all so simple. }

{$ifdef MSWINDOWS}
  needsrefocus := true;
{$endif}
{$ifdef LINUX}
  Linux_restored := true;
{$endif}
  Application.OnRestore := nil;
end;



{****************************************************************************
****************************************************************************}

{$ifdef NILLIFY}
var
plz_nillify: boolean;

procedure execnillify;
begin
  plz_nillify := true;
end;
{$endif}

{$ifdef MSWINDOWS}
{****************************************************************************
****************************************************************************}
function Texecform.MSWINDOWS_exec(apname, apname_and_args:string;
modal:boolean; chat:boolean=true):integer;

var
PI:TprocessInformation;
SI:TStartupInfo;
fSuccess : bool;
dwExitCode:Cardinal;
waitfor : DWORD;
theApName: Pchar;
ApNil : string;

label
ENDNESS;

  function isbatch_xp_too_many_quotes:boolean;
  var
  count,i:integer;
  begin
    result := false;

    if (not os_isxp)
    or (not isbatch(apname)) then
    exit;

    count := 0;

    for i := 1 to length(apname_and_args) do begin
      if apname_and_args[i]='"' then begin
        inc(count);
        if count>=3 then begin
          result := true;
          exit;
        end;
      end;
    end;

  end;

begin

  result := -1;   {assume failure}

  apname := unquote(apname);  //if it *is* quoted, *unquote*.

  fixslashquote(apname_and_args); //see CREATEPROCESS() 'N' ME below.
{****************************************************************************
  well who knows.... changes
    "blah blah" "blah blah\" ==> "blah blah" "blah blah"
  and dibil take the hindermost.... q.v. sbrs.pas
****************************************************************************}

  waitfor := 0; {stop annoying warning}

{  WinExec(pchar(apname_and_args),SW_SHOWNORMAL); } {worked but oh it's so simple....}

  FillChar(PI, SizeOf(PI), 0);

  FillChar(SI, SizeOf(SI), 0);

  theApName := Pchar(apname);

  if chat then begin

    if (Goptions.execute_nil)
    and
    (
    (not FileExists_unq(apname))
    or
//    isbatch(apname)
    isbatch_xp_too_many_quotes
    )
    then
    theApName := nil;

  end else begin

{Tue 10/15/02 8:13 pm. Have execution show no window. I am blaming Steven
Szelei from the Code Project where I saw this... And it worked! Ain't life
amazin'....}
    SI.cb := sizeof(SI);
    SI.dwFlags := STARTF_USESHOWWINDOW;
    SI.wShowWindow := SW_HIDE;

  end;

{$ifdef NILLIFY}
  if plz_nillify then
  theApName := nil;
  plz_nillify := false;
{$endif}

{$ifdef NILLIFY_ALL}
{****************************************************************************
Mon 12/03/2007 5:01 pm. It's like the creeping horror that will not die. This
one was discovered while attempting to -- gasp! -- execute "c:\Program
Files\Mozilla\Firefox.exe". Too many quotes too many days too much Microsoft!
... See it used the os_exec function which hasn't been used all that often
recently except for restart; the trick, as I probably blather around here
somewhere else, is that poor ol' Micrisoft gets all confused if there're more
than a few sets of quotes in an execution -- right, as in when I try to invoke

          "c:\Program Files\Mozilla\Firefox.exe" \
          "c:\Program Files\OwenShow\helphtm\owenfrm.htm"

those four quotes just do it in. So now we'll crush the last remaining suspect
and *always* set the(Supposed)ApName to nil. ... This is probably why, if
you've been attentive, you'll occasionally see the *short form* of your
favorite program getting executed under various conditions....

Mon 12/03/2007 5:45 pm. Oh gregor oh certitude. It wasn't that at all; I mean,
I have no idea why not, but in the event it turned-out to be I *forgot to
quotate* the argument for the html help -- when it was

               "c:\program files\owenshow\helphtm\owenfrm.htm"

see those wicked spaces! Anyway, when I fixed that, NILLIFY_ALL was no longer
needed to make it work; this phase of moon.

****************************************************************************}

  theApName := nil;
{$endif}

  if logexec or Goptions.logexec then begin
    if TheApName=nil then
    ApNIL := '(nil)'
    else
    ApNil := TheApName;
    lg('exec',
    'cwd: %s; TheApName:%s; apname_and_args:%s',
    [getcurrentdir,ApNil,apname_and_args]);
  end;

//see CREATEPROCESS() 'N' ME below.
  fSuccess := CreateProcess(
  TheApName,              {lpApplicationName: PChar;                     }


  pchar(apname_and_args),            {lpCommandLine: PChar;                         }
  nil,                    {lpProcessAttributes,                          }
  nil,                    {lpThreadAttributes: PSecurityAttributes;      }
  false,                  {bInheritHandles: BOOL;                        }
  0,                      {dwCreationFlags: DWORD;                       }
  nil                    {lpEnvironment: Pointer;                       }
  ,
  nil,
  {missing until Fri 6/06/03 4:23 pm. Although it doesn't seem to make any
  difference, but after my adventures with lpApplicationName....}
  SI,                     {const lpStartupInfo: TStartupInfo;            }
  PI);                    {var lpProcessInformation: TProcessInformation }

{p 70 Advanced Windows, third edition, Jeffrey Richter}

//  if chat then
//  SetForegroundWindow(PI.hThread);
//  SetForegroundWindow(PI.hProcess);

//  CloseHandle(PI.hProcess); //msdn said so. // but they were wrong.
//probably for modal? // oh look I was already doing it below! Nit....
  CloseHandle(PI.hThread);

  if not fSuccess then begin
    exec_failed_aborted := true;   //oh why not?
    goto ENDNESS;
    //exit; //bad bad.
  end;

  if modal then begin
    result := 0;      {assume success.}

    if chat then begin
      Application.onrestore := exec_restore;
      Application.minimize;
    end;

    while true do begin
      waitfor :=
      WaitForSingleObject(pi.hProcess,100 {250} {Infinite});

      if waitfor=WAIT_OBJECT_0 then
      break;

      delphi_yield;

      if chat and pleaseclose then begin
        exec_failed_aborted := true;
        break;
      end;
    end;

    if waitfor=WAIT_OBJECT_0 then begin
      GetExitCodeProcess(pi.hProcess,dwExitCode);
      result := dwExitCode;
    end;

    if chat then begin
      Application.restore;  {of course doesn't actually.}
      form1.WindowState := wsNormal;
    end;
  end
  else begin
    result := 0;      {if not modal, then fake good result?}
  end;

  ENDNESS:
  CloseHandle(pi.hProcess);

end;

{$endif}

{****************************************************************************
So it says here (Pchar help Delphi 6 pro) "The declaration of opendir is
in the Libc interface unit" 8/7/02.
****************************************************************************}

{$ifdef firstTry_LINUX}
function Texecform.os_exec(what:string; modal:boolean):integer;
begin

  result := 0;



{  if modal then
  application.minimize
  else }
  if length(what)<1 then
  Libc.system(nil) else begin

    if modal then
    what := what + ' &';
    Libc.system(PChar(
    {'bash'}  {nada}
    {'emacs'}   {RAN RAN RAN 8/7/02 4:25 pm}
    what      {worked cool; modal}
    ));
{    if modal then
    application.restore;  }
    form1.WindowState := wsNormal;

{  what := 'bash ' + what;
    Libc.system(PChar(what)); }
{didn't work....}

  end;

end;
{$endif}

{****************************************************************************
****************************************************************************}
{$ifdef LINUX}
var
zlist : TList;

procedure zombie(pid:integer);
begin
  if pid>=0 then
  zlist.add(pointer(pid));
{this is really a little dodgy; I'm assuming a pointer is *bigger* or as
big as a pid. Hope Delphi complains if it ever isn't....}
end;

{.$define PIDSHOUT}       //complain about pid or something.
{.$define dont_zombie}    //don't kill zombies.

procedure checkzombies;
var
r:integer;
const
index:integer = 0;
begin
  if zlist.count<1 then
  exit;
{$ifdef dont_zombie}
  exit;
{$endif}

  if index>=zlist.count then
  index := 0;

  if waitpid(integer(zlist[index]),@r,WNOHANG or WUNTRACED)=
  integer(zlist[index]) then begin
{$ifdef PIDSHOUT}
    osinfof('Werd-out; it saw pid %d',[integer(zlist[index])]);
{$endif}
    zlist.delete(index);
  end else
  inc(index);

{we only do them one at a time. But of course normally there would only
be one or two anyways....}

end;

{****************************************************************************
called by someone with time on their hands, to see if the executed -- Gpid --
program has stopped running; returns true if the GPID is no longer among us.
****************************************************************************}

function Gpid_gone:boolean;
begin
  mswait(Goptions.LinuxExecWait);

  checkzombies;

  result :=
  (zlist.count<1) or
  (zlist.indexof(pointer(Gpid))<0);

  if result then
  exec_failed_aborted := true;

end;

{****************************************************************************
The Borland site showed me how. Incidentally, to find these things, like
"waitpid", check-out kylix3/source/rtl/linux/Libc.pas, where there are
prototypes for lots of Linuxoid functions.
****************************************************************************}

function Texecform.LINUX_exec(name: string; arguments: TStringList; modal :
boolean; chat:boolean=true):integer;
var
pid: PID_T;
Max: Integer;
I: Integer;
parg: PPCharArray;
argnum: Integer;
begin

  Result := -1;

  if chat then {added Monday, February 2, 2004 1:45 pm}
  chdir(fdeslash(currentdir));
  {missing until Monday, November 3, 2003 4:18 pm.}


  pid := fork;

  if pid = 0 then begin {we are the forkee}

    Max := sysconf(_SC_OPEN_MAX);

    for i := (STDERR_FILENO+1) to Max do begin
      fcntl(i, F_SETFD, FD_CLOEXEC);
    end;

    argnum := arguments.Count;

    GetMem(parg,(2 + argnum) * sizeof(PChar));
    {I assume the reason he doesn't need to FreeMem is because he's about to
    execvp, which will trash this whatever it is.}

    parg[0] := PChar(Name);

    i := 0;

    while i <= {high(arguments)} argnum-1 do begin
      inc(i);
      parg[i] := PChar(arguments[i-1]);
    end;

    parg[i+1] := nil;

{    try }
      execvp(PChar(name),PPChar(@parg[0]));

{****************************************************************************
Wed 10/01/03 4:46 pm. So I say below "not supposed to happen" -- but of course
it does if the executable is no good. In Windows, *no problema*; just silently
fails. Of course we don't fork there. So, take that, Linuxoids.... As
indicated below, I tried a number of tricks and I may yet find another, but
for now the Linux version fails if the exec is wrong. The basic problem is,
there appears to be no way to *unfork* in Delphi.
****************************************************************************}

{      infof('Sorry; "%s" failed, and I don''t know how to unfork',
      [name]);     }
{****************************************************************************
I can't even do that. So sad....
****************************************************************************}
{      exit;  } {3/22/04: *this* makes it sort-of continue stumbling; still
doesn't work.... }

{And this really oughtn't to halt the forker -- but it does.... it makes
OwenShow go away; which is better than the exit.... }
{      halt(7);  {*this* kills OwenShow..}

{*this* makes it work; i.e., not fail.}
{$ifdef DUBIOUS_TEST}
      name := '/home/gregor/save/Kylix/OwenShow/pdsortx';
      parg[0] := PChar(Name);
      parg[1] := nil;
      execvp(PChar(name),PPChar(@parg[0]));
{$endif}

//      Really_Terminate_Now; //might work. //nope.

{and here is the final idiotic version.}
      name := Goptions.nop_name;
      parg[0] := PChar(Name);
      parg[1] := nil;
      execvp(PChar(name),PPChar(@parg[0]));

{and now, just for good look, or if you have foolishly specified nop as
something else or it's missing, we'll do what we used to do}
      halt(7);
{which apparently puts OwenShow out of its misery. If I don't do that and the
nop execution fails for whatever reason, you get a dead OS you have to
kill.... }

{****************************************************************************
Our topic here today Mon 3/22/04 5:27 pm is why does poor little Linux
OwenShow fail so miserably when I execute a nonexistent program -- typically,
the Owen traditional "bingo". Apparently, after the fork, if the execution
fails, I'm still in the Delphi program OwenShow in some mystifying
dopple-ganger way -- which really makes sense, i.e. if the execvp failed, I
*must* still be running OwenShow, what else could I be doing? So the fault is
not exactly Linux oh of course never little children, the fault is poor ol'
obsolete forgotten Delphi Kylix whatever it used to be called before we all
learned to love .NET....

So anyway *my* stupid solution -- and I'm beginning to have an odd feeling
this may be the only *actual* way to fix it, i.e. not just my ignorance -- is,
IF the execvp above fails, execute something else guaranteed to work -- as the
only safe/possible way for the forkee to exit the Delphi OwenShow environment.
So I fabricate "nop.com", which will hang around in the Delphi directory along
with its trivial nop.c source.... And I'll probably make an option for it....

But note that at Thu 8/19/2004 2:50 pm, OwenShow'll make its *own*
no-operation program if it doesn't find nop; see options:checknop.

One major delusion I suffered-from in this seemingly endless struggle is that
*fork* fails at a bad execution, which is *obviously* untrue; the execution
occurs *after* the fork, and fails in the forkee. I suppose a simple C
program'd just go "exit(12)" and everyone'd be happy, but the vast complex
Delphi environment apparently can't do that; I mean, I tried....

So you can insert your own "nop" program to replace the one the OwenShow
development team (me) has thoughtfully included in the distribution, but a few
random attempts I made weren't nice -- "konsole" made things look like the old
non-halt version, where you can still see OwenShow but it is mute and without
thought, and you have to kill it with the usual laborious Linux techniques....
So I stuck a halt at the end....

****************************************************************************}



{      zombie(pid);
      pid := -1;  }

{$ifdef FERGET}   {other pitiful attempts....}
    except
      on exception
      do begin
{        form1.xfinal;
        halt(7);     }
        Really_Terminate_Now;
        application.terminate;
        pid := -7;
      end;
    end;
    exit;
    Really_Terminate_Now;
    Application.Terminate;


{    infof('Ooops');

    halt; {not supposed to happen}
    form1.xfinal;
    Really_Terminate_Now;
    Application.Terminate;
    exit;
    halt(0);
{$endif}


  end;

{added modal Thursday, August 29, 2002 6:46 pm after this worked
once in Linux at least with emacs. // and gnome-terminal Thu 11/21/02 4:59 pm.
//but then 8/02/03, it doesn't really work all the time. I know nothing....}
  result := pid;

  Gpid := pid;    //leave it there for KylixDelete in cpyfiles at least.
  //and others, now that KylixDelete is gone.

  if modal and (pid > 0)
  and (not Gpid_gone)
  then begin

    Linux_restored := false;
    if chat then begin
      Application.onrestore := exec_restore;
      Application.Minimize;  {he can always maximize it again. //
                              unfortunately.}
    end;

    delphi_yield;
    mswait(100);

{$ifdef LINUX}
    if chat then begin
      while waitpid(pid,@result,WNOHANG {or WUNTRACED})<>pid do begin
{so with gnome-terminal, this returns immediately 8/02/03. ? // oh u
know this may be an artifact of fooling-around in the IDE or something.
// Nah it was because I was *already* running gnome-terminal, i.e. I
started the delphi IDE in gnome-terminal instead of konsole. I mean
when I went back and started delphi from konsole, then the @T modal
gnome-terminal thing worked fine, even in the IDE -- although the IDE does
have trouble with the focus of course. //Right I just tried @T with konsole
instead of gnome-terminal, and then it works, even 'though there's
a copy of konsole already running. Except of course the focus problem....}

        if pleaseclose then begin
          exec_failed_aborted := true;
          zombie(pid);
          break;
        end;

        mswait(500);
      end;
    end else begin
      waitpid(pid,@result,0);     {assign the result}
    end;
{$else}
    pleaseclose := true;        {I'm not sure why I do this.}
    waitpid(pid,@result,0);     {assign the result}
{$endif}

{This has to be here. Application doesn't restore itself.}
    if chat then begin

      form1.caption := 'exec restoring ...';
      for i := 0 to 5 do begin
//        dbg('linux restore: %d',[i]);

        if Linux_restored then
        break;

        Application.restore;  {of course doesn't actually.}
        Application.BringToFront; {let's try this // nope.}
        form1.WindowState := wsNormal;
      end;
    end;

  end else begin    {it's non-modal.}
    result := 0; {fake non-modal OK result.}
    zombie(pid);    {zombie discards bad pids.}
  end;

end;


{$endif}

{****************************************************************************
This is the simple-minded exec, called, for instance, to run the sort program.
I.e. NOT the fancy hot key exec.
****************************************************************************}

var
emptyStringList : TStringlist;

procedure nilempty(var t:TstringList);
begin
  if t=nil then
  t := emptyStringList;
end;

{$ifdef MSWINDOWS}
function os_exec(exec:string; arguments:TStringList;
modal:boolean = true; chat : boolean = false):
boolean;
var
i:integer;
commandline:string;
begin

  execform.currentdir := getcurrentdir;
//gets current directory for simple-minded execution.

  nilempty(arguments);

  commandline := quoteoid(exec);

  if arguments<>nil then
  for i:=0 to arguments.count-1 do begin
    commandline := commandline + ' '+arguments[i];
  end;

  result :=
  execform.MSWINDOWS_exec(exec,commandline,modal,chat)=0;


end;
{$endif}

{$ifdef LINUX}
function os_exec(exec:string; arguments:TStringList;
modal:boolean = true; chat : boolean = false):
boolean;
begin
  execform.currentdir := getcurrentdir;

  nilempty(arguments);

  result :=
  execform.LINUX_exec(exec,arguments,modal,chat)=0;
end;
{$endif}

{****************************************************************************
execit is called by user routines (1.) after the user clicks or selects one
of the executables or (2.) when the shortcut_key thing is true, i.e. he used
@G (default).
****************************************************************************}

function Texecform.execit:boolean;
begin

  try
    result := execute(Texec(execbox.selected.data));
{at least once the adorable TListView was unselected.}

  except
    on exception do result := false;
  end;

  if result then begin
    pleaseclose := true;
    shouldbeMROK := true;
  end
//  else
//  errorf('execit: execute result was false')
//no do this if we want in execute.
  ;
end;

{****************************************************************************
****************************************************************************}

procedure Texecform.CancelButtonClick(Sender: TObject);
begin
  exec_refocus := true;
  pleaseclose := true;
  clx_close;
end;



{****************************************************************************
****************************************************************************}

procedure Texecform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  timer_stupid.enabled := false;

  execClear;
  exec_showing := false;
  timer1.enabled := false;

  shortcut_key := false;

{$ifdef MSWINDOWS}
{this seems to really screw things up in Linux.... All is lost....}
{Tue 9/13/2005 3:26 pm. Yes it does; came-up again in fontfun. Basically you
shouldn't write modalresult in formclose, probably because it sets-off
formclose again? //Thursday, January 26, 2006 11:21 am. No because it halts
ALL activity.}
  if shouldbeMROK then
  modalresult := mrOK;
{$endif}
{$ifdef LINUX}
  if shouldbeMROK then
  Linux_exec_modalresult := mrOK
  else
  Linux_exec_modalresult := mrCancel;
{$endif}

  plzFview;

end;

procedure Texecform.clx_close;
begin
  exec_refowait;
  close;
end;

{****************************************************************************
returns true if the key was associated with an OS execution. Even if it
didn't actually execute it.
****************************************************************************}
function Texecform.checkexecs(key:Word; shift:TShiftState):boolean;
var
i:integer;
begin
  result := false;

  if (shift=[])
  and (not isreturnkey(key))
  and (form1.thepanel=d) then
  {the exec short-cuts should all be alt or control // except FileEnter
  in a files thingey.}
  exit;

  for i := 0 to Goptions.execs.count-1 do begin
    if is_key(
    (Goptions.execs.Objects[i] as Texec).r.key,
    key,shift) then begin

      if not exec_ok_logic(Goptions.execs.Objects[i] as Texec)
      then exit;

      result := true;   //it's a hot key that *should* be executed.

{$ifdef WAIT_KEY_CLEAR}
      WaitForNoAlt;
{$endif}

      execute(Goptions.execs.Objects[i] as Texec );

      exit;

    end;
  end;
end;

{returns true if we found the right double-click function, regardless of
whether it worked or not.}
function Texecform.checkdoubleclick:boolean;
var
i:integer;
begin
  result := false;

{  start_exec;  }

  try
    for i := 0 to Goptions.execs.count-1 do begin
      if
      (Goptions.execs.Objects[i] as Texec).r.doubleclick
      then begin
        result := execute(Goptions.execs.Objects[i] as Texec);
        exit;
      end;
    end;
  except
    on e: exception do
    Errorf('%s checkdoubleclick: %s',[OwenShowID,e.message]);
    {on 7/29/03, I double-clicked on a batch file, got a GPF, and then
    @g wouldn't work; only the shadow knows.... // that was on HP760 which
    *has* no doubleclicks defined. }
  end;
end;


{****************************************************************************
****************************************************************************}
{****************************************************************************
****************************************************************************}
{****************************************************************************
see note for Texecform.execshow (//I don't know why Thu 10/02/03 11:10 am) (oh
because I do the same thing there -- but just for show.). Note exec_args is
*not* a method of Texecform, but just a procedure so it can be called from
elsewhere easier -- at this point only in nlist.pas // which is gone today Wed
10/01/03 5:12 pm. So it's ONLY used in Texecform.execute. So I'm making it
handle the xops thingey. // Thu 10/02/03 11:07 am. so I'm making it an
Texecform procedure, and changing the name to exec_args. That'ul learn it.

****************************************************************************}


procedure Texecform.exec_args(arglist:Tstringlist; what:Texec);
var
{$ifdef MSWINDOWS}
xopscount,
{$endif}
i:integer;

  procedure argLadd(s:string); overload;
  begin
    if length(s)>0 then
    arglist.add(s);
  end;

  procedure argLadd(s:TStringList); overload;
  begin
    if s.count>0 then
    arglist.addstrings(s);
  end;

begin

  args.update;

  arglist.clear;

  arglist.AddStrings(what.xops);
{$ifdef MSWINDOWS}
  xopscount := arglist.count;
{$endif}

  if what.fixed_arglist<>nil then
  arglist.AddStrings(what.fixed_arglist);

  Gnome_quote_evar := 0;
  evarlist(arglist);

  if what.fixed_arglist=nil then begin
    if what.r.is_fake_blank then begin      {args=1 in our fake empty thing}
      arglist.AddStrings(args.L_marked_but_first);
    end
    else if what.r.marked then
    argLadd(args.L_marked) //arglist.addstrings(args.L_marked)
    else if what.r.select then
    argLadd(args.S_select) //arglist.add(args.S_select)
    else if what.r.args then
    argLadd(args.L_select_or_marked) //arglist.addstrings(args.L_select_or_marked)
    ;

    if what.r.full and (not args.directory) then begin
      for i := 0 to arglist.count-1 do begin
        arglist[i] := form1.thisfv.status.caption + arglist[i];
      end;
    end;
  end;

{$ifdef MSWINDOWS}
  if what.r.short then for i :=
  xopscount //DONT shortify the xops; I mean, it could be -s!
  to arglist.count-1 do begin
    arglist[i] := shortify(arglist[i]);
  end;
{$endif}

{quoteoid both xops and real arguments.}
  if what.r.quotes then for i := 0 to arglist.count-1 do begin
    arglist[i] := quoteoid(arglist[i]);
  end;

  if Gnome_quote_evar=1 //just forget it if he put more than one.
  then begin
{****************************************************************************
So we gotta stick all this junk into a *single* argument for the winsome
gnome.
****************************************************************************}
    for i := 0 to arglist.count-1 do begin
      if arglist[i]='''' then begin
        while (i+1)<arglist.count do begin
          arglist[i] := arglist[i] + ' ' + arglist[i+1];
          arglist.delete(i+1);
        end;
//        arglist[i+1] := arglist[i+1] + ' ''';
//so clever delphi just gave-up on that! No error no gpf nothin....
        arglist[i] := arglist[i] + ' ''';
        break;  //the for. I hope.
      end;
    end;
  end;

end;

{****************************************************************************
****************************************************************************}
function Texecform.exec_ok_logic(what:Texec):boolean;
begin
  result := false;

  if
  (what=nil) or
  ((not what.r.in_dir) and (not isfilepanel)) or
  ((not what.r.in_files) and (isfilepanel))
  then
  exit; {so much for that.}

  if what.r.is_enter and
  ((not isfilepanel) or
  (file_selected.dir)
  ) then
  exit;

  result := true;

end;

{****************************************************************************
execute returns true ONLY if execution succeeds.
****************************************************************************}

{.$define ALWAYS_SHOW}   //debug: show exec every time.
function Texecform.execute(what:Texec ):boolean;
var
arglist:TstringList;
i:integer;
exec, s:string;
thereread:integer;
label
ENDNESS;

  function ifquoteoid(s:string):string;
  begin
    if what.r.quotes then
    result := quoteoid(s)
    else
    result := s;
  end;

begin

{  osinfof('whadda u know');  }
  result := false;   {didn't execute.}
  the_exec := blankExec;

  if not exec_ok_logic(what) then
  exit;

  start_exec;

  {OK it's a go. Do the arguments}
  arglist := TstringList.create;

  if length(what.r.directory)>0 then
  currentdir := fdeslash(what.r.directory);

  if not DirectoryExists(currentdir) then begin
    if not usuref('exec "%s":'+LNEND+
    '  Directory "%s" doesn''t exist;'+LNEND+
    '  use "%s"?'
    ,
    [what.r.name,currentdir,datadir]) then
    goto ENDNESS;
    currentdir := datadir
  end;

  chdir(fdeslash(currentdir));
{****************************************************************************
Tue 3/01/2005 5:14 pm. [rc0] this seemed to fix a problem "L" (the program)
was having with short file names. L is a 16-bit program from ancient days, and
wanted short names. But sbrs.shortify wasn't going to work if it was in the
wrong directory. I believe I foolishly removed what I thought was an extra
chdir(currentdir) yesterday, in furtherance of my exciting project of actually
checking if the directory existed before using it. ... Ah I see; currentdir is
used (1.) in LINUX_exec, where there's a chdir and (2.) in MSWINDOWS_exec
where I use it in the call to CreateProcess. But that doesn't actually CHANGE
the directory or anything except for the new process, which is in any case too
late for shortify -- which rears its ugly head in exec_args which I'm just
about to call. Obviously before I "fixed" stuff, something in here called
chdir(currentdir) before this point -- and now it does again!


****************************************************************************}
  if (IOResult<>0)
  and (not usuref('Error in chdir(%s); go ahead anyway?',
  [currentdir]))
  then begin
    cancelled := true;
    goto ENDNESS;
  end;

  exec_args(arglist,what);

  exec := evarize(what.r.exec);

  if goptions.execute_check
  and (not what.r.is_fake_blank)  //otherwise path of arg! bad bad.
  then
  exec := x_in_path(exec);

{make up the exec, arglist, for execution and also maybe for prompt.}
  if what.r.prompt or (exec_showing and what.r.showing_prompt) then begin
    execprompt.memo.lines := arglist;
    if (length(exec)>0)
    then begin
      execprompt.isexec := true;
      execprompt.Memo.Insert(
      ifquoteoid(exec)
      +LF,0,0);
    end
    else
    execprompt.isexec := false
    ;

    {note that LF is pure mumbo-jumbo; it works. CRLF didn't; CR didn't.}
    if execprompt.showmodal <> mrOK then begin
      cancelled := true;
      goto ENDNESS;
    end;

    {so we assign everything in the memo to the arglist -- so the user
    can edit anything before executing.}
    if execprompt.changed then begin
      arglist.Assign(execprompt.memo.lines);

      if arglist.count>0 then begin
        exec := arglist[0];
        emptye.r.exec := exec;    //preserve any idiotic edits he might've done.
        arglist.delete(0);
      end else begin
  //      exec := '';
        cancelled := true;
        goto ENDNESS;
      end;
    end;
  end;

  if length(what.r.argfile)>0 then begin
    arglist.SaveToFile(what.r.argfile);
    arglist.clear;
    s := safe_format('%s %s',[ifquoteoid(exec),what.r.argfile]);
  end else begin
    s := ifquoteoid(exec);
    for i := 0 to arglist.count-1 do
    s := s + ' ' + arglist[i];
  end;

  the_exec := what;

  if goptions.execute_check then begin

    exec := x_in_path(exec);    //just do it again; won't do 2 paths....
    //if he did is_fake_blank, presumably he entered something now.

    if (not FileExists_unq(exec))
    and (not usuref('"%s" doesn''t exist in path; go ahead anyway?',
    [exec]))
    then begin
      cancelled := true;
      goto ENDNESS;
    end;
  end;

  refix_again(true);    //try 'n' fix speed?

//  if what.modal and isfilepanel then
//  savesort;

{  thisdirectory; } {did that above.}
  logexec := what.r.log or Goptions.logexec;

{$ifdef MSWINDOWS}
  exec_result := MSWINDOWS_exec({what.} exec,s,what.r.modal);
  {windows says bad result if I close the command window with a
  click -- i.e. instead of escaping out or exit or something. So
  just skip it; should be fairly obvious usually anyway. Wed 10/04/2006 11:54
  am Well now we don't now.}
{$endif}

{$ifdef LINUX}
  exec_result := LINUX_exec(exec,arglist,what.r.modal);
  if exec_result < 0
  then begin
    errorf('Oops; "%s" didn''t work...',[what.r.exec]);
    exec_refocus := true;
  end;
{$endif}

  result := exec_result >= 0;

  if (not result)
  and (Goptions.execute_error)
  then begin
    errorf('execute failed: exec:%s; args:%s; cwd:%s',
    [exec,s,getcurrentdir]);
    exec_refocus := true;
  end
{$ifdef ALWAYS_SHOW}
  else begin
    infof('execute success: exec:%s; args:%s; cwd:%s',
    [exec,s,getcurrentdir]);
    exec_refocus := true;
  end
{$endif}
  ;

  args.asterisk(what);

  if what.r.modal then begin
    mswait(200);      {let's wait a little, if modal}
    exec_refocus := true;
  end else begin
{    if what.throttling then  }
    throttle(true);

//    mswait(what.non_modaldelay);
  {Tuesday, April 15, 2003 6:19 pm. So when osdelay was 0 one dark day, and I
hadn't fixed mswait, apparently going off and looping forever while
calling delphi_yield just made this form disappear -- and, to be sure,
the program break in various novel and puzzling ways.... That is, this form
just dived away somehow without closing, and the main form showed itself, and
even os_idle kept executing. Keys didn't work, and couldn't close the thing,
but that might well have been mswait failing....}

{Thu 4/28/2005 2:25 pm. Doesn't seem to do much good ever. So now}
    Gnon_modaldelay := what.r.non_modaldelay;
{see usage in main.pas.}

    if form1.thepanel<>d then begin
      form1.reread := what.get_reread;
      form1.rereadwait := what.r.rereadwait;
    end;

    goto ENDNESS;

  end;

  //this is probably the modal path. The other ones goto ENDNESS.

  osdirectory;

  thereread := what.get_reread;

  if
  (form1.thepanel<>d) //don't reread if not files panel.
  and what.r.modal
  and (thereread>0)
  and (
  (thereread=1) or
  (thereread >= form1.thisfv.filecount)
  )
  and
  (not exec_failed_aborted) then
  form1.seefiles(false,false);
  //Friday, December 2, 2005 7:07 pm. Don't see *other* files.

{$ifdef MSWINDOWS}
  if what.r.modal and (not exec_failed_aborted) then
  Application.BringToFront;
{Tuesday, December 10, 2002 6:08 pm. this seemed to fix a lost-focus problem}
{$endif}

  ENDNESS:
  arglist.free;

end;

{****************************************************************************
****************************************************************************}



procedure Texecform.Timer1Timer(Sender: TObject);
const
here : boolean = false;
begin
  if here then
  exit;

  here := true;

  if pleaseclose then begin
{$ifdef MSWINDOWS}
    pleaseclose := false;
    Timer1.enabled := false;
{$endif}
    if exec_showing then
    clx_close;
{$ifdef MSWINDOWS}
  end else begin
    if (needsrefocus) and (not focused) then
    setfocus;
{$endif}
  end;

  here := false;
end;

procedure Texecform.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  if (xlatewordstar(key,shift)) then
//  execbox.setfocus;
// I just set the focus anyway.
  xlatewordstar(key,shift);
end;

{****************************************************************************
The idea here is to combine all the bizarre argument-collection nonsense that
barnicled on to the above and centralize it here, no matter how baroque.
****************************************************************************}
constructor Targs.Create;
begin
  inherited Create;
  {code goes after inherited create}
  L_marked := TStringList.create;
  L_marked_but_first := TStringList.create;
  L_select_or_marked := TStringList.create;
end;

destructor Targs.destroy;
begin
  L_marked.free;
  L_select_or_marked.free;
  L_marked_but_first.free;
  {code goes before inherited destroy}
  inherited destroy;
end;

procedure Targs.asterisk(x:Texec);
var
i:integer;
begin

  clear;                {might as well dump the strings and things.}

  if x.r.select {didn't consume marks.}
  or directory then {update decided we were directory}
  exit;

  for i := 0 to form1.thisfv.filecount-1 do begin
//    file_checkifmarked(form1.thisfv,i);
    file_dir_checkifmarked(form1.thisfv,i);
    //Tuesday, July 1, 2008 11:14 am.
  end;

end;

procedure Targs.clear;
begin
  L_marked.clear;

  S_marked := '';
  S_marked_but_first := '';
  L_marked_but_first.clear;

  S_select := '';

  S_arg1   := '';

  S_select_or_marked := '';
  L_select_or_marked.clear;
end;

procedure Targs.update;
var
i:integer;

  function markings(start:integer):string;
  var
  i:integer;
  space:string;
  begin
    space := '';
    for i := start to L_marked.count-1 do begin
      result := result+space+L_marked[i];
      space := ' ';
    end;

  end;

begin
  clear;
  marked := false;
  directory := false;

  with Form1 do begin
    case thepanel of
      d: begin
        directory := true;
        S_select := thetree.selectedpath;
      end;

      f1,f2: begin
        S_select := file_selected_name(thisfv);

        for i := 0 to thisfv.filecount-1 do begin
          if file_dir_ismarked( Tos_f(thisfv.fls.objects[i]) )
          then
          L_marked.add( Tos_f(thisfv.fls.objects[i]) .name);
        end;

        S_marked := markings(0);
        S_marked_but_first := markings(1);

        for i := 1 to L_marked.count-1 do
        L_marked_but_first.add(L_marked[i]);

      end;
    end;
  end;

  if length(S_marked)>0 then begin
    marked := true;
    S_select_or_marked := S_marked;
    L_select_or_marked.assign(L_marked);
  end else begin
    S_select_or_marked := S_select;
    L_select_or_marked.add(S_Select);
  end;

  if marked then
  S_arg1 := L_marked[0]
  else
  S_arg1 := S_select;

end;



{****************************************************************************
****************************************************************************}
procedure xinit;
const
done : boolean = false;
begin
  if done then
  exit;

  done := true;

  emptye := Texec.create(true);
  emptye.r.in_dir := true;
  emptye.r.in_files := true;
{  emptye.args := true; }
  emptye.r.marked := true;
  emptye.r.is_fake_blank := true;

  emptye.xops := TStringList.create;
  {create an empty xops.}

{  emptye.exec := '';
{  emptye.osdelay := def_osdelay; }
{  emptye.osdelay := 0;
{  emptye.modal := false;
{for some reason the emptye, which is used for the @G exec thingey, has to
have the modal thing set false, which I've been doing by accident up to now.
//and then I'm going it on purpose now, with the constructor arg....// I don't
know why and I'm not checking right today, however it definitely has a
different execution path, and then there's all the gingerbread to make CLX
play nice....}
  emptye.r.non_modaldelay := Goptions.execkey_delay;

{$ifdef LINUX}
  zlist := TList.create;
{$endif}
  blankexec := Texec.create(true);
  blankexec.xops := TStringList.create;
  the_exec := blankExec;

  emptyStringList := TStringList.create;

  args := Targs.create;

end;

{****************************************************************************
Fri 6/13/03 10:55 am. Oh I see; this was in the form Texecform.xfinal, even
'though it only fixed globals and didn't need the scope, and I was calling it
from finalization execform.xfinal. In another module, I was freeing form
variables that way, and the variables were already nil dead gone, and
naturally it was producing errors. So when finalization shows up, probably the
variables i.e. the instance are gone, but the methods still remain. Or
something.... // I have no idea what he's babblnig about.

****************************************************************************}

{****************************************************************************
Tue 12/13/2005 12:49 pm. nothing to do with that, just program modernization
here. And pitifully, there already was offexec in options! And now Texec has a
destroy method. Finally, the try/except thing apparently does no good when it
exceptions -- as I just found out -- just upsets delphi in all directions.
****************************************************************************}

procedure xfinal;
begin
{$ifdef LINUX}
  freeandnil(zlist);
{$endif}
  freeandnil(emptye);
  freeandnil(blankexec);
  freeandnil(emptyStringList);
  freeandnil(args);
end;

procedure Texecform.BitBtn1Click(Sender: TObject);
begin
  oshelp('The Execs Section: OwenShow Execution');
end;

procedure Texecform.exec_fit;
begin
  exec_dif :=
  ExecBox.width -
  (execbox.columns[0].width + execbox.columns[1].width);
end;

procedure Texecform.FormResize(Sender: TObject);
begin
  execbox.columns[1].width :=
  ExecBox.width
  - execbox.columns[0].width
  - exec_dif;
end;

procedure Texecform.ExecBoxColumnResize(Sender: TObject;
  Column: TListColumn);
begin
  exec_fit;
end;

{****************************************************************************
****************************************************************************}

initialization
xinit;

finalization
xfinal;



{****************************************************************************
CREATEPROCESS() 'N' ME: The Sorry and the Pity        Fri 10/06/2006 2:19 pm

Below (at the ----) are millions of comments from various points in this
endless excitement.... Here are my notes today.

WIN_FIX_APP_QUOTES  permanently false Thu 4/12/2007; discarded code.

Bad idea; *shouldn't* quotify the application name; it doesn't work. Note that
in the apname_and_args string, it *must* be quoted....

FIX_SLASH_QUOTE   conditional removed Thu 4/12/2007 1:12 pm.

Pretty-much irrelevant maybe-bug; like it says, see fixslashquote in sbrs.pas.

WIN_ALWAYS_NIL    permanent flase Thu 4/12/2007 2:24 pm; discarding code.

This worked. Passing CreateProcess(nil, ...) works in XP and w98 (2nd
edition). But it's wrong.

The Winner: WIN_BATCH_NIL   permanently true Thu 4/12/2007 2:26 pm.

My latest variation and finest moment. My theory is like this:

  1. In Win98, you can could a batch file with CreateProcess.

  2. I suspect that Winders 2000 didn't do that.

  3. But the excitement was so great, they put it into XP.

  4. But there's a bug: if *the application name* AND *an argument contains
  spaces* then the batch file execution fails, *UNLESS* I set the
  lpApplicationName to nil.

  In XP. This happens for both .BAT and .CMD files.

So see Microsoft note below for "Windows NT", where they suggest you can set
the lpApplicationName to NULL under certain conditions. So I do it for this. I
was doing it for everything before, but I felt bad.

If anyone is so foolish to try and run OwenShow in Windows 2000 -- well I have
no idea. It's all guessology.

Try setting option execute_nil=0 to see this effect.

CMD.EXE SUX

Fri 10/06/2006 5:02 pm. Well lookee here:

  c:\gregor\OwenShow\CreateProcess>cmd /C "c:\Program Files\OwenShow\altu.bat" "c:\gregor\OwenShow\  chat with spaces"
  'c:\Program' is not recognized as an internal or external command,
  operable program or batch file.

No kidding! I went through the trouble of writing a Builder C++ program before
I noticed this. Certainly explains a lot eh? Here is my TESTQUOTES.BAT:

  :cmd /C "c:\Program Files\OwenShow\altu.bat" "c:\gregor\OwenShow\  chat with spaces"
  :command /C "c:\Program Files\OwenShow\altu.bat" "c:\gregor\OwenShow\  chat with spaces"
  :   that one produces "invalid drive in search path"
  cmd /C "c:\Program Files\OwenShow\altu.bat"
  :   that one works.

Stupid effs -- but then I found this is *known documented* behavior! Is that
cool or what!?!?

But it does sort-of explain why I can execute batch files by leaving the
ApName=nil; because otherwise there would *no* way to do it the recommended
way -- if there were too many quotes 'n' spaces -- which is using cmd.exe....
Another way to put this is Microsoft never finished that long-filename project
they were tinking-with....

  from
  http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dllproc/base/createprocess.asp
  at Fri 10/06/2006 5:37 pm:

  To run a batch file, you must start the command interpreter; set
  lpApplicationName to cmd.exe and set lpCommandLine to the name of the batch
  file.

Which is not true; you have to alter the arguments properly with /C to make
that work  or not as is the case.

----------------------------------------
----------------------------------------

//  apname := quoteoid(apname);
  it will fail with spaces, no quotes. // no that wasn't that problem.
  The problem was the *what* string -- the arguments -- needs the executable
  quoted, to distinguish it from the arguments and who knows what. Which
  should be accomplished by whoever calls MSWINDOWS_exec.

better still, we'll quote the silly thing elsewhere, and *unquote* it here.
//no that's a bad idea because Delphi doesn't like quotes.
//  ApName := unquote(ApName);
so caller has to do it.


----------------------------------------

function CreateProcess(lpApplicationName: PChar; lpCommandLine: PChar;
  lpProcessAttributes, lpThreadAttributes: PSecurityAttributes;
  bInheritHandles: BOOL; dwCreationFlags: DWORD; lpEnvironment: Pointer;
  lpCurrentDirectory: PChar; const lpStartupInfo: TStartupInfo;
  var lpProcessInformation: TProcessInformation): BOOL; stdcall;
[$EXTERNALSYM CreateProcess]

  PProcessInformation = ^TProcessInformation;
  _PROCESS_INFORMATION = record
    hProcess: THandle;
    hThread: THandle;
    dwProcessId: DWORD;
    dwThreadId: DWORD;
  end;
  [$EXTERNALSYM _PROCESS_INFORMATION]
  TProcessInformation = _PROCESS_INFORMATION;
  PROCESS_INFORMATION = _PROCESS_INFORMATION;
  [$EXTERNALSYM PROCESS_INFORMATION]

  PStartupInfo = ^TStartupInfo;
  TStartupInfo = record
    cb: Longint;
    lpReserved: Pointer;
    lpDesktop: Pointer;
    lpTitle: Pointer;
    dwX: Longint;
    dwY: Longint;
    dwXSize: Longint;
    dwYSize: Longint;
    dwXCountChars: Longint;
    dwYCountChars: Longint;
    dwFillAttribute: Longint;
    dwFlags: Longint;
    wShowWindow: Word;
    cbReserved2: Word;
    lpReserved2: ^Byte;
    hStdInput: Integer;
    hStdOutput: Integer;
    hStdError: Integer;
  end;


function WaitForSingleObject(hHandle: THandle; dwMilliseconds: DWORD): DWORD; stdcall;
[$EXTERNALSYM WaitForSingleObject]

when chat is false, it basically means some other part of OS is using this
thing to execute programs, and it should try to be discreet about it. For
instance, in Windows it tries to make the window invisible.

----------------------------------------

Fri 9/01/2006 12:11 pm. This mumbo-mumbo apparently makes it search for the
program through the path. Well let's see what our 1999 SDK help says:

  lpApplicationName

    Pointer to a null-terminated string that specifies the module to execute.

    The string can specify the full path and filename of the module to
    execute.

    The string can specify a partial name. In that case, the function uses the
    current drive and current directory to complete the specification.

    The lpApplicationName parameter can be NULL. In that case, the module name
    must be the first white space-delimited token in the lpCommandLine string.

    The specified module can be a Win32-based application. It can be some
    other type of module (for example, MS-DOS or OS/2) if the appropriate
    subsystem is available on the local computer.

    Windows NT: If the executable module is a 16-bit application,
    lpApplicationName should be NULL, and the string pointed to by
    lpCommandLine should specify the executable module. A 16-bit application
    is one that executes as a VDM or WOW process.

  lpCommandLine

    Pointer to a null-terminated string that specifies the command line to
    execute.

    The lpCommandLine parameter can be NULL. In that case, the function uses
    the string pointed to by lpApplicationName as the command line.

    If both lpApplicationName and lpCommandLine are non-NULL,
    *lpApplicationName specifies the module to execute, and *lpCommandLine
    specifies the command line. The new process can use GetCommandLine to
    retrieve the entire command line. C runtime processes can use the argc and
    argv arguments.

    If lpApplicationName is NULL, the first white space-delimited token of the
    command line specifies the module name. If the filename does not contain
    an extension, .EXE is assumed. If the filename ends in a period (.) with
    no extension, or the filename contains a path, .EXE is not appended. If
    the filename does not contain a directory path, Windows searches for the
    executable file in the following sequence:

    1.  The directory from which the application loaded.

    2.  The current directory for the parent process.

    3.  Windows 95: The Windows system directory. Use the GetSystemDirectory
    function to get the path of this directory.

    Windows NT: The 32-bit Windows system directory. Use the
    GetSystemDirectory function to get the path of this directory. The name of
    this directory is SYSTEM32.

    4.  Windows NT: The 16-bit Windows system directory. There is no Win32
    function that obtains the path of this directory, but it is searched. The
    name of this directory is SYSTEM.

    5.  The Windows directory. Use the GetWindowsDirectory function to get the
    path of this directory.

    6.  The directories that are listed in the PATH environment variable.

    If the process to be created is an MS-DOS - based or Windows-based
    application, lpCommandLine should be a full command line in which the
    first element is the application name. Because this also works well for
    Win32-based applications, it is the most robust way to set lpCommandLine.

If I read carefully through the above, it *does* imply it does a path search
*if* lpApplicationName is blank. Idn't winders wunnerful!?

(from jx comment)

Fri 6/06/03 4:40 pm. I always wondered about this; it seems if I don't name
the application, then when the application inquires about its own name, it
apparently gets the name of *this* program, and proceeds, according to its
logic, to use that address. F'rinstance, when I started OwenShow in a
different directory, until I did the above, it would use the data from the
OwenShow directory I started from, not the different directory. //But then it
turns-out if I specify the lpApplicationName, then CreateProcess won't search
through the path & etc. So logic above uses TheApName *if it exists* --
assuming that we're in the current directory appropriately -- else nil. Or if
not chat -- we're being called by some program process, which definitely
should use full paths -- always use it.


****************************************************************************}

end.

