/****************************************************************************
(hyperget.h.)
These bits go in the INSERT argument, NOT the style argument....
****************************************************************************/
#define WINSERTKEY (0)        /* permit ... */
#define WINSERTNOKEY (128)    /* disable INS key toggle effect. */
#define WWRITEOVER (0)        /* start wgets, wwgets in writover... */
#define WINSERT (1)           /* in insert. */
#define WINOCLR BIT15         /* If NOT set, typing a key before a control key
                              erases current contents of buffer. */
#define CR0OK BIT14           /* if set, pressing a carriage return at 0
                              position in the buffer works ok. I.e., you'd
                              send a default string, and the guy types CR to
                              accept the string. */
/* style bits: */
#define stylNOSPACES BIT0
#define stylONLYN    BIT1   /* only decimal numbers. */
#define stylALPHAN   BIT2   /* only alpha, decimal. */
#define stylSIGN     BIT3   /* == ALPHAN, but let a sign through. */
#define stylARROWS   BIT4   /* if he hits any arrow at the beginning of the
                            buffer, return that.... */
#define stylEXIT     BIT5   /* if he fills the buffer, exit. */
/* style used to be nospaces; now it will break if caller used anything other
than YES==1 for NOSPACES. */

#define BIGINDEX (0x7fff)   /* if *index==, force wwwgets to use string size,
i.e. start @ end of string. Note this restricts size to 32000 or so, ho ho ho.
*/

#define CHECK_CTLA (1)

#if CHECK_CTLA
extern int Gwas_ctla;
#endif


void cmult(int c, int count) ;
int wwwgets(char *b, int n, int upper, int style,
  int *insert, int *index, int achar, int trailcharacter) ;
int wsgets(char *b, int n, int upper, int style) ;
int wugets(char *b, int n, int upper) ;
int wsgetsclr(char *b, int n, int upper, int style) ;
int wugetsclr(char *b, int n, int upper) ;
int wwgets(char *b, int n) ;
int wgets(char *b, int n) ;


#ifdef MSWINDOWS

#define exeunt exit

#define x_putch putch
#define x_getch getch
#define x_puts cputs

#define LNEND "\r\n"

#else

#undef __FLAT__
//#ifndef __FLAT__
  #define __FLAT__ (1)
/* fer gcc. */  
//#endif  

#define LNEND "\n"

typedef unsigned short WORD;

//for kbhit.c functions.
//void   init_keyboard(void);
//void   close_keyboard(void);
int      x_kbhit(void);

int x_putch(int c);

int x_getch(void);

int  x_puts(char *s);

int wherex(void);

int wherey(void);

void gotoxy(int x, int y);

void exeunt(int code);

void termstart(void);

void termstop(void);

void Sleep(int milliseconds);

//int printw(char *fmt, ...);
//a curses def for non includers. Or whatever.

#include <ncurses.h>


#endif

