/*
kbhit.c from
http://www.linux-sxs.org/programming/kbhit.html
severely hacked by me.
*/

//#include "kbhit.h"
#ifndef MSWINDOWS
/********************************************************/

#define KEYPAD (0) 	//didn't seem to work.

#include "hyperx.h"
#include "winkey.h"
#include <termios.h>
#include <unistd.h>   // for read()
//#include <curses.h>

static struct termios initial_settings, new_settings;
static int peek_character = -1;

void init_keyboard()
{
    tcgetattr(0,&initial_settings);
    new_settings = initial_settings;
    new_settings.c_lflag &= ~ICANON;
    new_settings.c_lflag &= ~ECHO;
    new_settings.c_lflag &= ~ISIG;
//i'm adding.
    new_settings.c_iflag &= ~(IXON | IXOFF);  //don't dump ^S^Q.
//    new_settings.c_iflag |= IXANY;

    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VTIME] = 0;
    tcsetattr(0, TCSANOW, &new_settings);
}

void close_keyboard()
{
    tcsetattr(0, TCSANOW, &initial_settings);
}

#if !KEYPAD
int kbhit()
{
unsigned char ch;
int nread;

    if (peek_character != -1) return 1;
    new_settings.c_cc[VMIN]=0;
    tcsetattr(0, TCSANOW, &new_settings);
    nread = read(0,&ch,1);
    new_settings.c_cc[VMIN]=1;
    tcsetattr(0, TCSANOW, &new_settings);
    if(nread == 1)
    {
        peek_character = ch;
        return 1;
    }
    return 0;
}

int readch()
{
char ch;

    if(peek_character != -1)
    {
        ch = peek_character;
        peek_character = -1;
        return ch;
    }
    read(0,&ch,1);
    return ch;
}
#endif
/********************************************************/

void redisplay(void) {
  refresh();
}

int x_putch(int c) {
  addch(c);
}

#if KEYPAD

int kbhit(void) {
  return 0;
}

int x_getch(void) {
  int c;
  refresh();
  switch (c = getch()) {
    case KEY_UP: 	return UPARROW;
    case KEY_DOWN:      return DOWNARROW;
    case KEY_LEFT: 	return LEFTARROW;
    case KEY_RIGHT:	return RIGHTARROW;
    case KEY_IC:	return INS;
    case KEY_DC:	return DEL;
    case 127:           return BS;
  }
  return c;
}

#else

int x_getch(void) {
  int c;
  refresh();
  c = readch();
  if (c==ESC)
  switch (c=readch()) {
    case '[': case 'O':	//my father has many mansions.
    switch (c=readch()) {
//gotta set c so we can see what it is in debugger heaven help us.
      case 'A': return UPARROW;
      case 'B': return DOWNARROW;
      case 'C': return RIGHTARROW;
      case 'D': return LEFTARROW;
      
      case '1': if ((c=readch())=='~') return HOME;
      break;

      case '2': if ((c=readch())=='~') return INS;
      break;

      case '3': if ((c=readch())=='~') return DEL; 
      break;
      
      case '4': if ((c=readch())=='~') return END;
      break;

    }
    break;  //case '[', 'O'.

    case ESC:
    return ESC; //u have to hit esc twice. U could use ^Z.

  }

  switch (c) {
    case 127: return BS;
  }

  return c;
}

#endif

int x_puts(char *s) {
  addstr(s);
  refresh();
}


/* the code in hyperget is general-purpose, but here it's supposed to be a
single-line editor.
*/
int wherex(void) {
  int x,y;
  getyx(stdscr,y,x);
  return x;
}

int wherey(void) {
  int x,y;
  getyx(stdscr,y,x);
  return y;
}

void gotoxy(int x, int y) {
  move(y,x);
  refresh();
}

static int started;

void termstart(void) {
  if (started)
  return;

  started = 1;

#if !KEYPAD
  init_keyboard();
#endif

  initscr();
#if KEYPAD
  keypad(curscr,1);
#endif  
#if !KEYPAD
  raw();
#endif  
  nocrmode();
}

void termstop(void) {

  if (!started)
  return;

  refresh();


  crmode();
#if !KEYPAD
  noraw();
#endif  
#if KEYPAD
  keypad(curscr,0);
#endif  
  endwin();

#if !KEYPAD
  close_keyboard();
#endif  

  started = 0;
}

void exeunt(int code) {
  termstop();
  exit(code);
}

void Sleep(int milliseconds) {
  usleep(milliseconds * 1000);
}

/********************************************************/
#endif
