/*
winkey.h
so kbhitc and hyperget.c can share them.
*/

#define ENTER (13)
#define CR (13)
#define LF (10)
#define CTL (0x40)        /* 'A'-CTL is ^A. */
#define ESC (0x1b)
#define DEL (0x5300)
#define BS (8)

#define F1 (0x3b00)
#define F2 (0x3c00)
#define F3 (0x3d00)
#define F4 (0x3e00)
#define F5 (0x3f00)
#define F6 (0x4000)
#define F7 (0x4100)
#define F8 (0x4200)
#define F9 (0x4300)
#define F10 (0x4400)
#define FSHIFT (0x5400-0x3b00)  /* i.e., add to F to get shift F. */
#define FALT   (0x6800-0x3b00)
#define FCTL   (0x5e00-0x3b00)

#define UPARROW (0x4800)
#define LEFTARROW (0x4b00)
#define RIGHTARROW (0x4d00)
#define DOWNARROW (0x5000)

#define HOME    (0x4700)
#define END     (0x4f00)
#define PGUP    (0x4900)
#define PGDOWN  (0x5100)

#define INS (0x5200)

#define CTLHOME (0x7700)
#define CTLPGUP (0x8400)
#define CTLPGDOWN (0x7600)


